Tue Feb 28 16:36:58 1995  Michael Meissner  <meissner@cygnus.com>

	* rs6000/eabi.asm (__eabi): Correctly reload r30 in the case where
	the GOT pointers have to be relocated.

	* rs6000/rs6000.md (floatsidf2, floatunssidf2): Add
	TARGET_SOFT_FLOAT conditional dropped in the last change.
	(movdf insns): Add -msoft-float varients that do not use 'f' register
	constraints.
	(movti): On PowerPC, don't clobber the MQ register, since it doesn't
	exist.  Add abort to default switch case.
	(store_multiple, load_multiple): Test for TARGET_POWER instead
	of !TARGET_POWERPC to determine whether the MQ register exists.

Tue Feb 28 14:46:48 1995  Doug Evans  <dje@cygnus.com>

	* configure (extra_headers): Renamed from header_files.

	* toplev.c (rest_of_compilation): Defer output of static inlines
	even if not optimizing, they may never be referenced.

Mon Feb 27 17:06:47 1995  Doug Evans  <dje@cygnus.com>

	* cccp.c (do_include): Check for redundant file before opening in
	relative path case.  Don't call fstat unnecessarily.

Mon Feb 27 11:20:29 1995  Jim Wilson  <wilson@chestnut.cygnus.com>

	* mips.md (muldi3_internal): Change dmul to dmult.

Mon Feb 27 02:30:54 1995  Jeffrey A. Law  <law@mole.gnu.ai.mit.edu>

	* pa.c (hppa_expand_prologue): Don't save the PIC register into
	the stack for functions which have no stack of their own.

Mon Feb 27 00:43:32 1995  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* config/gnu.h (ASM_SPEC): Macro removed.

Sun Feb 26 20:21:52 1995  Doug Evans  <dje@cygnus.com>

	* reload.c (find_reloads_address): Fix typo in reg+const case.

Sat Feb 25 10:21:13 1995  Doug Evans  <dje@cygnus.com>

	* gcc.c (print_search_dirs): New variable.
	(build_search_list): New function.
	(putenv_from_prefixes): Call it.
	(option_map): New option --print-search-dirs.
	(process_command): Handle it.
	(main): Print installation directory and exec/startfile_prefixes if
	--print-search-dirs given.

	* Makefile.in (Makefile): Delete config.run afterwards.
	(distclean): Delete config.run.

Sat Feb 25 08:36:40 1995  David Mosberger-Tang  (davidm@cs.arizona.edu)

	* alpha.h (ASM_SPEC): Pass -pg to assembler.
	(FUNCTION_PROFILER): Do nothing; the assembler does it for us.

Sat Feb 25 08:24:27 1995  H.J. Lu   (hjl@nynexst.com)

	* configure (native_prefix): New; lets some hosts put
	files in /usr instead of /usr/local if no --prefix specified.

Sat Feb 25 08:07:56 1995  David Edelsohn  <edelsohn@mhpcc.edu>

	* rs6000.h (RTX_COSTS): Add cost of FFS.

Sat Feb 25 06:52:22 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* mips.c (mips_fill_delay_slot): Fix typo in call to FP_REG_P.

	* cse.c (simplify_unary_operation): If operand mode is VOIDmode
	for UNSIGNED_FLOAT and operand looks negative, can't simplify.

	* rs6000.c (low_32_bit_operand): New function.
	* rs6000.h (PREDICATE_CODES): Add low_32_bit_operand.
	* rs6000.md: Remove unneeded tests on HOST_BITS_PER_INT from 
	some extra conditions.
	Use low_32_bit_operand for (plus:DI (zero_extend:DI ..) ..) cases.

Sat Feb 25 00:49:29 1995  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* config/xm-gnu.h (POSIX): Define this macro.

	* config/gnu.h (GNU_CPP_PREDEFINES): Add missing backslash.

Fri Feb 24 19:17:29 1995  Jeffrey A. Law  <law@snake.cs.utah.edu>

	* configure (hppa1.?-hp-hpux9*): Use hpux9 configuration files.
	* pa-hpux9.h, pa-ghpux9.h, pa1-hpux9.h, pa1-ghpux9.h: New
	configuration files.

Fri Feb 24 15:55:33 1995  Jim Wilson  <wilson@cygnus.com>

	* reorg.c (relax_delay_slots): When searching for next CODE_LABEL,
	use next_real_insn not next_active_insn.

	* stdarg.h, va-*.h, varargs.h (va_end): Expand to a void expression
	instead of nothing.

	* sh.h (PACKSTRUCT_BIT, TARGET_PACKSTRUCT): Change to PADSTRUCT.
	Add comment saying that the option is not useful.
	(TARGET_SWITCHES): Change -mpackstruct option to -mpadstruct.
	(STRUCTURE_SIZE_BOUNDARY): Change PACKSTRUCT to PADSTRUCT changing
	default value from 32 to 8.

	* dwarfout.c (PUSHSECTION_FORMAT): Add a leading tab.

	* expr.c (expand_expr, case COMPONENT_REF): Don't fetch unaligned
	field if we only want its address.

	* i960.c (fp_literal_one, fp_literal_zero): Don't accept VOIDmode.
	(i960_output_ldconst): In DFmode code, delete code to handle FP_REG_P
	target.  In DFmode and SFmode code, delete test for HOST_FLOAT_FORMAT
	== TARGET_FLOAT_FORMAT.
	* i960.h (REAL_ARITHMETIC): Define.
	(LEGITIMATE_CONSTANT_P): Pass argument mode not VOIDmode to fp_literal.

	* i960.h (CC1_SPEC): Don't output implicit -gstabs or -gcoff option
	if user gave an explicit one.
	* vx960-coff.h (CC1_SPEC): Likewise.

	* dbxout.c (GDB_INV_REF_REGPARM_STABS_LETTER): New macro.
	(dbxout_parms): For gdb, output use GDB_INV_REF_REGPARM_STABS_LETTER
	for parameters passed by invisible reference in registers.

	* mips.c (mips_secondary_reload_class): Also handle SUBREGs.
	* mips.md (madsi): Don't use '+' constraint in a clobber.
	(madsi_highpart, umadsi_highpart): Delete.

	* dbxout.c (dbxout_parms): For parameters passed in memory, delete
	obsolete code to handle parameters converted and stored back to
	the stack slot where they were passed in.
	(dbxout_reg_parms): Delete obsolete ifdefed out code.  Combine
	redundant PARM_PASSED_IN_MEMORY tests.  For case where parameter
	lives in memory, output stab if it doesn't live where it was passed.

	* sh.c: Correct typos and formatting problems.
	(add_constant, current_function_pretend_args_size,
	flag_traditional, table_lab): Delete unnecessary declarations.
	(sh_cpu): Change type from attr_cpu to processor_type.	
	(need_slot, output_shift, lshiftrt_insns, howshift,
	pop_operand): Delete.
	(print_operand, output_branch): Delete calls to need_slot.
	(synth_constant): Comment that it doesn't work.
	(output_movedouble): Handle PRE_DEC dest not POST_INC dest.
	(output_options): Don't use flag_traditional.
	(shift_insns): Correct numbers to optimal sequences.
	(shift_amounts): New table.
	(shift_insns_rtx): New function.
	(shiftinsns): Combine LSHIFTRT and ASHIFT cases.
	(shiftcosts): Return true costs of shifts instead of estimate of 1.
	(gen_ashift): Handle negative shift amounts.  Call gen_lshrsi3_m
	for single bit LSHIFTRT, and gen_lshrisi3_k for multiple bit shifts.
	(gen_shifty_op): Handle negative shift amounts at top.  Generate
	optimal sequences for ASHIFT and LSHIFTRT.
	(find_barrier): Correct pattern for matching mova instructions.
	(general_movsrc_operand): Delete redundant test for (MEM LABEL_REF).
	Don't reject POST_INC address for size > 4.
	(general_movdst_operand): Don't reject PRE_DEC address for size > 4.
	* sh.h: Correct typos and formatting problems.
	(MODE_DISP_OK_[12]): Delete.
	(GO_IF_LEGITIMATE_INDEX): Delete uses of MODE_DISP_OK_[12].
	(RTX_COSTS): Add LSHIFTRT.
	(table_lab): Delete declaration.
	(enum processor_type): New enum.
	(sh_cpu_attr): New macro.
	(sh_cpu): Change type to enum processor_type to avoid incomplete
	enum type.
	* sh.md: Correct typos and formatting problems.
	(cpu): Use sh_cpu_attr not sh_cpu.
	(adddi3, subdi3, udivsi3-1, divsi3-1, mulsi3_call-1, ashrsi2_16,
	ashrsi2_31, dect, casesi_worker): Use arith_reg_operand not
	register_operand.
	(ashlsi3_n, lshrsi3_n): Enable pattern.  Set length correctly.
	Use '#' to output it.
	(ashlsi3_n+1, lshrsi3_n+1): New patterns to split shifts.
	(ashlsi3, lshrsi3): Use shiftby_operand instead of gen_shifty_op.
	(lshlsi3_m): New pattern for single bit shifts.
	(lshlsi3_k): Only handle multiple bit shifts.	
	(negc): Use IOR not PLUS to set carry bit.
	(push+2, pop+2, movsi_pi, movdi-2, movdf_k-1, movsf_i-1): Delete.
	(movsi_i, movqi_i, movhi_i): Delete redundant < and > constraints.
	(movsf_i): Delete incorrect < and > constraints.

Fri Feb 24 13:07:55 1995  Stephen L Moshier  <moshier@world.std.com>

	* i386/i386.md (sinxf2, cosxf2): Define.

Thu Feb 23 14:14:20 1995  Mike Stump  <mrs@cygnus.com>

	* rs6000.h/rs6000.h (RETURN_ADDR_RTX): Add definition to support
	__builtin_return_address and __builtin_frame_address on the
	rs6000.  This is necessary to support exception handling in g++ on
	the rs6000. 

Thu Feb 23 15:23:26 1995  Michael Meissner  <meissner@cygnus.com>

	* rs6000/rs6000.h (TARGET_SWITCHES): All -mpower switches set
	-mmultiple by default.  Rename -mno-fp-regs to -msoft-float and
	-mfp-regs to -mhard-float.
	(TARGET_NO_FPR): Rename all occurances of macro to be either
	TARGET_HARD_FLOAT or TARGET_SOFT_FLOAT.
	(FUNCTION_VALUE): If -msoft-float, floating point gets returned in
	register 3.
	(LIBCALL_VALUE): Ditto.
	(USE_FP_FOR_ARG_P): Don't use floating point registers if
	-msoft-float.
	(MOVE_MAX): Use TARGET_MUTIPLE instead of TARGET_POWER to decide
	to move 16 bytes at a time.
	(GO_IF_LEGITIMATE_ADDRESS): Don't allow index + base register
	addresses for DF's if -msoft-float.

	* rs6000/rs6000.c (POWER_MASKS): Or in MASK_MULTIPLE.
	(processor_target_table): Set MASK_MULTIPLE for Power CPUs and
	don't set it for PowerPC CPUs.
	(output_prolog): If -mrelocatable and a GOT pool is used, mark the link
	register as being live.  Load the GOT address via a bl instruction.
	(output_toc): If V.4 semantics, make the TOC label be the difference
	from the start of the TOC section, rather a label the assembler has to
	recognize as being an offset.

	* rs6000/rs6000.md (all floating point ops): For all operations,
	check if floating point is allowed.
	(movti): Use TARGET_MULTIPLE to decide whether to expand movti
	instead of TARGET_POWER.

	* rs6000/sysv4.h (SUBTARGET_SWITCHES): Move here from eabi.h, so the
	various macro overrides don't have to be recoded for eabi as well
	as System V.4.  Add -mstrict-align to set STRICT_ALIGNMENT to 1.
	Add -mrelocatable to specify that that the data/text sections may
	be copied elsewhere, but not true V.4 style PIC.
	(TOC_SECTION_FUNCTION): Handle TARGET_RELOCATABLE.
	(TOC_SECTION_ASM_OP): Put quotes around ".got".
	(MINIMAL_TOC_SECTION_ASM_OP): Put quotes around ".got1".

	* rs6000/eabi.h (SUBTARGET_SWITCHES): Move to rs6000/sysv4.h.
	(MINIMAL_TOC_SECTION_ASM_OP): Use ".got2" section if
	-mrelocatable.

	* rs6000/eabi.asm: New file to load up register 2 or relocate the .got2
	addresses.  Called from main.

	* rs6000/t-rs6000: Build two libgcc.a's, one for normal use, and one
	used when compiling with -msoft-float.

	* rs6000/t-eabi: New file, build two libgcc.a's, one for normal use,
	and one used when compiling with -msoft-float.  Add support for eabi
	module to relocate the .GOT2 section to support -mmultiple.

	* configure (powerpc-*-eabi*): Use t-eabi, not t-rs6000.

Thu Feb 23 06:58:46 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* Makefile.in (ld): Add missing backslash to make continuation line.

	* i386/winnt.c (gen_stdcall_suffix): Deleted.
	* winnt/winnt.h (MODIFY_ASSEMBLER_NAME): Deleted.
	(VALID_MACHINE_DECL_ATTRIBUTES): Deleted.
	* varasm.c (make_decl_rtl): Remove reference to MODIFY_ASSEMBLER_NAME.

	* alpha.h (RTX_COSTS): Update costs for FP operations.

Thu Feb 23 00:13:05 1995  Jason Merrill  <jason@phydeaux.cygnus.com>

        * c-typeck.c (build_binary_op): Warn if, in a comparison, a signed
        operand that might be negative is converted to unsigned.

Wed Feb 22 21:32:48 1995  Peter Schauer  (Peter.Schauer@regent.e-technik.tu-muenchen.de)

	* config/svr4.h (DBX_OUTPUT_MAIN_SOURCE_FILE_END): New macro.

Wed Feb 22 20:29:31 1995  J.T. Conklin  <jtc@netbsd.org>

	* configure (*-*-netbsd*): Set tmake_file to t-libc-ok.

	* config/xm-netbsd.h, i386/xm-netbsd.h, m68k/xm-netbsd.h: New files.
	* sparc/xm-netbsd.h: New file.
	* ns32k/xm-netbsd.h: Changed to use config/xm-netbsd.h and
	ns32k/xm-ns32k.h.
	* configure (i386-*-netbsd*): Use i386/xm-netbsd.h.
	(m68k-*-netbsd*): Use m68k/xm-netbsd.h.
	(sparc-*-netbsd*): Use sparc/xm-netbsd.h.

	* cppp.c, collect2.c: Removed __NetBSD__ from conditional.
	* collect2.c: Declare strerror if HAVE_STRERROR is defined;
	otherwise declare sys_errlist and sys_nerr.

Wed Feb 22 19:07:08 1995  Niklas Hallqvist  (niklas@appli.se)

	* Makefile.in (libgcc1.a): Run ranlib.

Wed Feb 22 18:46:50 1995  Yury Shevchuk  (sizif@botik.yaroslavl.su)

	* explow.c (memory_address): Add missing "else".

Wed Feb 22 15:29:58 1995  Jason Merrill  <jason@phydeaux.cygnus.com>

        * collect2.c (libselect): New function for passing to scandir.
        (libcompare): Ditto.
        (locatelib): Use scandir to look for libraries with matching version
        numbers.

Wed Feb 22 18:27:14 1995  Paul Eggert  <eggert@twinsun.com>

	* cccp.c (enum sharp_token_type): New type.
	(stringify, raw_before, raw_after): Use this type instead of char.
	(collect_expansion, dump_single_macro): Keep track of white space
	after # and around ## tokens, since the C Standard requires a
	diagnostic if the white space doesn't match during a redefinition.
	(sharp_token, sharp_sharp_token): Labels renamed from hash_token and
	hash_hash_token for naming consistency.

Wed Feb 22 17:37:12 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* gcc.c (SWITCH_TAKES_ARG): Add `x'.
	(process_command): -Wl, -Xlinker, and -lm values always go to
	linker even if -x was specified.

Wed Feb 22 09:33:36 1995  Jason Merrill  <jason@phydeaux.cygnus.com>
     
        * fold-const.c (fold): Support folding CLEANUP_POINT_EXPRs into
        arithmetic expressions.

Wed Feb 22 08:40:30 1995  David Edelsohn  <edelsohn@mhpcc.edu>

	* rs6000.c (print_operand, case 'H', 'S'): Delete unused.

	* rs6000.md (ffssi2): Use gpc_reg_operand predicate.
	(Some maskir patterns): Likewise.
	(ffsdi2): Likewise.

	* rs6000.md (movsfcc, movdfcc): New standard patterns.
	(fselsfsf4, fseldfsf4, fseldfdf4, fselsfdf4): Name and create
	variants of existing anonymous patterns for movsfcc and movdfcc.
	
Wed Feb 22 08:10:36 1995  Philippe De Muyter (phdm@info.ucl.ac.be)

	* final.c (output_asm_name): New function, using code taken
	from output_asm_insn.
	(output_asm_insn): If flag_print_asm_name, print the comment
	after the first assembler instruction even in multi-instruction
	templates.

Wed Feb 22 07:04:25 1995  Ian Lance Taylor  (ian@cygnus.com)

	* real.c (REAL_WORDS_BIG_ENDIAN): New macro.  Define as either
	FLOAT_WORDS_BIG_ENDIAN or HOST_FLOAT_WORDS_BIG_ENDIAN.  Use it
	instead of FLOAT_WORDS_BIG_ENDIAN. 

Wed Feb 22 07:03:39 1995  Stephen L Moshier  (moshier@world.std.com)

	* final.c (split_double): Handle CONST_INT that holds both words.
	* i386.c (output_move_double): Let split_double extract any
	constant in op 1; take size from op 0.

	* real.c (m16m, edivm, emulm): Change `short' to `EMUSHORT', and `long'
	to `EMULONG'.
	Clean up comments.

Wed Feb 22 00:52:40 1995  Jeffrey A. Law  <law@mole.gnu.ai.mit.edu>

	* pa.h (ASM_DECLARE_FUNCTION_NAME): Handle invisible reference
	arguments passed in registers.

Tue Feb 21 19:03:09 1995  Douglas Rupp  (drupp@cs.washington.edu)

	* Makefile.in ($exeext, $objext, $oldobjext): New macros.
	* Makefile.in: Copy config.status to config.run and then execute.
	* configure, Makefile.in: Try a "cp" if "ln" fails.
	* objc/Makefile: Added {} around file variable.

	* c-parse.in: New rules to allow attributes in a prefix position.
	* c-tree.h (decl_attributes): Added argument.
	* c-decl.c (grokdeclarator): Added code to support machine attributes.
	* c-common.c (decl_attributes): Add third argument prefix_attributes.
	(valid_machine_attribute): Deleted; moved to tree.c.
	* tree.h (union tree_decl): New field MACHINE_ATTRIBUTES.
	(DECL_MACHINE_ATTRIBUTES): New macro.
	* c-decl.c (duplicate_decls): Pass DECL_MACHINE_ATTRIBUTES to
	descendent typedef; make duplicate typedefs that are identical 
	generate a warning if they are both in system header files.  
	(redeclaration_error_message): Make duplicate typedefs that 
	are identical not an error if they are both in system header files.  
	* print-tree.c (print_node{,_brief}): Print machine attributes.

	* calls.c (emit_call_1): Added function declaration node argument
	passed to RETURN_POPS_ARGS; also effects calls to emit_call_1.
	* function.c (assign_parms): Added arg to RETURN_POPS_ARGS.
	* 1750a.h, a29k.h, alpha.h, arm.h, clipper.h, convex.h: Likewise.
	* dsp16xx.h, elxsi.h, fx80.h, gmicro.h, h8300.h, i370/mvs.h: Likewise.
	* i386.h, i386/isc.h, i386/next.h, i386/sco.h: Likewise.
	* i386/scodbx.h, i860.h, i960.h, m68k.h, m88k.h, mips.h: Likewise.
	* ns32k.h, pa.h, pdp11.h, pyr.h, romp.h, rs6000.h, sh.h: Likewise.
	* sparc.h, spur.h, tahoe.h, vax.h, we32k.h: Likewise.

	* cccp.c (main): Don't set "Include" environment variable for NT.
	* protoize.c: Added #ifdef's WINNT.
	* toplev.c (get_run_time): Return an approximate value for NT.
	* gbl-ctors.h, libgcc2.c (atexit): Prototype now works with NT.
	* gcc.c (fix_argv): Rewrite.

	* i386/winnt.c: New file
	* winnt/ld.c (expand_lib): Look for both libfoo.a and foo.lib.
	Modified to support linking with Windows NT graphics libraries. 
	* i386/winnt.h, x-winnt: Support NT Graphics programs; also bug fixes.
	* winnt/winnt.h (CPP_SPEC): Accept c++ style comments.
	* winnt/xm-winnt.h: Reflect features/functions available in NT.

	* fixinc.winnt: New file.
	* configure (i[345]86-*-winnt): Add fixincludes and extra_objs.
	* config-nt.bat: Deleted.
	* configure.bat: Take arg specifying msdos or winnt batch file config.
	* i386/config-nt.{bat,sed}: Updated to Windows NT 3.5.

	* ginclude/stdarg.h, ginclude/varasgs.h: Test _VA_LIST_DEFINED macro.
	* ginclude/stddef.h: Test _SIZE_T_DEFINED and _WCHAR_T_DEFINED.
	* ginclude/varargs.h: Modifed to work with Windows NT.  Needed a 
	_VA_LIST_DEFINED macro.

	* tree.c: (chain_member_value, decl_attribute_variant): New functions.
	(valid_machine_attribute): Moved here from c-common.c.

	* varasm.c (make_decl_rtl): Call MODIFY_ASSEMBLER_NAME if defined.

Tue Feb 21 12:40:05 1995  Jeffrey A. Law  <law@snake.cs.utah.edu>

	* local-alloc.c (block_alloc): Stop looping over the input
	operands once we find an input/output register pair which can
	be combined into a single qty.

	* integrate.c (finish_inline): Don't set DECL_INLINE.

Tue Feb 21 10:19:51 1995  Michael Meissner  <meissner@cygnus.com>

	* toplev.c (lang_options): Move fortran switches here, fixing bad
	patch.

Tue Feb 21 07:30:11 1995  Stephen L Moshier  (moshier@world.std.com)

	* rs6000.c (output_toc): Use REAL_VALUE_* macros.
	* rs6000.h (REAL_ARITHMETIC): Define.

Tue Feb 21 06:48:41 1995  Stephen R. van den Berg  (berg@pool.informatik.rwth-aachen.de)

	* stmt.c (expand_value_return): Make function static.

Tue Feb 21 06:42:33 1995  Paul Eggert  <eggert@twinsun.com>

	Add support for ISO Normative Addendum 1 to the C Standard.
	* ginclude/iso646.h: New file.
	* Makefile.in (USER_H): Add iso646.h.
	* c-lex.c (yylex): Add support for <: :> <% %> digraphs.
	* cccp.c (rescan): Add support for %: and %:%: digraphs.
	(collect_expansion, skip_if_group, dump_single_macro): Likewise.
	(union hashval): Remove ival member; it doesn't suffice for `199409L'.
	(special_symbol): Use cpval instead of ival for T_CONST macros.
	(install): Remove ivalue argument, since string value now suffices.
	All callers changed.
	(initialize_builtins): Switch from int to string values for T_CONST.
	If not traditional, initialize __STDC_VERSION__ to 199409L.
	(STDC_VALUE): Remove no-longer-used configuration macro.

Tue Feb 21 06:16:37 1995  Franz Korntner  (fkorntne@bazis.nl)

	* gcc.c (read_specs): Use length read when inserting zero.

	* c-lex.c (yylex): For float, build constant in long double.

Tue Feb 21 05:57:42 1995  Craig Burley  (burley@gnu.ai.mit.edu)

	* toplev.c (lang_options): Add options for Fortran.

	* gcc.c (default_compilers): Add entries for .f and .F.

Tue Feb 21 05:37:21 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* gcc.c (default_compilers): Remove rule for ".ada".
	Pass .ads or .adb suffix to -dumpbase, depending on input filename.

	* toplev.c (compile_file): Initialize input_file_stack before
	calling lang_init, not after.
	* c-lex.c (check_newline): Give warning if unrecognized data on #line.
	(yylex): Give error for unterminated string constant.

Mon Feb 20 14:46:56 1995  Per Bothner  <bothner@kalessin.cygnus.com>

	* varasm.c (output_constant):  Strip NOP_EXPRs for SET_TYPE too,
	by using AGGREGATE_TYPE_P macro.

Mon Feb 20 14:39:57 1995  Per Bothner  <bothner@kalessin.cygnus.com>

	* config/svr4.h (ASM_OUTPUT_SOURCE_LINE):  Use assemble_name.

Mon Feb 20 15:26:05 1995  Doug Evans  <dje@cygnus.com>

	* config.sub (sun4sol2): Alias for sparc-sun-solaris2.

Sat Feb 18 16:15:33 1995  Mike Stump  <mrs@cygnus.com>

	* libgcc2.c (__unwind_function): New function to support stack
	unwinding on rs6000 for g++ exception handling.

Sat Feb 18 13:55:02 1995  Per Bothner  <bothner@kalessin.cygnus.com>

	* tree.h (get_set_constructor_bytes): Fix prototype.
	* varasm.c (output_constructor): Fix typo byte_size -> size.

Sat Feb 18 12:36:12 1995  Doug Evans  <dje@cygnus.com>

	Lynx patches from various Cygnus people.
	* config.sub: Recognize lynx* as lynxos.
	* configure (i386-lynx): Set xm_file to i386/xm-lynx.h
	Set tmake_file to i386/t-i386bare.
	(m68k-lynx): Set xm_file to m68k/xm-lynx.h.
	Set tmake_file to m68k/t-lynx.
	(rs6000-lynxos*): New target.
	(sparc-lynxos*): Set xm_file to sparc/xm-lynx.h.
	Set tmake_file to sparc/t-sunos41.
	* config/lynx.h (LIB_SPEC, STARTFILE_SPEC): Update to LynxOS 2.2.2.
	(FUNCTION_PROFILE): Undef.
	* config/xm-lynx.h (HOST_BITS_PER_CHAR): Delete.
	(HOST_BITS_PER_{SHORT,INT,LONG,LONGLONG}): Likewise.
	(mktemp): Provide our own, lynx's definition isn't standard.
	* i386/t-i386bare (LIBGCC1): Define to empty instead of libgcc1.null.
	(CROSS_LIBGCC1): Likewise.
	* i386/xm-lynx.h: New file.
	* m68k/lynx.h (FUNCTION_VALUE): Redefine.
	(LIBCALL_VALUE, FUNCTION_VALUE_REGNO_P, NEEDS_UNTYPED_CALL): Likewise.
	* m68k/t-lynx: New file.
	* m68k/xm-lynx.h: New file.
	* rs6000/lynx.h: New file.
	* rs6000/rs6000.h (SUBTARGET_OVERRIDE_OPTIONS): Define.
	(OVERRIDE_OPTIONS): Call it.
	* rs6000/x-lynx: New file.
	* rs6000/xm-lynx.h: New file.
	* sparc/xm-lynx.h: New file.

Thu Feb 16 17:02:51 1995  Ian Lance Taylor  <ian@cygnus.com>

	* config/mips/mips.h (enum processor_type): Add PROCESSOR_R4650.
	* config/mips/mips.c (override_options): Use PROCESSOR_R4650 for
	the 4650, not PROCESSOR_R4600.  Check for it when doublechecking
	mips_isa level.
	* config/mips/mips.md: Add r4650 to cpu attr.  Update functional
	units for r4650.
	(mulsi3): If TARGET_MAD, generate mulsi3_r4650.
	(mulsi3_r4650): New instruction, mul directly to register file,
	supported on r4650.

Thu Feb 16 11:44:51 1995  Michael Meissner  <meissner@cygnus.com>

	* rs6000/eabi.h (SUBTARGET_SWITCHES): Add support for
	-mstrict-align to control whether STRICT_ALIGNMENT is 1 or 0.
	(STRICT_ALIGNMENT): Redefine, to be 1 if -mstrict-align used.

Wed Feb 15 13:03:38 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* libgcc2.c: Repair botch in application of patch.

Tue Feb 14 16:00:52 1995  Per Bothner  <bothner@kalessin.cygnus.com>

	* tree.c (get_set_constructor_bytes):  New function.  Replaces ...
	(get_set_constructor_words):  ... removed old function.
	* tree.h: get_set_constructor_words -> get_set_constructor_bytes.
	* expr.c (store_constructor):  Don't use get_set_constructor_words.
	* varasm.c (const_hash):  Add support for SET_TYPE constructors.
	(record_constant_1):  Likewise.
	(copy_constant):  Likewise.
	(output_constant):  Likewise.  (Also SET_TYPE INTEGER_CSTs.)

Tue Feb 14 08:05:07 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* tree.c (stabilize_reference_1): No longer static.
	* tree.h (stabilize_reference_1): Add declaration.

Mon Feb 13 19:37:15 1995  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* config/mips/gnu.h: Rewritten to use ELF object format.
	* config/gnu.h (GNU_CPP_PREDEFINES): New macro.
	* config/i386/gnu.h (CPP_PREDEFINES): Use GNU_CPP_PREDEFINES macro.
	* config/i386/gnuelf.h: Likewise.

Mon Feb 13 14:06:04 1995  Jason Merrill  <jason@phydeaux.cygnus.com>

        * libgcc2.c (__default_new_handler): Don't call write if
        inhibit_libc is defined.
        (__pure_virtual): Ditto.

Mon Feb 13 16:42:38 1995  Doug Evans  <dje@cygnus.com>

	* a29k/a29k-udi.h (DBX_DEBUGGING_INFO): Define.
	(PREFERRED_DEBUGGING_TYPE): Define.

	* expmed.c (store_split_bit_field): If value is VOIDmode,
	pass word_mode to force_reg.

	* varasm.c (function_section): New function.
	(assemble_start_function): Call it.
	* output.h (function_section): Declare it.
	* final.c (final_scan_insn): Call function_section instead of
	text_section.
	* dwarfout.c (dwarfout_begin_block): Likewise.
	(dwarfout_end_block): Likewise.
	(dwarfout_label): Likewise.
	(dwarfout_begin_function): Likewise.
	(dwarfout_end_function): Likewise.
	(dwarfout_line): Likewise.

	* flow.c (find_basic_blocks): Revise calculation of when to
	make another pass.

	* libgcc2.c (exit): Don't call __do_global_dtors if
	INIT_SECTION_ASM_OP and OBJECT_FORMAT_ELF.

	* Makefile.in (libgcc1.S): New target.

Mon Feb 13 12:45:11 1995  Per Bothner  <bothner@kalessin.cygnus.com>

	* tree.c (permanent_allocation):  Pop function_maybepermanent_obstack,
	not hardwired &maybepermanent_obstack.

Mon Feb 13 12:10:31 1995  J.T. Conklin  <jtc@netbsd.org>

	* config/netbsd.h: Changed so that macro definitions used when gcc
	is integrated into the NetBSD source tree are not defined unless
	NETBSD_NATIVE is defined too.

	* configure (*-netbsd-*): Rename netbsd config files so that they don't
	have the machine type in them.
	* i386/netbsd.h: Renamed from i386/netbsd-i386.h.
	* m68k/netbsd.h: Renamed from m68k/netbsd-m68k.h.
	* ns32k/netbsd.h: Renamed from ns32k/netbsd32k.h.

Mon Feb 13 15:05:09 1995  Jason Merrill  <jason@phydeaux.cygnus.com>

        * collect2.c (main): Remember all the .o files specified on the
        command line, and scan them directly if COLLECT_SCAN_OBJECTS.
        * rs6000/rs6000.h (COLLECT_SCAN_OBJECTS): Define.

        * stmt.c (warn_if_unused_value): Don't warn about dereferenced
        references.

Mon Feb 13 14:00:51 1995  Jim Wilson  <wilson@mole.gnu.ai.mit.edu>

	* m68k.h (RTX_COSTS): Fix typo from last change.

	* reload1.c (last_spill_reg): Move definition to top of file.
	Don't initialize here.  
	(reload): Intialize here to -1.

Mon Feb 13 09:29:49 1995  Paul Eggert  <eggert@twinsun.com>

	* fixinc.svr4 (longlong_t, u_longlong_t):
	Work around bug in Solaris 2.4 <sys/types.h>.

Mon Feb 13 08:31:18 1995  David Edelsohn  <edelsohn@mhpcc.edu>

	* rs6000.h, powerpc.h (CPP_SPEC): Define _POSIX_SOURCE if -posix.

	* rs6000.md (extendsfdf2): Undo 30 Nov 94 change.  Use float_extend
	instead of SUBREG and restore fmr instruction for differing FPRs.

Mon Feb 13 05:25:09 1995  Jason Merrill  <jason@phydeaux.cygnus.com>

        * convert.c (convert_to_{pointer,real,integer,complex}):
	Handle references.

Mon Feb 13 08:14:10 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* c-parse.in (ALIGN): Remove unused token.

	* loop.c (mark_loop_jump): Remove bogus assignments to LABEL_
	fields in default case.

Mon Feb 13 07:55:30 1995  Torbjorn Granlund  (tege@tiny.cygnus.com)

	* a29k.h (TARGET_MULTM): New #define.
	(TARGET_SWITCHES): Recognize "-mno-multm".
	* a29k.md (smulsi3_highpart, umulsi3_highpart, mulsidi3, umulsidi3):
	Make these conditional on TARGET_MULTM.

	* a29k.md (multm matcher): Delete.
	(multmu matcher): Delete.
	(mulsidi3 DEFINE_SPLIT): Generate RTL for smulsi3_highpart instead of
	for deleted pattern.  Fix typo in preparation code.
	(umulsidi3 DEFINE_SPLIT): Analogous change.

Mon Feb 13 07:09:02 1995  Peter Flass  (FLASS@LBDRSCS.BITNET)

	* i370/mvs.h (ASM_OUTPUT_ASCII): Don't duplicate first char.

Mon Feb 13 06:51:07 1995  Samuel A. Figueroa  (figueroa@CS.NYU.EDU)

	* i386/os2.h (OBJECT_SUFFIX): New macro.
	(LIB_SPEC, STARTFILE_SPEC): Adjust to include better set of libs.

	* i386/xm-os2.h (DIR_SEPARATOR): Define if not already.
	(strcasecmp): New definition.

	* toplev.c (main): Look at DIR_SEPARATOR for finding last component.
	* cccp.c (do_include, is_system_include, open_include_file):
	Handle DIR_SEPARATOR.

Sun Feb 12 20:20:28 1995  Brendan Kehoe  (brendan@lisa.cygnus.com)

        * config/sparc/sysv4.h (ASM_OUTPUT_SECTION_NAME): Check to make
        sure DECL is non-null before trying to reference it.
        * config/mips/elf64.h (ASM_OUTPUT_SECTION_NAME): Likewise.

Sun Feb 12 19:55:45 1995  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* calls.c (expand_call): Add missing paren in last change.

Sat Feb 11 18:09:27 1995  Jim Wilson  <wilson@cygnus.com>

	* libgcc2.c (L_fixunsxfsi, L_fixunsdfsi, L_fixunssfsi): Undef
	normal types before including limits.h.

	* calls.c (expand_call): When setting n_named_args, depend on new
	macro STRICT_ARGUMENT_NAMING.

	* expr.c (expand_builtin, case BUILT_IN_NEXT_ARG): Don't warn when
	no argument if this is a varargs routine.

Sat Feb 11 16:08:13 1995  Samuel A. Figueroa  (figueroa@CS.NYU.EDU)

	* gcc.c (specs): Use %O instead of "o" for object file suffix.
	(do_spec_1, case 'O'): New option.

Sat Feb 11 14:58:19 1995  Philippe De Muyter (phdm@info.ucl.ac.be)

	* m68k/mot3300.h (RETURN_IN_MEMORY): Fix error in last change.

Sat Feb 11 13:09:28 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* cexp.y (%union): Delete VOIDVAL and SVAL; unused.

	* c-decl.c (grokdeclarator): Use NAME, not IDENTIFIER_POINTER
	of DECLARATOR for error messages; DECLARATOR might be null.

	* expmed.c (expand_divmod): Always call expand_twoval_binop with
	psuedos as targets.

Fri Feb 10 14:55:05 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* caller-save.c: Replace MAX_UNITS_PER_WORD with MIN_UNITS_PER_WORD.
	* h8300.h, mips.h, rs6000.h, sparc.h: Likewise.

	* alpha.c (direct_return): Can't if have outgoing args.

	* expr.c (store_constructor, ARRAY_TYPE): Use code for
	non-integer INDEX for non-integer ELTTYPE size.
	Allow INDEX to be zero in code and divide size by BITS_PER_UNIT.

	* fold-const.c (fold): Don't modify tree with newly-allocated
	nodes; instead make new tree in those cases.

Wed Feb  8 15:13:49 1995  Doug Evans  <dje@cygnus.com>

	* sparc/sparc.c (v9_regcmp_p): New function.
	(v9_regcmp_op): Call it.
	* sparc/sparc.md (movsicc): New pattern.
	(movdicc, movsfcc, movdfcc, movtfcc): Likewise.

	* sparc/sparc.c (sparc64_initialize_trampoline): Use gen_flush
	instead of knowing what pattern looks like.

	* sparc/sparc.md (nonlocal_goto): Use Pmode instead of SImode.

Wed Feb  8 10:05:11 1995  David J. MacKenzie  <djm@geech.gnu.ai.mit.edu>

	* config.sub: Add a blank in the #! line for 4.2BSD, Dynix, etc.

Wed Feb  8 02:52:21 1995  Jeffrey A. Law  <law@mole.gnu.ai.mit.edu>

	* pa.md (call, call_value): Emit save of the PIC register
	with "emit_insn" before emitting the call insn itself.

Tue Feb  7 15:19:40 1995  Jim Wilson  <wilson@cygnus.com>

	* sh.c (prepare_scc_operands, from_compare): Force constant 0 into
	register for unsigned comparisons.

	* sh.c: Correct errors in comments.
	(calc_live_regs, expand_acall): Delete TARGET_SMALLCALL support.
	(need_slot): Add comment.  Delete test of INSN_ANNULLED_BRANCH_P.
	(print_operand_address): Delete '*', '^', '!' support.
	(synth_constant): Call zero_extend* instead of and*.  Call ashlsi3_k
	instead of ashlsi3_n.
	(prepare_scc_operands): Abort for NE case.
	(output_move_double, output_far_jump, output_branch): Delete commented
	out code.  Don't output assembler comments.
	(gen_ashift): Don't call addsi3.
	(fixit): Delete redundant test for QImode constants.
	(hi_const): Delete TARGET_SHORTADDR support.
	(find_barrier): Don't put constant pool between mova and its label.
	(add_function, seen_function, bsr_operand, mac_operand,
	fake_shift): Delete.
	(sh_expand_prologue, expand_acall): Delete TARGET_BSR support.
	(general_movsrc_operand): Don't reject non-I CONST_INT.
	* sh.h: Correct errors in comments.
	(CONDITIONAL_REGISTER_USAGE): Delete TARGET_NOSAVE support.
	(TARGET_MAC, TARGET_TRYR0, TARGET_NOSAVE, TARGET_SMALLCALL,
	TARGET_PARANOID, TARGET_RETR2, TARGET_SHORTADDR, TARGET_BSR): Delete.
	(TARGET_SWITCHES): Delete above options.
	(OVERRIDE_OPTIONS): Delete TARGET_BSR support.
	(FUNCTION_BOUNDARY): Use 32 bit alignment when not TARGET_SMALLCODE.
	(FIRST_RET_REG): Delete TARGET_RETR2 support.
	(MODE_DISP_OK_[21]): Delete TARGET_TRYR0 support.
	(EXTRA_CONSTRAINT_U): Delete.
	(CONST_COSTS): For logical operations, give L constants cost 1.
	(PRINT_OPERAND_PUNCT_VALID_P): Delete '*', '^', '!'.
	* sh.md: Correct errors in comments.  Delete all assembler comments.
	Delete commented out patterns.  Delete all peepholes but two.
	Delete all define_splits but one.  Delete all `combiner' patterns.
	(mpy): Correct multiply latencies.
	(needs_delay_slot, hit_stack, interrupt_function, in_delay_slot,
	define_delay): Correct and/or simplify all reorg related definitions.
	(addsi3_real): Delete.
	(addsi3): Use arith_operand for argument 1.
	(mulhisi3): Use arith_reg_operand not mac_operand.
	(and_ffff, and_ff): Delete.
	(andsi3): Handle constant 255 specially.
	(rot*): Correct and/or simplify all rotate patterns.
	(ashlsi3_k): Delete clobber of T bit.  Output add for 1 bit shift.
	(ashlsi3_n, lshrsi3_n): Delete use of fake_shift.
	(negc): Correct pattern by adding set of T bit.
	(extend*): Delete 'u' and 'U' constraint cases.
	(pop): Separate 'l' and 'x' constraint cases.
	(movsi-1): Better code for move to T bit case.
	(bsr, bsr_value, mac): Delete.

Tue Feb  7 14:23:52 1995  Doug Evans  <dje@cygnus.com>

	* sparc/sparc.md (*): Give names to all anonymous patterns.

Mon Feb  6 23:41:09 1995  Stephen L Moshier  <moshier@world.std.com>

	* sparc/sysv4.h (ASM_OUTPUT_FLOAT, ASM_OUTPUT_DOUBLE): Remove
	  tests for host == target format and endianness.

Mon Feb  6 16:52:38 1995  Torbjorn Granlund  (tege@tiny.cygnus.com)

	* i386.h (RTX_COSTS): Rewrite.

	* m68k/lb1sf68.asm (__udivsi3, __divsi3, __umodsi3, __modsi3):
	Rewrite to actually work for more than a few small operands,
	and to be reasonably small.
	(__mulsi3): Eliminate usage of link register (i.e. a6).
	(shift patterns): Delete.
	(__umulsi3): Delete.
	* t-m68kbare (LIB1ASMFUNCS): Remove _umulsi3.
	* t-vxworks68: Likewise.

Mon Feb  6 15:22:39 1995  Jim Wilson  <wilson@cygnus.com>

	* ginclude/va-i960.h (va_start): Add __builtin_next_arg call.

	* sh/sh.c (sh_function_arg): Don't reject unaligned structures.
	(sh_function_arg_partial_nregs): Likewise.

	* sparc/sparc.md (movsf-1, movdf-1, movtf-1): Use 'F' not 'E'.

	* sparc/sol2.h (STARTFILE_SPEC): Delete explicit /usr/ccs/lib/
	pathnames.

	* reload1.c (alter_reg): New variable stack_slot.  Apply anti
	BYTES_BIG_ENDIAN correction to stack slot address stored in
	spill_stack_slot.

	* jump.c (jump_optimize): When searching for a LOOP_END note to move,
	stop if we find a LOOP_BEG note first.

Mon Feb  6 15:03:35 1995  Doug Evans  <dje@cygnus.com>

	* i386/sysv3.h (DBX_DEBUGGING_INFO): Define.
	(PREFERRED_DEBUGGING_TYPE): Define.

Mon Feb  6 11:56:14 1995  Jeffrey A. Law  <law@mole.gnu.ai.mit.edu>

	* pa.md: Replace "misc" attribute with "multi" in recentlyadded
	soft-float code.

	* pa-osf.h (TARGET_DEFAULT): Protect definition.

Mon Feb  6 11:52:25 1995  Ian Lance Taylor  <ian@cygnus.com>

	* fixincludes: When changing <assert.h> to include <stdio.h> or
	<stdlib.h>, make it include them only for C++.

Sun Feb  5 21:39:41 1995  Torbjorn Granlund  <tege@cygnus.com>

	* pa.c (globally): Use GEN_INT.
	(emit_move_sequence): Use expand_inc instead of plus_constant
	(generates less rtl).
	* pa.md (globally): Use GEN_INT.

	* pa.h (PREDICATE_CODES): Fix many errors.  Enable.

	* m68k.h (RTX_COSTS): Add special cases for a plain 68000.

	* expmed.c (mul_cost, div_cost): New variables.
	(mul_widen_cost, mul_highpart_cost): New variables.
	(init_expmed): Init new variables.
	(expand_mult_highpart): New argument, MAX_COST.
	Use new argument in several places.  Simplify code that tries
	widening multiply variants.
	(expand_divmod): New variables MAX_COST, EXTRA_COST.
	Initialize MAX_COST dependent on REM_FLAG.
	Calculate and pass cost in all calls of expand_mult_highpart.

Sat Feb  4 13:19:29 1995  Jim Wilson  <wilson@cygnus.com>

	* mips/abi64.h, mips/cross64.h, mips/iris6.h: New files.
	* mips/iris5.h (TARGET_DEFAULT): Add #ifndef/#endif around define.
	* mips/mips.c (mips_isa_string): Add mips4 to comment.
	(large_int): Delete code for handling 64 bit constants.
	(mips_const_double_ok): For irix6, reject all floating point constants.
	(mips_move_2words): Use dli not li for 64 bit constants.
	Use dla not la for 64 bit addresses.
	(output_block_move): Likewise.
	(function_arg): Add support for 64bit ABI.
	(override_options): Add support for mips4 and R8000.
	(print_operand): Handle new modifiers 'B', 'b', 'T', 't'.
	Make 'X' case work for 64 bit host.
	(mips_output_filename): Use ASM_OUTPUT_FILENAME.
	(mips_asm_file_start): Go to text section for 64bit ABI.
	(compure_frame_size, save_restore_insns, function_prologue,
	mips_expand_prologue, function_epilogue): Add support for 64 bit ABI.
	(type_dependent_reg, mips_function_value): New functions.
	* mips/mips.h (__PTR_TO_INT, __INT_TO_PTR): Delete.
	(enum processor_type): Add R8000.
	(mips_isa_string, CC1_SPEC): Add mips4 to comment.
	(CONDITIONAL_REGISTER_USAGE): Use SUBTARGET_CONDITIONAL_REGISTER_USAGE.
	(SUBTARGET_CONDITIONAL_REGISTER_USAGE): New macro.
	(ASM_SPEC, LINK_SPEC, CPP_SPEC): Add mips4 support.
	(MIPS_TEMP[12]_REGNUM): Change to avoid clobbering 64bit abi
	parameter registers.
	(SMALL_INT, SMALL_INT_UNSIGNED, CONST_OK_FOR_LETTER_P): Fix for 64
	bit host.
	(ABI_64BIT): New macro.
	(REG_PARM_STACK_SPACE): Use UNITS_PER_WORD not 4.
	(GO_IF_LEGITIMATE_ADDRESS, CONSTANT_ADDRESS_P, LEGITIMATE_CONSTANT,
	LEGITIMIZE_ADDRESS): Don't allow CONST addresses for Irix6.
	(ASM_OUTPUT_FILENAME): New macro.
	(ASM_OUTPUT_ADDR_DIFF_ELT): Add 64 bit ABI support.
	* mips/mips.md (type attribute): Add fmadd.
	(cpu attribute): Add r8000.
	(umaddi+1, ..., umadddi+8): Add pattern for multiply accumulate.
	(movdi): Legitimize addresses, just like movsi does.
	(loadgp): New pattern for 64 bit ABI.
	(shift patterns): Use INTVAL instead of XINT for constants.
	(jump, tablejump_interal[12]): Add 64 bit ABI support.
	(movsicc-8, ..., movsicc): Add patterns for conditional moves.
	* mips/t-cross64, mips/t-iris6, mips/x-iris6, mips/xm-iris6.h:
	New files.
	* configure: Add irix6 and irix5cross64 configurations.
	* ginclude/va-mips.h (*): Change __mips==3 to __mips>=3.
	(sgidefs.h): Include if _MIPS_SIM is defined.
	(va_start): Add support for 64 bit ABI.

Sat Feb  4 10:31:37 1995  Doug Evans  <dje@cygnus.com>

	* dbxout.c (dbxout_source_file): Don't switch to text section if
	in function with section attribute.  Print Ltext label to correct
	file (important on mips).

Fri Feb  3 14:43:23 1995  Michael Meissner  (meissner@cygnus.com)

	* rs6000/rs6000.md (call, call_value): If building for System V.4
	or eABI, function pointers are just pointers, not pointers to a
	three word area.

Thu Feb  2 15:50:26 1995  Ian Lance Taylor  <ian@cygnus.com>

	* fixincludes: When fixing bool in <curses.h>, permit whitespace
	before the semicolon.  Needed on AIX 3.2.5.

Thu Feb  2 12:06:12 1995  David Edelsohn  <edelsohn@mhpcc.edu>

	* rs6000.md (smax:SF define_split): Change match_operand typo to
	match_dup.
	(smin:SF define_split): Likewise.
	(smax:DF define_split): Likewise.
	(smin:DF define_split): Likewise.

Wed Feb  1 16:50:18 1995  Michael Meissner  (meissner@cygnus.com)

	* config.sub: Add support for powerpc-*-{elf,svr4,eabi}.
	* configure: Ditto.

	* rs6000/xm-sysv4.h: New file, to support building GCC for a
	System V.4 PowerPC system.
	* rs6000/sysv4.h: Ditto.
	* rs6000/x-sysv4: Ditto.

	* rs6000/eabi.h: New file, to support building GCC for an embedded
	PowerPC system.

	* rs6000/rs6000.h (TARGET_SWITCHES): Add -mmultiple, -mno-multiple
	to control emitting load/store multiple instructions.  On the
	power, this is on by default, and on the powerpc it is off.
	(SUBTARGET_SWITCHES): New macro, which defaults to nothing to
	allow a subtarget to add new switches.
	(SAVE_FP_*, RESTORE_FP_*): New macros that give the prefix and
	suffix to use for the functions that save and restore the floating
	point registers.

	* rs6000/rs6000.c (output_prolog): Use TARGET_MULTIPLE instead of
	TARGET_POWER to control whether to emitt load/store multiple
	instructions.  Use the SAVE_FP_*/RESTORE_FP_* macros instead of
	using the hardwired AIX names for the functions to save and
	restore the floating point registers.
	(output_epilog): Likewise.
	(print_operand_address): Do not prepend a '.' for %z when using
	the ELF object file format.
	(svr4_traceback): New function to emit the word before the
	procedure prologue that System V.4 expects to do tracebacks.
	(output_prolog): Call svr4_traceback under ELF systems.
	(output_epilog): Omit AIX style traceback tables for ELF systems.
	(output_function_profiler): Abort for now in the ELF case.

	* rs6000/rs6000.md (load_multiple, store_multiple): Test against
	TARGET_MULTIPLE instead of TARGET_POWER.

Tue Jan 31 19:27:43 1995  Torbjorn Granlund  <tege@cygnus.com>

	* pa.h (REAL_ARITHMETIC): Define.
	(ASM_OUTPUT_DOUBLE): Rewrite.
	(ASM_OUTPUT_FLOAT): Rewrite.
	* pa.md (SF and DF move): Use constraint 'E' instead of 'F'.
	* pa.c (singlemove_string): Make case with SFmode CONST_DOUBLE abort.
	(print_operand): #ifdef out CONST_DOUBLE cases.

Tue Jan 31 19:27:43 1995  Jim Wilson  <wilson@chestnut.cygnus.com>

	* pa/pa.h (TARGET_SOFT_FLOAT): New macro.
	(TARGET_SWITCHES, CPP_SPEC, CONDITIONAL_REGISTER_USAGE, FUNCTION_VALUE,
	LIBCALL_VALUE, FUNCTION_VALUE_REGNO_P, FUNCTION_ARG_REGNO_P,
	FUNCTION_ARG, ASM_DECLARE_FUNCTION_NAME, GO_IF_LEGITIMATE_ADDRESS,
	RTX_COSTS): Use TARGET_SOFT_FLOAT.
	* pa/pa.md (*sf*, *df*, etc): Make all floating point patterns depend
	on ! TARGET_SOFT_FLOAT.
	(movsi, movdi, movsf, movdf): Add patterns for TARGET_SOFT_FLOAT.

Tue Jan 31 15:53:04 1995  Jason Merrill  <jason@phydeaux.cygnus.com>

        * toplev.c (lang_options): Add -f{no-,}check-new.

Tue Jan 31 13:55:37 1995  Doug Evans  <dje@cygnus.com>

	* mips/mips.h (ASM_DECLARE_FUNCTION_NAME): Ensure section is .text if
	no section attribute.
	* mips/elf64.h (ASM_OUTPUT_SECTION_NAME): Use asm_out_text_file for
	functions.

Tue Jan 31 13:26:42 1995  Ian Lance Taylor  <ian@cygnus.com>

	* libgcc2.c: Include <limits.h>, not "glimits.h".

Mon Jan 30 16:34:24 1995  Jason Merrill  <jason@phydeaux.cygnus.com>

        * c-common.c (type_for_size): Try to match on int before other
        types (which might be the same size).
        (type_for_mode): Ditto.

Sat Jan 28 16:28:15 1995  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* config/sparc/sysv4.h (ASM_OUTPUT_SECTION_NAME): #undef before
 	defining.

Sat Jan 28 13:54:23 1995  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* pa.md (call, call_value): Always save the PIC register before
	a call.

Sat Jan 28 07:31:26 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* c-typeck.c (c_expand_return): Refine check for returning pointer
	to local variable to allow subtracting a pointer from it.

	* calls.c (expand_call): When emitting queue for each arg,
	call protect_from_queue; put in initial_value so EXPR_LIST in
	is_const case won't have QUEUED.

Sat Jan 28 04:36:46 1995  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* pa.md (call_internal_reg): Use an even faster sequence for
	TARGET_FAST_INDIRECT_CALLS.
	(call_value_internal_reg): Likewise.

Fri Jan 27 21:28:51 1995  Ronald F. Guilmette  (rfg@segfault.us.com)

	* config.sub (unixware, svr4): Treat as synonyms for sysv4.

Fri Jan 27 19:36:13 1995  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* config/i386/gnuelf.h: New file.

Fri Jan 27 16:55:05 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* libgcc1.c (perform_lshlsi3, __lshlsi3): Deleted.
	* libgcc2.c (__lshldi3): Deleted.
	* Makefile.in (LIB1FUNCS): Delete _lshlsi3.
	(LIB2FUNCS): Delete _lshldi3.

	* expr.c (expand_expr, case MINUS_EXPR): Remove bogus operand swap.

	* optabs.c (expand_binop): Add missing test for VOIDmode
	before calling convert_to_mode.

	* final.c (high_{block,function}_linenum): New variables.
	(final_start_function): Initialize them.
	(final_end_function): Pass highest line number to function end
	debugging routines.
	(final_scan_insn): Pass highest line number in block to block end
	debugging function.
	(output_source_line): Update highest line in block and function.

Thu Jan 26 03:46:35 1995  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* configure (i[345]86-*linux*): Set $extra_parts if $elf.
	(*-*-gnu*): Likewise.

Wed Jan 25 18:11:19 1995  Jim Wilson  <wilson@cygnus.com>

	* sh.c (prepare_scc_operands): Force sh_compare_op1 to a register if
	it is an invalid constant.
	(output_branch): Add cases for 4, 8, and 18.  Correct branch offsets
	in comments.
	(find_barrier): Correct test for move instructions that need to be
	fixed by verifying that the set source is a bad constant.
	(arith_reg_or_0_operand): New function.
	* sh.h (CONST_OK_FOR_LETTER_P): Add case for 'N'.  Correct comment.
	(ADJUST_INSN_LENGTH, SHORTEN_WITH_AJUST_INSN_LENGTH): New macros.
	* sh.md (define_attr type): Combine pcloadsi and pcloadhi into pcload.
	(*): Likewise for all patterns that use them.
	(define_attr length): Delete cases for pcloadsi and pcloadhi.
	Modify branch offsets and lengths to be correct.  Correct comment.
	(*): Correct length attributes for all patterns.
	(in_delay_slot): Delete maybe value.  Change default case from yes to
	no.  Delete case for lengths of 4, 6, 8, 10, and 12.
	(cmpeq_0, cmpeq_0-1, cmpeq_0-2): Delete patterns.
	(cmpeqsi_t): Delete case with constant as first operand.
	(cmpgtsi_t, cmpgesi_t): Use arith_reg_or_0_operand not arith_operand.
	Put register cases first.
	(cmpgeusi_t, cmpgtusi_t): Delete cases for comparing against zero.
	(jump): Call output_far_jump if insn length >= 14 instead of == 14.
	(casesi): Use arith_reg_operand not arith_operand for operand 2.

	* fixincludes (strings.h): Fix return type of strlen.

	* expr.c (expand_expr, case MIN_EXPR): If must emit multiple
	instructions, then don't allow a MEM target.

Wed Jan 25 17:07:47 1995  Pat Rankin  (rankin@eql.caltech.edu)

	* cccp.c (do_include): For VMS, don't attempt to
	treat `#include X' as `#include <X.h>' unless `X' has already been
	macro expanded.
	(main): For VMS, do a better job of picking out the base name from
	argv[0]'s absolute name.
	* vax/xm-vms.h (FAILURE_EXIT_CODE): Define.

Wed Jan 25 14:50:45 1995  David S. Miller  (davem@nadzieja.rutgers.edu)

	* genattrtab.c (check_attr_value): Change error message text.
	(simplify_test_exp): Likewise.
	* stmt.c (expand_asm, expand_asm_operands): Likewise.
	* mips.c (print_operand, print_operand_address): Likewise.
	* dsp16xx.c (dsp16xx_reg_class_from_letter): Likewise.
	(limit_reload_class, double_reg_to_memory): Likewise.
	(print_operand_address, emit_1600_core_shift): Likewise.
	(gen_tst_reg, gen_compare_reg): Likewise.
	* dsp16xx.md (compare): Likewise.
	* unroll.c (find_splittable_givs): Likewise.

Wed Jan 25 13:21:10 1995  Matthias Pfaller (leo@marco.de)

	* configure (ns32k-pc532-netbsd): Use netbsd32k.h instead of netbsd.h.
	* ns32k/netbsd32k.h: Renamed from netbsd.h.
	Don't include ansi.h.
	Include config/netbsd.h and delete definitions included from it.
	* ns32k/xm-netbsd.h (HAVE_ATEXIT): Deleted.

Wed Jan 25 12:53:40 1995  Philippe De Muyter (phdm@info.ucl.ac.be)

	* m68k/mot3300.h (DEFAULT_PCC_STRUCT_RETURN): Define as zero.
	(RETURN_IN_MEMORY): Small aggregates are to be returned in d0.

Wed Jan 25 12:48:43 1995  Paul Eggert  <eggert@twinsun.com>

	* cccp.c (handle_directive): Fix typo: '\' caused next char to
	be copied blindly, which was an error if !traditional and if
	the next char was newline or one of <\'"/.

Wed Jan 25 08:15:49 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* jump.c: Include expr.h after insn-config.h and insn-flags.h.

Tue Jan 24 23:19:28 1995  Doug Evans  <dje@cygnus.com>

	Improved conditional move support from Richard Earnshaw.
	* optabs.c (movcc_gen_code): New variable.
	(init_optabs): Initialize it.
	(emit_conditional_move): New function.
	(can_conditionally_move_p): New function.
	* combine.c (simplify_set): Call it.
	* expr.h: (emit_conditional_move): Declare it.
	(can_conditionally_move_p): Likewise.
	(movcc_gen_code): Likewise.
	* genopinit.c (optabs): Add entry for movcc_gen_code.
	* genconfig.c (main): Delete #ifndef around HAVE_conditional_move.
	* jump.c (jump_optimize): Try to emit a conditional move insn before
	trying a store-flag insn.
	* alpha.md (movsicc): New named pattern.
	(movdicc, movsfcc, movdfcc): Likewise.
	(SImode conditional move): New matcher.
	* sparc.h (HAVE_conditional_move): Delete.

	* configure: Recognize and ignore --x-* options.

Mon Jan 23 23:23:33 1995  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* config/svr4.h (ASM_OUTPUT_SECTION_NAME): Renamed from
 	ASM_OUTPUT_SECTION.  The old name was a typo.
	(ASM_OUTPUT_SECTION_NAME): Take proper number of args.

Mon Jan 23 18:51:38 1995  Jason Merrill  <jason@phydeaux.cygnus.com>

        * collect2.c (main): Check LD_INIT_SWITCH and LD_FINI_SWITCH
        separately.
        (scan_prog_file): Don't add shared library initializers or
        finalizers to list if LD_INIT_SWITCH or LD_FINI_SWITCH are
        defined, respectively.

Mon Jan 23 18:45:13 1995  Ian Lance Taylor  <ian@cygnus.com>

	* config/mips/mips.c (override_options): Permit any small integral
	mode in the HI/LO registers.

Mon Jan 23 15:41:10 1995  Steve Chamberlain  <sac@cygnus.com>

	* h8300.md (table_jump_h8300, table_jump_h8300h): Constrain
	operand to use register.

Sat Jan 21 00:01:08 1995  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* configure (*-*-gnuelf*): Set elf=yes.
	(*-*-gnu*): Use ${cpu_type}/gnuelf.h under --with-elf.

Fri Jan 20 20:11:17 1995  Jim Wilson  <wilson@cygnus.com>

	* combine.c (num_sign_bit_copies): Can handle paradoxical subreg only
	if LOAD_EXTEND_OP is defined to SIGN_EXTEND.

	* loop.c (record_giv): Initialize new field same_insn.
	* loop.h (structure induction): Add new field same_insn.
	* unroll.c (copy_loop_body): When check for shared address givs, use
	new same_insn field.
	(find_splittable_givs): New variable v2.  Scan givs to set new
	same_insn field.  Use same_insn to indentify address givs to be
	shared.

	* flow.c (find_basic_blocks): No longer need to check for deleted
	nonlocal_labels.
	* function.c (delete_handlers): When clear LABEL_PRESERVE_P,
	also remove label from nonlocal_label list.
	* integrate.c (save_for_inline_copying): Add comment that
	nonlocal_label list should be updated if it ever can be nonzero.

	* sdbout.c (syms.h): Don't include under Linux-based GNU systems.

	* loop.c (scan_loop): For the replace_rtx call, copy the rtx that is
	being substituted in before the call.

	* sh.c (machine_dependent_reorg): When remove SUBREG, add in
	SUBREG_WORD to new register number.

	* sh.c (multcosts): Do not compute cost of constant power-of-two
	multiplies as if they were shifts.  Reduce multiply cost from 5 to 3.
	Delete variable insn_cost.

Fri Jan 20 14:21:49 1995  Mike Stump  <mrs@cygnus.com>

	* stmt.c (expand_cleanups): Add 4th argument to indicate if code
	needs to be expanded for the cleanup.
	(expand_goto_internal): Ditto.
	(bc_expand_goto_internal): Ditto.
	(fixup_gotos): Ditto.
	(expand_end_bindings): Ditto.  We now always call expand_cleanups,
	even after BARRIERs, so that the call to the exception handling
	routines is always done.

Thu Jan 19 18:39:14 1995  Ian Lance Taylor  <ian@cygnus.com>

	* config/mips/mips.h (MASK_SINGLE_FLOAT): Define.
	(MASK_MAD): Define.
	(TARGET_SINGLE_FLOAT, TARGET_DOUBLE_FLOAT): Define.
	(TARGET_MAD): Define.
	(TARGET_SWITCHES): Add single-float, double-float, mad, no-mad,
	4650.
	(ASM_SPEC): For gas, pass down -m4650, and pass -m4650 if -mmad is
	used.
	(CC1_SPEC): If -mips3 is used, only set -mfp64 if neither
	-msingle-float nor -m4650 are used.  Don't permit both -mfp64 and
	-msingle-float, or both -mfp64 and -m4650.  If -m4650 is used,
	pass down -mcpu=r4650.
	(FIXED_REGISTERS): Change HI and LO to not be fixed.
	(HARD_REGNO_NREGS): If TARGET_SINGLE_FLOAT, use floating point
	registers in 4 byte units, not 8 byte units.
	(SECONDARY_RELOAD_CLASS): Define.
	(mips_secondary_reload_class): Declare.
	(LIBCALL_VALUE): If TARGET_SINGLE_FLOAT, only use FP_RETURN if the
	mode size is <= 4.
	(REGISTER_MOVE_COST): Use a cost of 12 when moving HI or LO to
	anything other than a general register.
	* config/mips/mips.c (function_arg): If TARGET_SINGLE_FLOAT, pass
	DFmode arguments in general registers.
	(override_options): Accept 4650 as a cpu type.  If
	TARGET_SINGLE_FLOAT, permit only small floating point modes in
	floating point registers.  Always permit SImode modes in HI/LO
	registers.
	(compute_frame_size): If TARGET_SINGLE_FLOAT, only save 4 bytes
	per floating point register.  Align the floating point register
	save space to an eight byte boundary.
	(save_restore_insns): If TARGET_SINGLE_FLOAT, save floating point
	regisers in single precision.
	(mips_secondary_reload_class): New function.
	* config/mips/mips.md: Require TARGET_DOUBLE_FLOAT for all double
	precision floating point insns.  Change the multiplication insns
	to be single instructions which set a register of class l or h or
	x, as appropriate, rather than explicitly setting HI and/or LO.
	Use define_expand to avoid generating a shift near a multiply on
	the r4000.  Use match_scratch in the division insns to clobber HI
	and LO, rather than mentioning them explicitly.  Add support for
	r4650 mad and madu insns.
	* config/mips/t-ecoff (MULTILIB_OPTIONS): Add mips1/mips3.
	(MULTILIB_DIRNAMES): Add mips1 mips3.

Wed Jan 18 07:43:53 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* tree.c (stabilize_reference): Fix typo in last change.
	* expr.c (get_inner_reference): Don't ignore CONVERT_EXPR from
	non-UNION_TYPE to UNION_TYPE.
	(expand_expr, case CONVERT_EXPR): Check for conversion to union
	before checking for not changing mode.

Tue Jan 17 22:33:27 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* tree.c (stabilize_reference, case RTL_EXPR): New case.

Tue Jan 17 18:42:44 1995  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* pa.c (emit_move_sequence): Also handle displacements which
	do not fit in 14 bits for fp load/store secondary reloads.

Tue Jan 17 13:34:22 1995  Jason Merrill  <jason@phydeaux.cygnus.com>

        Avoid bogus errors for C++ lvalues.
        * c-decl.c (init_decl_processing): Set pedantic_lvalues to pedantic.
        * fold-const.c (pedantic_non_lvalue): Only force a non-lvalue if
        pedantic_lvalues is set.
        * tree.h: Declare pedantic_lvalues.

        Generalize shared truthvalue code to allow for C++ bool.
        * c-tree.h: Declare boolean_{type,true,false}_node.
        * c-decl.c (init_decl_processing): Set up
        boolean_{type,true,false}_node to equal
        integer_{type,one,zero}_node.
        * c-common.c (truthvalue_conversion): Use
        boolean_{type,true,false}_node instead of
        integer_{type,one,zero}_node.
        (shorten_compare): Ditto.

Mon Jan 16 07:11:50 1995  Paul Eggert  <eggert@twinsun.com>
 
	* cccp.c (rescan): Fix typo that caused tokens to be glued
	together improperly.

Sun Jan 15 21:00:24 1995  Doug Evans  (dje@cygnus.com)

	* configure (vintmsg): Delete.

Sat Jan 14 17:50:06 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* expr.c (get_inner_reference): Only treat offset of PLUS_EXPR
	as special if second arg is integer constant.

Sat Jan 14 01:28:15 1995  Doug Evans  (dje@cygnus.com)

	* expmed.c (extract_bit_field, fields bigger than word case): Count
	subwords in target.  Zero remaining upper bits if unsigned.

	* c-common.c (decl_attributes): Fix typo in packed ignored warning.
	Fix unrecognized mode warning.  Make string comparisons consistent.
	Support machine attributes with arguments.  Make noreturn/volatile
	warnings consistent with others.

	* a29k.h (INIT_CUMULATIVE_INCOMING_ARGS): Reserve two regs for
	caller's lr0,lr1.
	* a29k.c (incoming_reg): Keep regstack aligned to even boundary.

Fri Jan 13 20:29:30 1995  Philippe De Muyter (phdm@info.ucl.ac.be)

	* sdbout.c (plain_type_1): For LONG_LONG_TYPE_SIZE, return T_[U]LONG
	instead of 0 (i.e. T_VOID).

	* optabs.c (expand_binop): Do not force constant shift-count to
	a register, to allow possible widening; do not convert_to_mode
	mode{1,2} or copy_to_mode_reg if mode{1,2} is VOIDmode.
	* m68k.md (zero_extendsidi2): New pattern.
	(extendqidi2, extendhidi2, extendsidi2, extendplussidi): New patterns.
	(adddia_sexthishl32, adddid_sexthishl32): New patterns.
	(adddi_dilshr32, adddi_dishl32, adddi_mem): New patterns.
	(adddi3, subdi3): Allow more alternatives.
	(subdia_sexthishl32, subdid_sexthishl32): New patterns.
	(subdi_dishl32, subdi_mem): New patterns.
	(negdi2): New pattern.
	(ashldi_sexthi, ashldi_const32, ashldi_const, ashldi3): New patterns.
	(subreg1ashrdi_const32, ashrdi_const32): New patterns.
	(ashrdi_const32_mem, ashrdi_const, ashrdi3): New patterns.
	(subreg1lshrdi_const32, lshrdi_const32, lshrdi_const, lshrdi3): Ditto.
	(lshrsi_31): New pattern.
	(lshrsi_16, lshrsi_17_24): New names for old unnamed patterns.

	* m68k.c (use_movqi, const_method): New functions.
	(const_int_cost, output_move_const_into_data_reg): Likewise.
	(singlemove_string): Call output_move_const_into_data_reg.
	* m68k.md (fullword move): Likewise.
	* m68k.h (CONST_COSTS): Call const_int_cost.

Fri Jan 13 20:17:55 1995  Oliver Kellogg  (okellogg@salyko.cube.net)

	* 1750a.h, 1750a.c: Remove use of function prototypes.

Fri Jan 13 15:53:33 1995  Jason Merrill  <jason@phydeaux.cygnus.com>

        * tree.h (DECL_STATIC_CONSTRUCTOR): New macro.
        (DECL_STATIC_DESTRUCTOR): New macro.
        (tree_decl): Add static_ctor_flag and static_dtor_flag.

        * objc-act.c (finish_file): Renamed from objc_finish.

        * c-parse.in (program): Call finish_file.

        * c-decl.c (duplicate_decls): Propagate DECL_STATIC_{CON,DE}STRUCTOR.
        (finish_function): Handle DECL_STATIC_{CON,DE}STRUCTOR.

        * c-lang.c (finish_file): New function to emit code for calling
        static constructor and destructor functions as necessary.

        * c-common.c (decl_attributes): Support __attribute__s
        "constructor" and "destructor".

Fri Jan 13 19:38:08 1995  Paul Eggert  <eggert@twinsun.com>

	* gcc.c (execute): Don't wait for just any N subprocesses,
	since we may have started with some subprocesses before we
	started executing.  Wait just for _our_ N subprocesses.

Fri Jan 13 18:08:17 1995  John F Carr  <jfc@mit.edu>

	* gencodes.c, genemit.c, genflags.c (gen_insn):  Ignore insns whose
	names begin with '*'.
	* genoutput.c (output_epilogue): Do not reference gen_ functions for
	insns whose names begin with '*'.

Fri Jan 13 17:54:42 1995  Wolfgang Formann  (wolfi@exner.tgm.ac.at)

	* i386/isc.h (ASM_FILE_START): New macro.

Fri Jan 13 15:01:59 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* c-parse.in (unary_expr): If -pedantic, give error for &&.

	* fold-const.c (fold, case COND_EXPR): Properly swap args 1 and 2.
	Strip nops from ARG2, just like ARG1.
	Make {MIN,MAX}_EXPR properly when type of result different than args.
	
	* function.c (optimize_bit_field): Don't remove a SUBREG that
	changes mode class.

	* Makefile.in (stmp-multilib*): Pass CC and CFLAGS to recursive make.

	* alpha/osf12.h (LINK_SPEC): Add missing "\".

Thu Jan 12 13:37:13 1995  Jim Wilson  <wilson@cygnus.com>

	* i960/t-* (LIBGCC1, CROSS_LIBGCC1): Define to empty instead of
	to libgcc1.null.
	* mips/t-*, sparc/t-*: Likewise.

Thu Jan 12 08:13:55 1995  Steve Chamberlain  (sac@wombat.gnu.ai.mit.edu)

	* libgcc2.c (__lshldi3, __lshrdi3,  __ashldi3, __ashrdi3):
	Shift count comes as a word, not as an SI.  Keep temporary in
	a word.
	(__moddi3, __divdi3): Make negate flag `c' have word_type for
	efficiency.

Thu Jan 12 07:18:09 1995  Stephen L Moshier  (moshier@world.std.com)

	* real.c (toe64):  Use Intel bit pattern for little-endian XFmode Inf.
	(e64toe): Likewise; also check the exponent field properly.

Wed Jan 11 14:24:55 1995  Jason Merrill  <jason@phydeaux.cygnus.com>

        * toplev.c (lang_options): Add -f{no-,}gnu-keywords, 
        -f{no-,}operator-names.

Tue Jan 10 19:16:07 1995  David Edelsohn  <edelsohn@mhpcc.edu>

	* rs6000.h (REGISTER_MOVE_COST): Add LINK_OR_CTR_REGS class to
	expensive moves.

Tue Jan 10 19:07:36 1995  Jonathan Beimel  (jbeimel@gomez.sc.intel.com)

	* combine.c (simplify_if_then_else): Fix typo: "|" should be "||".

Tue Jan 10 05:49:25 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* fold-const.c (fold): Avoid infinite recursion caused by last change.

Mon Jan  9 17:08:56 1995  Michael Meissner  (meissner@cygnus.com)

	* configure: All AIX versions [456789].* use the AIX 4.1 support.

Mon Jan  9 13:21:07 1995  David Edelsohn  <edelsohn@npac.syr.edu>

	* rs6000/aix41ppc.h: New file.

	* configure (powerpc-ibm-aix4.1*): Add support AIX version 4.1 on
	the powerpc.

Sat Jan  7 08:51:29 1995  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* sparc.c (order_regs_for_local_alloc): Add casts to bcopy call.
	(print_operand, case 'f'): New case.
	(sparc_initialize_trampoline): Use gen_flush instead of knowing
	what pattern looks like.
	Use MEM instead of address in flush insn, so virtual reg
	instantiation can update.
	Ensure address in flush insn is valid.
	* sparc.md (flush): Change to using a MEM instead of address.

	* reorg.c (dbr_schedule): Add missing casts in bzero call.

	* fold-const.c (fold, case CONVERT_EXPR): Don't remove an
	integer conversion when outer is FP unless it doesn't change
	signedness; rework code in this area to be clearer.

Sat Jan  7 02:58:21 1995  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* pa.h (enum processor_type): New enumeration describing the
	processor to schedule for (700, 7100, 7100LC).
	(pa_cpu_attr, TARGET_OPTIONS, OVERRIDE_OPTIONS): Define.
	(pa_cpu_string, pa_cpu): Provide extern decls.
	* pa.c (pa_cpu, pa_cpu_string): Provide definitions.
	(override_options): New function.
	(pa_adjust_cost): Handle PROCESSOR_7100 and PROCESSOR_7100LC
	scheduling.  Handle anti-dependendy cases involving fp division
	and sqrt.  Handle output dependencies correctly.  Break TYPE_FPMUL
	into TYPE_FPMULSGL and TYPE_FPMULDBL.
	* pa.md (cpu attribute): New attribute.
	Clean up comments for PROCESSOR_700 scheduling info.  Slightly
	simplify.  Make conditional on PROCESSOR_700.
	Add comments and scheduling information for PROCESSOR_7100 and
	PROCESSOR_7100LC.  Set types for instructions which use the shifter
	to "shift".  Explicitly set lengths and types for all instructions.
	Break type "fpmul" into "fmulsgl" and "fpmuldbl".

Fri Jan  6 17:50:48 1995  Jim Wilson  <wilson@chestnut.cygnus.com>

	* sh/sh.h (DO_GLOBAL_CTORS_BODY): Run constructors from right to
	left not left to right.
	* h8300/h8300.h: Likewise.

Thu Jan  5 12:37:26 1995  Doug Evans  <dje@cygnus.com>

	* loop.c (get_condition): Use CONST0_RTX instead of const0_rtx.

Wed Jan  4 04:26:23 1995  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* pa.md (call expander): Use emit_insn_before to emit an insn to
	save the PIC register before a function call.
	(call_value expander): Likewise.

Tue Jan  3 15:23:49 1995  Jim Wilson  <wilson@cygnus.com>

	* va-mips.h (va_arg, mips3 case): Use __PTRDIFF_TYPE__ not int in
	casts.

	* c-decl.c (duplicate_decls): Push to correct obstack before
	creating new function types.

Fri Dec 30 16:12:52 1994  Ian Lance Taylor  <ian@cygnus.com>

	* fixinc.svr4: Remove special patch for <netinet/in.h>.

Fri Dec 30 08:00:53 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* varasm.c: Include output.h.
	Add prototyes for all static functions; remove forward declarations
	of non-static functions.
	(assemble_variable): Add missing arg decl.
	(bc_make_decl_rtl, const_hash, const_hash_rtx): Now static.
	(output_addressed_constants, output_constructor): Likewise.
	(bc_output_constructor): Add missing argument.
	(output_byte_asm): Delete, unused.
	* output.h: Add decls of functions in varasm.c.
	Allow to be included when rtl.h is not.
	* function.h ({save_restore}_varasm_status): Add decls.
	* c-decl.c, c-typeck.c, toplev.c: Include output.h.
	* Makefie.in (c-decl.o, c-typeck.o, toplev.o, varasm.o): Likewise.

Thu Dec 29 21:48:03 1994  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* calls.c (expand_call): Set MEM_IN_STRUCT_P as needed on return
	value from assign_stack_temp.
	(store_one_arg): Likewise.
	* expr.c (save_noncopied_parts): Likewise.
	(expand_expr): Likewise.
	* function.c (assign_parms): Likewise.
	* integrate.c (expand_inline_function): Likewise.
	* stmt.c (expand_decl): Likewise.

Thu Dec 29 14:06:34 1994  Jim Wilson  <wilson@cygnus.com>

	* cse.c (simplify_unary_operation): Cast constant 1 to HOST_WIDE_INT
	before shifting left to form mask.
	* gcc.c (print_multilib_info): Initialize last_path_len to 0.
	* varasm.c (output_constructor): Change type of variable value to
	HOST_WIDE_INT.

	* expmed.c (expand_mult_highpart): Use convert_modes instead of
	gen_lowpart to do conversions.

Thu Dec 29 13:42:08 1994  Mike Stump  <mrs@cygnus.com>

	* toplev.c (lang_options): Add -frtti flag for rtti support in C++.

Wed Dec 28 22:04:42 1994  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* config/pa/lib2funcs.asm: New file.
	* config/pa/t-pa (LIB2FUNCS_EXTRA): Define.
	* config/pa/pa.h (DO_GLOBAL_DTORS_BODY): Define.  Include a
	reference to __gcc_plt_call so __gcc_plt_call always appears in
	executables which reference __main.

Wed Dec 28 21:18:26 1994  Jim Wilson  <wilson@cygnus.com>

	* mips.md (truncdiqi2+[123]): Add patterns to optimize DImode to
	SImode truncation.

	* reorg.c (fill_simple_delay_slots): For the epilogue case, set needed
	to include frame pointer and stack pointer, don't include all of
	end_of_function_needs.	Reject insn if it sets a previously set
	resource.

	* sh.c (sh_expand_prologue): Clear extra_push at start.  Clear
	current_function_anonymous_args if set.  Clear shiftsyms array.
	(sh_expand_epilogue): Don't clear extra_push,
	current_function_pretend_args_size, current_function_anonymous_args,
	and shiftsyms array.

	* reload.c (find_equiv_reg): Exclude registers clobbered in the
	CALL_INSN_FUNCTION_USAGE field of a CALL_INSN.

Tue Dec 27 19:22:35 1994  Mike Stump  <mrs@cygnus.com>

	* stmt.c (expand_cleanups): Add third parameter so that we can
	avoid marking a cleanup region if this cleanup is part of a fixup
	style goto.
	(expand_goto_internal): Pass a 1 to expand_cleanups.
	(bc_expand_goto_internal): Ditto.
	(fixup_gotos): Ditto.
	(expand_end_bindings): Pass a 0 to expand_cleanups.

Tue Dec 27 15:45:18 1994  Jeffrey A. Law  <law@snake.cs.utah.edu>

	* pa.c (output_movb): Fix ttypo.

Tue Dec 27 15:11:42 1994  Ian Lance Taylor  <ian@cygnus.com>

	* config/i960/i960.c (i960_output_double): Print hex constants if
	REAL_VALUE_TO_TARGET_DOUBLE is defined.
	(i960_output_float): Likewise with REAL_VALUE_TO_TARGET_SINGLE.

Sun Dec 25 07:22:30 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* convert.c (convert_to_pointer): Eliminate ref to null_pointer_node.

Thu Dec 22 12:51:31 1994  Stephen R. van den Berg  (berg@pool.informatik.rwth-aachen.de)

	* limitx.h (syslimits.h): Find syslimits.h in the same directory.

	* limity.h (_GCC_NEXT_LIMITS_H): If macro defined, recurse down
	to real limits.h.

	* gsyslimits.h (_GCC_NEXT_LIMITS_H): Define macro and start recursing
	down to the real limits.h.

Thu Dec 22 12:17:11 1994  Ian Lance Taylor  <ian@cygnus.com>

	* Makefile.in (LIMITS_H_TEST): New variable.
	(xlimits.h): Use LIMITS_H_TEST.
	* config/m68k/t-next (LIMITS_H_TEST): Define.
	* config/i386/t-next (LIMITS_H_TEST): Define.

Wed Dec 21 15:56:13 1994  Holger Teutsch  (teutsch@sw017.ffm-iw.Degussa.DE)

	* clipper.h (TRAMPOLINE_TEMPLATE): Specify some code as explicit hex
	words. Shorten template.
	(TRAMPOLINE_SIZE,INITIALIZE_TRAMPOLINE): Update accordingly.
	(FUNCTION_ARG,FUNCTION_ARG_ADVANCE): Aggregates are ALWAYS passed
	on the stack.
	* va-clipper.h (__va_rounded_size): Delete.
	(__va_round): Args have at least PARM_BOUNDARY (=32) alignment.

Wed Dec 21 15:36:46 1994  Stephen L Moshier  (moshier@world.std.com)

	* m68k.md (sqrtsf2, sinsf2, sindf2, sinxf2): Define.
	(cossf2, cosdf2, cosxf2): Likewise.
	(sqrtxf2): Operand 1 now XFmode.

Wed Dec 21 14:39:46 1994  Philippe De Muyter (phdm@info.ucl.ac.be)

	* m68k.md (adddi3, subdi3): New patterns.

Wed Dec 21 13:56:08 1994  Michael Gschwind  <mike@vlsivie.tuwien.ac.at>

	* pdp11.md (mulhisi3): Add truncate to mulhisi3 to fix bug and
	change from define_insn to define_expand to survive register
	presssure.

Wed Dec 21 12:51:10 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* stmt.c (expand_asm_operands): Make sure input operands are
	valid constants if they are constants.

	* toplev.c (rest_of_compilation): Adjust tests for when to
	inline and when to defer.
	* calls.c (expand_call): Only inline if DECL_INLINE; don't
	call function_cannot_inline_p here.

	* stmt.c (expand_expr_stmt): If want values for statements,
	convert function to address-of-function.

Wed Dec 21 00:02:33 1994  Ian Lance Taylor  <ian@cygnus.com>

	* combine.c (simplify_shift_const): Always copy flags to new MEM.

Tue Dec 20 14:15:58 1994  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* rs6000/aix41.h (LINK_SPEC): Add case for -shared, just like rs6000.h.

Tue Dec 20 09:14:00 1994  DJ Delorie (dj@ctron.com)

	* i386/go32.h: support #pragma pack().

	* msdos/configur.bat: add libgcc.a target.
	* msdos/mklibgcc.c: new file, helps build libgcc.a.
	* msdos/libgcc.mak: new file, makefile fragment for libgcc.a.
	* msdos/top.sed: change Makefile to be able to build libgcc.a.

Mon Dec 19 20:52:13 1994  Jim Wilson  <wilson@cygnus.com>

	* mips/x-sysv (CLIB): Add -L/usr/lib/cmplrs/cc3.11.

	* dsp16xx/dsp16xx.h (HAVE_VPRINTF): Delete.

	* flow.c (mark_set_1): For multi-reg hard register, clear all
	reg_next_use entries.

Mon Dec 19 17:49:59 1994  Doug Evans  <dje@cygnus.com>

	* Makefile.in (stmp-multilib): Check recursive make's return code.
	(.PHONY): Tell GNU make the various LANGUAGES are phony targets.

Mon Dec 19 17:07:41 1994  Ian Lance Taylor  <ian@cygnus.com>

	* config/mips/mips.c (print_operand): Don't print a CONST_DOUBLE
	as a floating point value if it is not MODE_FLOAT.

Mon Dec 19 15:27:42 1994  Jim Wilson  <wilson@cygnus.com>

	* fp-bit.c (fpadd_parts): Adding infinities with opposite signs
	yields a NaN.

	* loop.c (invariant_p): Reject const volatile references.

Sun Dec 18 21:55:26 1994  Jeffrey A. Law  <law@snake.cs.utah.edu>

	* pa.md (pic2_highpart): Accept readonly operands.

Sun Dec 18 16:29:20 1994  Jim Wilson  <wilson@cygnus.com>

	* mips/dec-bsd.h (CPP_PREDEFINES): Change _MIPSEB to _MIPSEL.

	* cccp.c (macarg1): Count newline at end of C++ comment.

Sun Dec 18 06:54:34 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* stor-layout.c (layout_decl): Allow DECL_BIT_FIELD for any type.

Sat Dec 17 03:43:24 1994  Jeffrey A. Law  <law@snake.cs.utah.edu>

	* pa.h (readonly_section): During PIC code generation, put
	readonly data into the standard data section.

	* pa.c (pic_label_operand): Disallow SYMBOL_REFs (constant data).

Fri Dec 16 06:44:40 1994  Jim Wilson  <wilson@chestnut.cygnus.com>

	* sparc/litecoff.h (DBX_BLOCKS_FUNCTION_RELATIVE, DBX_FUNCTION_FIRST,
	DBX_OUTPUT_MAIN_SOURCE_FILE_END): Define.
	(ASM_OUTPUT_SOURCE_LINE): Modify it to output function relative stabs.

	* sh/lib1funcs.asm (ashiftrt_r4_1): Delete useless or instruction.
	Add nop to rts delay slot.

	* combine.c (distribute_notes): When output an insn to hold a REG_DEAD
	note, update basic_block_head if necessary.

Thu Dec 15 15:22:46 1994  Jeffrey A. Law  <law@snake.cs.utah.edu)

	* pa.h (DBX_OUTPUT_MAIN_SOURCE_FILE_END): Don't emit a ".text"
	pseudo-op, we already make sure we're in the right space/subspace.

Thu Dec 15 07:49:36 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* expr.c (store_constructor): Properly get constant part of
	bit position when DECL_FIELD_BITPOS is a PLUS_EXPR.

Wed Dec 14 19:01:32 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* expr.c (get_inner_reference): Use EXACT_DIV_EXPR to
	compute byte offset from bit offset.

Wed Dec 14 11:41:21 1994  Ian Lance Taylor  <ian@cygnus.com>

	* fixincludes: Fix non const atof parameter on NEWS-OS 4.2R.

Tue Dec 13 18:39:09 1994  Doug Evans  <dje@cygnus.com>

	* h8300.c (handle_pragma): Only print warning once.

	* function.c (instantiate_virtual_regs_1, case PLUS): If offset is
	zero, make sure register replacement is still validated.

Tue Dec 13 07:51:20 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* tower-as.h (FUNCTION_EXTRA_EPILOGUE): Fix typo in mov.l opcode.
	* tower.h (IMMEDIATE_PREFIX): Really define.

	* expr.c (expand_expr, case MINUS_EXPR): Properly handle case
	when the NEGATE overflows.

Mon Dec 12 17:22:19 1994  der Mouse  (mouse@collatz.mcrcim.mcgill.edu)

	* reload.c (debug_reload): Use GET_MODE_NAME to avoid warning.

Mon Dec 12 13:15:04 1994  Doug Evans  <dje@cygnus.com>

	* function.c (locate_and_pad_parm): Don't call pad_below for BLKmode
	parms in regs.

	* expmed.c (emit_store_flag): Set mode after canonicalizing op0/op1
	so op1 is constant.

Mon Dec 12 08:04:33 1994  Pat Rankin  (rankin@eql.caltech.edu)

	* cccp.c, toplev.c (vms_fopen): Call `fopen' through an indirect
	pointer to inhibit checking argument list against its prototype.
	Increase RMS multi-block count from 16 to 32.

Sat Dec 10 17:03:59 1994  H.J. Lu   (hjl@nynexst.com)

	* cccp.c (do_include): Avoid dynamic initialization of aggregate.

Sat Dec 10 16:57:50 1994  Andreas Luik  (luik@isa.de)

	* m68k.md (cmpsi): Make this into a define_expand; legitimize
	PIC addresses if necessary.
	Old cmpsi code now unnamed define_insn pattern.

Sat Dec 10 16:06:03 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* fold-const.c (pedantic_omit_one_operand): New function.
	(fold, case COND_EXPR): Use it instead of calling
	pedantic_non_lvalue on the result of omit_one_operand.

Fri Dec  9 15:53:35 1994  Steve Chamberlain  (sac@wombat.gnu.ai.mit.edu)

	* reload.c (find_reloads_address_1):  Handle TRUNCATE and
	ZERO_EXTEND in same way as SIGN_EXTEND.

Fri Dec  9 14:52:41 1994  Jason Merrill  <jason@phydeaux.cygnus.com>

        * rs6000/rs6000.h (LINK_SPEC): Add %{shared:-bM:SRE}.
        (LINK_LIBGCC_SPECIAL_1): Use LIBGCC_SPEC instead.

Fri Dec  9 14:24:02 1994  Per Bothner  <bothner@kalessin.cygnus.com>

	* gcc.c (default_compilers):  Add support for Chill (.ch and .chi).

Fri Dec  9 17:31:46 1994  Jason Merrill  <jason@phydeaux.cygnus.com>

	* fixinc.svr4 (sys/byteorder.h): Turn extern inlines back into
	static inlines for targets (such as SPARC/Solaris) that don't
	supply these functions in the C library.

Fri Dec  9 17:19:44 1994  David Edelsohn  <edelsohn@npac.syr.edu>

	* rs6000.h (MASK_NO_FPR, TARGET_NO_FPR): Define.
	(TARGET_SWITCHES): Add "fp-regs" and "no-fp-regs".
	(CONDITIONAL_REGISTER_USAGE): Set FPRs fixed and call_used if
	TARGET_NO_FPR.

Fri Dec  9 16:06:23 1994  Doug Evans  <dje@cygnus.com>

	* fold-const.c (fold): Call real_zerop for real constants.

Thu Dec  8 17:28:57 1994  Jason Merrill  <jason@phydeaux.cygnus.com>

        * dbxout.c (dbxout_type_method_1): Don't try to look at the first
        argument of non-methods (which might not have a first argument).

Thu Dec  8 16:07:27 1994  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* configure (mips-*-gnu*): Recognize this configuration.
	* config/mips/gnu.h: New file.

Thu Dec  8 15:41:32 1994  Philippe De Muyter (phdm@info.ucl.ac.be)

	* m68k.c (extend_operator): New predicate.
	* m68k.md (bsetmemqi, bclrmemqi): New patterns to set bit in memory
	byte with bit number dynamic (use bclr/bset instructions).

Thu Dec  8 14:13:45 1994  Paul Eggert  <eggert@twinsun.com>

	* cccp.c (do_include): Don't turn newline markers into spaces
	when expanding an include file name.

	* cccp.c (discard_comments): If traditional, replace a comment
	with nothing instead of with a space.

	* cccp.c (char_name): New var.
	(initialize_char_syntax): Initialize it.
	(handle_directive): Use it to simplify printing of diagnostics.
	Warn about '\r' too.
	(create_definition, do_pragma, do_endif, make_assertion): Be consistent
	about skipping all horizontal white space, not just space and tab.

Thu Dec  8 13:54:38 1994  H.J. Lu (hjl@nynexst.com)

	* i386/linuxelf.h: Modified for stabs-in-ELF.
	(PREFERRED_DEBUGGING_TYPE): Defined as DBX_DEBUG.
	(FUNCTION_PROFILER): Use mcount instead of _mount.
	(CPP_PREDEFINES): Add -D__ELF__.
	(CPP_SPEC): Add -D__PIC__ -D__pic__ for -fPIC or -fpic.
	(LIB_SPEC): Don't use any default library if -shared.
	(LIBGCC_SPEC, LINK_SPEC, STARTFILE_SPEC, ENDFILE_SPEC): New specs.
	* configure (gxx_include_dir): Set default to '$(prefix)/include/g++'
	(i[345]86-*-linuxelf): New platform for ELF.
	* crtstuff.c (CRT_END): Add dummy refs to ___brk_addr, __environ
	and atexit if __linux__ and __PIC__  defined. 

Thu Dec  8 12:58:34 1994  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* config/xm-freebsd.h, i386/xm-freebsd.h: New files.
	* configure (i[345]86-*-freebsd*): Use i386/xm-freebsd.h.

Wed Dec  7 16:51:56 1994  Philippe De Muyter (phdm@info.ucl.ac.be)

	* m68k.md: New pattern for ior between SImode target and zero_extended
	value.

Wed Dec  7 16:42:46 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* combine.c (distribute_notes): If can't find place for REG_DEAD
	note, add an INSN with a USE to hold it.

	* tree.c (preserve_momentary): New function.

Wed Dec  7 15:59:00 1994  Doug Evans  <dje@cygnus.com>

	* function.c (locate_and_pad_parm): Do padding before rounding
	so pad_below knows how much is needed.

Tue Dec  6 17:53:37 1994  Steve Chamberlain  (sac@wombat.gnu.ai.mit.edu)

        * sh.md (ashrsi2_16): New pattern doesn't clobber reg 18.
        (ashrsi2_31): Fix.

Tue Dec  6 19:11:36 1994  Stephen L Moshier  (moshier@world.std.com)

	* c-decl.c (init_decl_processing):  Implement built-in functions
	fabsf, sqrtf, sinf, cosf, fabsl, sqrtl, sinl, cosl.

Tue Dec  6 18:42:15 1994  Pat Rankin  (rankin@eql.caltech.edu)

	* make-gcc.com: Eliminate `set symbol/scope=noGlobal'.

	* vax/vms.h (CPP_PREDEFINES): Set __GNUC_MINOR__ to 7.

Tue Dec  6 15:10:37 1994  Jason Merrill  <jason@phydeaux.cygnus.com>

        * sparc/t-sol2 (CRTSTUFF_T_CFLAGS): Don't use PIC if
        cross-compiling, use the native assembler otherwise.

Tue Dec  6 05:48:32 1994  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* configure (i[345]86-*-gnu*): Just set cpu_type=i386 here.
	(*-*-gnu*): Match this in second case stmt and set other vars based on
	$cpu_type.
	* config/gnu.h: New file.
	* config/i386/gnu.h: Include "gnu.h".

Mon Dec  5 16:59:39 1994  Doug Evans  <dje@cygnus.com>

	* sparc/t-sparcbare (LIB2FUNCS_EXTRA): Compile fp-bit.c.

Mon Dec  5 14:48:53 1994  Jim Wilson  <wilson@mole.gnu.ai.mit.edu>

	* unroll.c (copy_loop_body): Reformat CODE_LABEL_NUMBER macro call
	to avoid HPUX compiler bug.

Mon Dec  5 13:53:45 1994  Doug Evans  <dje@cygnus.com>

	* m68k.md (negsf2): Flip sign bit if software floating point.
	(negdf2,negxf2): Likewise.
	(abssf2): Zero sign bit if software floating point.
	(absdf2,absxf2): Likewise.

Mon Dec  5 13:00:37 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* rs6000.h (EXTRA_CONSTRAINT, case 'R'): Fix error in last change.

Mon Dec  5 00:40:11 1994  Doug Evans  <dje@cygnus.com>

	* Makefile.in (c-parse.h): Split away from c-parse.c for parallel
	makes.
	(bi-parser.h): Likewise with bi-parser.c.

Sun Dec  4 21:04:40 1994  Doug Evans  <dje@cygnus.com>

	Delete this patch:
	* reorg.c (fill_slots_from_thread): Create a USE insn for any
	redundant insn we pretend to fill a delay slot with.  Continue
	searching for a suitable delay slot insn at the new USE insn.

Fri Dec  2 11:29:41 1994  Per Bothner  <bothner@kalessin.cygnus.com>

	* expr.c (store_constructor):  Add support for SET_TYPE.

Fri Dec  2 18:14:09 1994  David Edelsohn  <edelsohn@npac.syr.edu>

	* rs6000.h (MASK_64BIT, TARGET_64BIT, SHORT_TYPE_SIZE): Define.
	(INT_TYPE_SIZE, MAX_INT_TYPE_SIZE, LONG_TYPE_SIZE): Define.
	(MAX_LONG_TYPE_SIZE, LONG_LONG_TYPE_SIZE, CHAR_TYPE_SIZE): Define.
	(FLOAT_TYPE_SIZE, DOUBLE_TYPE_SIZE, LONG_DOUBLE_TYPE_SIZE): Define.
	(POINTER_SIZE, PARM_BOUNDARY): Depend on TARGET_64BIT.
	(BIGGEST_ALIGNMENT, STARTING_FRAME_OFFSET): Likewise.
	(FIRST_PARM_OFFSET, REG_PARM_STACK_SPACE): Likewise.
	(STACK_POINTER_OFFSET, Pmode, FUNCTION_MODE): TARGET_64BIT dependent.
	* xcoffout.c (xcoff_output_standard_types): Add TARGET_64BIT
	dependencies.  Add "wchar", "long long int", and "long long
	unsigned int" built-in C types.

Fri Dec  2 18:08:16 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* integrate.c (subst_constant): Don't treat all virtual regs as
	constants, just those that are off FP and AP, but not SP.
	(expand_inline_function): If called function calls alloca, save and
	restore SP around its call.

	* rs6000.c (input_operand): Correctly check for SYMBOL_REF 
	referring to the TOC.
	* rs6000.h (EXTRA_CONSTRAINT): Likewise.

Wed Nov 30 20:42:57 1994  Jeffrey A. Law  <law@snake.cs.utah.edu)

	* reorg.c (fill_slots_from_thread): Create a USE insn for any
	redundant insn we pretend to fill a delay slot with.  Continue
	searching for a suitable delay slot insn at the new USE insn.

Wed Nov 30 19:02:49 1994  Jim Wilson  <wilson@chestnut.cygnus.com>

	* combine.c (record_dead_and_set_regs_1): Handle SUBREGs.

	* expr.c (convert_move): When emit multiword conversion, force FROM
	into a new pseudo-reg if it overlaps TO.

	* fold-const.c (fold_truthop): Delete BIT_AND_EXPR of constants
	with masks.

Wed Nov 30 18:22:31 1994  David Edelsohn  <edelsohn@npac.syr.edu>

	* rs6000.h (BITS_PER_WORD): TARGET_POWERPC64 dependent.
	(MAX_BITS_PER_WORD): Define.
	(UNITS_PER_WORD): TARGET_POWERPC64 dependent.
	(MAX_UNITS_PER_WORD): Define.
	(UNITS_PER_FP_WORD): Define.
	(HARD_REGNO_NREGS): Use MAX_UNITS_PER_FP_WORD.
	(HARD_REGNO_MODE_OK): Likewise.
	(CLASS_MAX_NREGS): Likewise.
	(MOVE_MAX): TARGET_POWER and TARGET_POWERPC64 dependent.
	(MAX_MOVE_MAX): Define.
	* rs6000.md (floatsidf2): Test BITS_PER_WORD in pattern condition
	not during build.  Fail if TARGET_POWERPC64.
	(floatunssidf2): Likewise.

	* rs6000.md (extendsidi2): Use lwa_operand predicate.
	(sign_extend load with update): New PowerPC64 pattern.
	* rs6000.c (lwa_operand): New predicate.
	* rs6000.h (PREDICATE_CODES): Add lwa_operand.

Wed Nov 30 18:19:08 1994  Will Athanasiou  (will@westford.ccur.com)

	* rs6000.md (extendsfdf2): SFmode and DFmode register format
	identical so use define_expand with paradoxical subreg no-op and
	accompanying new define_split.

Wed Nov 30 18:05:03 1994  Michael Collison  (collison@sw.stratus.com)

	* reload.c (combine_reloads): If using reg dying in this insn as
	reload reg, ensure it can't be a secondary output reload reg.
	
Wed Nov 30 15:48:29 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* expr.c (emit_block_move): Only use movstr if size is
	small enough constant or MODE is at least BITS_PER_WORD.

	* c-common.c (decl_attribute): Allow special names (e.g, `word')
	for mode attribute.
	* libgcc2.c (word_type): Use __attribute__ ((mode (__word__))).

Tue Nov 29 16:50:37 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

    	* expmed.c (expand_shift): Open-code rotate even if by a variable.
	* optabs.c (init_optabs): Don't set functions for rotl and rotr.

Tue Nov 29 00:39:56 1994  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* pa.h (DEFAULT_PCC_STRUCT_RETURN): Define as zero.
	(RETURN_IN_MEMORY): Only large structs (>8 bytes) and addressable
	structs should be returned in memory.
	* calls.c (expand_call): Handle returning BLKmode values in
	registers.  Do not try to promote BLKmode.
	* expr.c (expand_assignment): For BLKmode structure returns,
	copy the return value from registers into the target memory
	locations.
	* integrate.c (function_cannot_inline_p): Do not inline functions
	which return a BLKmode value in registers.
	* stmt.c (expand_return): For BLKmode structure returns, copy
	the return value from memory into the return registers.  Use
	an integer mode rather than BLKmode for returning structures
	in registers.
	* explow.c (hard_function_value): Change a register in BLKmode
	to a register in a sufficiently wide integer mode.

	* calls.c (expand_call): Do not set is_integrable if the
	function is not inlineable according to function_cannot_inline_p.

Mon Nov 28 18:53:06 1994  Dave Love  (d.love@dl.ac.uk)

	* Makefile.in (FLAGS_TO_PASS): Fix typo in GCC_FOR_TARGET.

Mon Nov 28 18:15:58 1994  Stephen R. van den Berg  (berg@pool.informatik.rwth-aachen.de)

	* configure (lang): Really fix the quoting bug in bash 1.12.

Mon Nov 28 18:03:48 1994  Jim Wilson  (wilson@cygnus.com)

	* expmed.c (store_bit_field, extract_bit_field): Consistently use
	SLOW_UNALIGNED_ACCESS instead of STRICT_ALIGNMENT.
	* expr.c (move_by_pieces, move_by_pieces_ninsns, emit_push_insn,
	expand_assignment, store_field, expand_expr): Likewise.
	(SLOW_UNALIGNED_ACCESS): Default to STRICT_ALIGNMENT, not zero.

	* cccp.c (create_definition): Error if comma not followed by an
	identifier.
	(collect_expansion): Error if # used in macro with no arguments.

	* c-decl.c (finish_decl): Use DECL_CONTEXT instead of
	current_binding_level to identify file-scope variables.

Wed Nov 23 19:44:25 1994  Steve Chamberlain  (sac@jonny.cygnus.com)

	* sh.c (MSW, LSW): New macros.
        (print_operand_address): Added 'T' and 'S'.  Modified
        to support alternate endianness.
        (output_movedouble):  Support both byte orders.
        (output_options): Tell assembler when in little endian mode.
        (shiftinsns): New function to calculate shift cost more
        accurately.
        (gen_shifty_op): Use new function.
        * sh.h (CPP_SPEC, ASM_SPEC, LINK_SPEC, LIBGCC2_WORDS_BIG_ENDIAN): New.
        (TARGET_SWITCHES, WORDS_BIG_ENDIAN, BYTES_BIG_ENDIAN, ): Support
        both byte orders.
        * sh.md (addi3, subdi3, ashrdi3, ashldi3, extendsidi2, movdi, movdf):
        Support both byte orders.
        (ashrsi2_16, ashrsi2_31): New.
        t-sh: Support both byte orders.

Wed Nov 23 17:25:43 1994  Ian Dall  (dall@hfrd.dsto.gov.au)

	* config/ns32k/{ns32k.c,ns32k.h}: Add -mhimem to
	support linking above 0x20000000 boundary.

	* config/ns32k/{netbsd.h,pc532.h, ns32k.c}: Fix meaning
	of BASE_REG_NEEDED.

Wed Nov 23 17:24:24 1994 Matthias Pfaller (leo@marco.de)

	* configure (ns32k-pc532-netbsd): No need for fixincludes
	and libgcc1.
	* ns32k/ns32k.h (CONST_COSTS): Correct range is -0x1fff to 0x2000.
	* ns32k/ns32k.md (everywhere): Correct range is -0x1fffffff
	to 0x20000000, others have to be loaded with movd.
	Shortcircuit with TARGET_32532 as early as possible.
	(movsi): Use movd to load unknown symbol values. to allow
	* ns32k/ns32k.c (print_operand): Removed dead code.
	* ns32k/pc532.h (TARGET_DEFAULT): Forbid usage of bitfield
	instructions.

Wed Nov 23 14:09:42 1994  Jim Wilson  (wilson@cygnus.com)

	* mips.c (mips_output_external): Exclude __builtin_next_arg from list
	of used external functions.

	* sh.c (arith_reg_operand): Disallow MACH_REG and MACL_REG.

	* sparc.h (SECONDARY_MEMORY_NEEDED_RTX, SECONDARY_MEMORY_NEEDED_MODE):
	Use MODE not mode.

Wed Nov 23 13:30:52 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* expr.c (emit_move_insn): If splitting up into individual words
	and X is a push_operand, do the push and reference top of stack.

Tue Nov 22 21:39:52 1994  Doug Evans  (dje@cygnus.com)

	* mips/elf64.h (ASM_OUTPUT_SECTION_NAME): Define.

Tue Nov 22 06:29:21 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* fold-const.c (fold_convert): Don't fold conversion if it would
	produce constant larger than we can support.
	* emit-rtl.c (gen_lowpart_common): Do nothing if size is
	greater than twice host wordsize, not just if equal.

	* optabs.c (emit_no_conflict_block): Just emit the insns if
	the block contains something not an INSN or has an embedded block.

	* emit-rtl.c (init_emit): Set REGNO_POINTER_FLAG
	for HARD_FRAME_POINTER_REGNUM.

	* machmode.h (ptr_mode): Add declaration.
	* emit-rtl.c (ptr_mode): Add definition.
	(init_emit_once): Initialize ptr_mode.
	* stor-layout.c (layout_type): Use ptr_mode instead of equivalent
	call to mode_for_size.

Mon Nov 21 18:41:42 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* varasm.c (output_constant): When eliminating conversions,
	treat ARRAY_TYPE like a record.

	* m68k.md (movqi): Fix typo in push/pop case.

Mon Nov 21 18:11:55 1994  Stephen R. van den Berg  (berg@pool.informatik.rwth-aachen.de)

	* genopinit.c (gen_insn): Use GET_MODE_WIDER_MODE macro instead of
	directly accessing the array.

Mon Nov 21 17:59:07 1994  David Edelsohn  <edelsohn@npac.syr.edu>

	* aix41.h (LINK_SPEC): New overriding defintion.

Mon Nov 21 17:44:01 1994  John F Carr  (jfc@mit.edu)

	* rs6000.c (input_operand):  Allow a SYMBOL_REF referring to a
	symbol in the TOC.

Mon Nov 21 14:39:13 1994  Doug Evans  (dje@cygnus.com)

	* mips/t-ecoff (dp-bit.c): Fix typos.

Mon Nov 21 14:06:29 1994  Jim Wilson  (wilson@cygnus.com)

	* emit-rtl.c (operand_subword): For CONST_DOUBLE, add case to
	handle BITS_PER_WORD of 16.

	* reload1.c (reload): When decrement max_groups of superclass, can
	only do so if the group_size is smaller than the current group.

	* c-lex.c (yylex): Do warn about floating point out of range if
	target floating-point format is IEEE.  Use warning instead of
	pedwarn to avoid getting errors.

Mon Nov 21 13:37:03 1994  Doug Evans  (dje@cygnus.com)

	* m88k/m88k-aout.h (CPP_PREDEFINES): Add -Acpu and -Amachine.
	* m88k/m88k-coff.h (CPP_PREDEFINES): Likewise.
	(DBX_DEBUGGING_INFO): Define.

	* m68k/t-m68kbare (MULTILIB_MATCHES): Treat m68302/m68332 like m68000.

Mon Nov 21 00:58:36 1994  Jeffrey A. Law  (law@mole.gnu.ai.mit.edu)

	* pa.c (output_call): When emitting an inline long-call, use LP%
	and RP% prefixes to get the function's address.

Sun Nov 20 07:00:25 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* Makefile.in (objc-parse.y): Fix typo.

	* t-svr3: Deleted.
	* t-svr4 (EXTRA_PARTS): Deleted.
	* i386/t-crtstuff, i386/t-crtpic: New files.
	* i386/t-svr3dbx (EXTRA_PARTS): Deleted.
	* configure: Replace use of t-svr3 with extra_parts definition.
	Add extra_parts to t-svr4 users; likewise for i386/t-svr3dbx.
	(i386 configurations): Add t-crtstuff if can't build crtstuff.c
	with -fomit-frame-pointer; use t-crtpic if also must build with -fpic.

Sat Nov 19 17:14:54 1994  Jim Wilson  (wilson@cygnus.com)

	* m68k/lb1sf68.asm (addsf3): After using swap for 16 bit rotate,
	branch back only if count still greater than 0.

	* c-typeck.c (build_binary_op): Can shorten shift only if shift count
	is less than size in bits of arg0.
	* expmed.c (expand_shift): Re-enable truncation of immediate shift
	count.

	* mips.c (mips_const_double_ok): Accept VOIDmode not DImode.
	(mips_move_1word): Accept VOIDmode CONST_DOUBLE.

Sat Nov 19 05:36:35 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* alpha.c (print_operand, case 'c', case 'd'): New cases.
	* alpha.md (sign_extend): Disable pattern with explicit SUBREG.
	(cmov): Allow first operand of comparison to be zero, 2nd reg.

	* a29k/unix.h (DEFAULT_PCC_STRUCT_RETURN): Define as 0.
	* a29k/x-unix (CLIB): Remove -lsysv.

Fri Nov 18 22:37:26 1994  Jason Merrill  (jason@phydeaux.cygnus.com)

	* m88k/mot-sysv4.h: Remove, no longer needed.
	* configure: Remove m88k-mot*-sysv4* special case.

	* collect2.c: Make various functions static.

	* sparc/sysv4.h ([CD]TORS_SECTION_ASM_OP): Remove #execinstr.

	* svr4.h, i386/sol2.h, m88k/dgux.h, sparc/sol2.h
	(LINK_SPEC): Pass -z text when -shared or -symbolic.
	* svr4.h (LIBGCC_SPEC): Don't pass -lgcc when -symbolic.

	* crtstuff.c: Fix comments.

Fri Nov 18 22:36:26 1994  Jason Merrill  (jason@phydeaux.cygnus.com)

	* pa/pa-hpux.h (LDD_SUFFIX): Move to pa.h.
	(PARSE_LDD_OUTPUT): Ditto.
	* pa/pa.h: (LDD_SUFFIX): Move from pa-hpux.h.
	(PARSE_LDD_OUTPUT): Ditto.
	(LINK_SPEC): Pass -b if -shared.  Don't pass -u main if -shared.
	* pa/pa1-osf.h: Reduce code duplication.

Fri Nov 18 22:35:26 1994  Jason Merrill  (jason@phydeaux.cygnus.com)

	* Makefile.in (crt{begin,end}.o): Pass $(CRTSTUFF_T_CFLAGS).
	(CRTSTUFF_T_CFLAGS): New variable.

	* svr4.h, m88k/sysv4.h, sparc/sysv4.h (FINI_SECTION_ASM_OP): Define.
	* i386/sol2.h (FORCE_FINI_SECTION_ALIGN): Define to
	FORCE_INIT_SECTION_ALIGN.
	* m88k/dgux.h, m88k/mot-sysv4.h, sparc/sysv4.h
	(INIT_SECTION_PREAMBLE): Remove.
	* svr4.h, sparc/sol2.h (STARTFILE_SPEC): Include crti.o and
        values-X?.o when building a shared lib.
	* svr4.h, i386/sol2.h, sparc/sol2.h (LIB_SPEC): Remove endfiles.
	(ENDFILE_SPEC): Handle endfiles.

	* libgcc2.c (__do_global_dtors): Don't define if
        INIT_SECTION_ASM_OP and OBJECT_FORMAT_ELF.
	(L_[cd]tor_list): Lose unused pieces.

	* crtstuff.c (__[CD]TOR_{LIST,END}__): static if OBJECT_FORMAT_ELF.
	(__do_global_ctors_aux): In .text if OBJECT_FORMAT_ELF.
	(__do_global_dtors_aux): Ditto.
	(init_dummy): Dummy function to stick a call to __do_global_ctors_aux
	into the .init section if OBJECT_FORMAT_ELF.
	(fini_dummy): Similarly.
	Remove reference to INIT_SECTION_PREAMBLE.

	* mips/iris5.h (HAS_INIT_SECTION): Define.
	(LINK_SPEC): Pass -u __main -init __main if not -shared.
	(STARTFILE_SPEC): Don't include these when -shared.
	(LIB_SPEC): Don't include these when -shared.
	(ENDFILE_SPEC): Define.
	(LD_INIT_SWITCH): Define.
	(LD_FINI_SWITCH): Define.

	* alpha/alpha.h (LD_INIT_SWITCH): Define.
	(LD_FINI_SWITCH): Define.
	(INIT_NAME_FORMAT): Lose.
	(FINI_NAME_FORMAT): Lose.

Fri Nov 18 22:34:26 1994  Ronald F. Guilmette (rfg@segfault.us.com)

	* crtstuff.c, svr4.h, i860/sysv4.h, m88k/sysv4.h, sparc/sysv4.h
        (CTORS_SECTION_ASM_OP): Remove @progbits, add SHF_WRITE.
	(DTORS_SECTION_ASM_OP): Ditto.

	* t-svr4, i386/t-sol2, m88k/t-sysv4, sparc/t-sol2
	(CRTSTUFF_T_CFLAGS): Define to -fpic.

Fri Nov 18 22:33:26 1994  Jason Merrill  (jason@phydeaux.cygnus.com)

	* gcc.c (LIBGCC_SPEC): New spec.
	(link_command_spec): Use LIBGCC_SPEC.
	(set_spec): Handle LIBGCC_SPEC.
	(process_command): Ditto.
	(do_spec_1): %G is LIBGCC_SPEC.
	(validate_all_switches): Also validate LIBGCC_SPEC.

	* alpha/alpha.h (LIBGCC_SPEC): Do include libgcc when
        creating a shared library.

Fri Nov 18 22:32:26 1994  Steve Dum  (steve_dum@mentorg.com)

	* collect2.c (SUNOS4_SHARED_LIBRARIES): Support scanning the
        _DYNAMIC field of SunOS 4 shared libraries directly.

Fri Nov 18 22:31:26 1994  Jason Merrill  (jason@phydeaux.cygnus.com)

	* collect2.c (main): For shared libraries, link in stubs even if
	there are no constructors or destructors so that static objects
	can be added without re-linking everything that uses the library.
	(write_c_file_stat): Tweak.

	* configure: Use sunos4.h instead of sparc.h for SunOS 4 targets.

	* sparc/sunos4.h: New file for SunOS 4-specific things.
	(SUNOS4_SHARED_LIBRARIES): Define to 1.
	* sparc/sparc.h: (LINK_SPEC): Support -shared.
	(LIB_SPEC): Ditto.

	* pa/pa-hpux.h (LDD_SUFFIX): New macro.
	(PARSE_LDD_OUTPUT): New macro.
	(LINK_SPEC): Pass -b if -shared.  Don't pass -u	main if -shared.
	(LIB_SPEC): Don't include if -shared.

	* collect2.c (scan_prog_file): Ignore undefined symbols.

Fri Nov 18 22:30:26 1994  Steve Dum (steve_dum@mentorg.com)

	* collect2.c (enum pass): Add PASS_LIB.
	(is_ctor_dtor): Check for shared library constructor and destructor
	functions, too.
	(main): Add o_file after any link libraries, too.
	Create a shared object if COLLECT_GCC_OPTIONS contains -shared.
	Also scan shared libraries for constructors and destructors if
	LDD_SUFFIX is defined.
	(write_c_file_stat): New function to write out file for a shared
	object.
	(write_c_file_glob): Renamed from write_c_file.
	(write_c_file): Calls one of write_c_file_{stat,glob}.
	(scan_prog_file): Update to deal with shared libraries.
	(scan_libraries): New function to scan shared libraries for
	constructors and destructors.

Fri Nov 18 19:16:19 1994  David Edelsohn  (edelsohn@npac.syr.edu)

	* rs6000.c (addrs_ok_for_quad_peep): New function.
	(output_prolog): Use liu mnemonic.
	(registers_ok_for_quad_peep): New function.
	* rs6000.md (peepholes for two DF load/store): New peepholes.

Fri Nov 18 19:10:24 1994  Kresten Krab Thorup  (krab@next.com)

        * objc/object.c (class_create_instance):  Replace memchr
	with memset.

Fri Nov 18 19:06:15 1994  Doug Evans  (dje@cygnus.com)

	* sparc/lite.h: #include "gofast.h"
	(INIT_SUBTARGET_OPTABS): Define.

Fri Nov 18 19:01:51 1994  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* Makefile.in (extraclean): Remove *.ps.

Fri Nov 18 18:53:57 1994  Philippe De Muyter (phdm@info.ucl.ac.be)

	* cccp.c (create_definition): Allow carriage-return ('\r')
	as white space in simple or empty expansion.

Fri Nov 18 18:30:40 1994  Douglas Rupp  (drupp@cs.washington.edu)

	* winnt/ld.c (main): Fix off-by-one error allocating sdbuff.

Fri Nov 18 18:23:54 1994  Mike Collison  (collison@sw.stratus.com)

	* regclass.c (record_reg_classes): For single SET between hard reg
	 alone in a class and pseudo, ensure reg is the only member of class.

Fri Nov 18 15:15:27 1994  Jim Wilson  (wilson@cygnus.com)

	* sol2.h (MD_STARTFILE_PREFIX): Delete.

Fri Nov 18 14:16:04 1994  Chris Huey  (cah@tactix.rain.com)

	* Makefile.in (objc-parse.y, mostlyclean): Rename temp file 
	for objc-parse.y to be under 14 characters.

Thu Nov 17 20:46:15 1994  Doug Evans  <dje@cygnus.com>

	VxWorks support from various people at Cygnus.
	* config.sub: Vendor for vxworks is wrs.
	* configure (i960-wrs-vxworks*): New target.
	(m68k-wrs-vxworks*): New target.
	(sparc-wrs-vxworks*, sparclite-wrs-vxworks*): New targets.
	* i960/t-vxworks960, i960/vx960-coff.h, i960/vx960.h: New files.
	* m68k/t-vxworks68, m68k/vxm68k.h: New files.
	* sparc/t-vxsparc, sparc/vxsparc.h: New files.

	* h8300/h8300.h (DBX_DEBUGGING_INFO): Define.
	(PREFERRED_DEBUGGING_TYPE): Define to SDB_DEBUG.

	* configure (--program-prefix, --program-suffix,
	--program-transform-name, -v, -verbose): New arguments.
	(as): If gas is in build tree, use it.
	(ld, real-ld): Likewise but watch for use_collect.
	(program_transform_name): Update Makefile if
	--program-transform-name given.
	(program_transform_cross_name): Likewise.
	* Makefile.in (program_transform_name): Define.
	(program_transform_cross_name): Define.
	(GCC_INSTALL_NAME, GCC_CROSS_NAME): Define.
	(install-common): Use them.
	(install-man): Likewise.
	(distclean): Delete *.asm.
	(stage*, risky-stage*): If as/ld/real-ld exist, copy them to stage dir.

	Embedded target support from various Cygnus people.
	* config.sub (sparc): Recognize as a cpu.
	(ecoff*, vsta, udi): Recognize as os's.
	(udi29k): New alias.
	* configure: (a29k-*-udi): New target.
	(i[345]86-*-aout*): New target.
	(i[345]86-*-coff*): New target.
	(i[345]86-*-vsta): New target.
	(m68k-*-aout*): New target.
	(m68k-*-coff*): New target.
	(m88k-*-aout*): New target.
	(m88k-*-coff*): New target.
	(mipsel-*-ecoff*): New target.
	(mips-*-ecoff*): New target.
	(mipsel-*-elf*): New target.
	(mips-*-elf*): New target.
	(mips64el-*-elf*): New target.
	(mips64orionel-*-elf*): New target.
	(mips64-*-elf*): New target.
	(mips64orion-*-elf*): New target.
	(sparc-*-aout*): New target.
	(sparclite-*-coff*): New target.
	(sparclite-*-*): Set tmake_file to sparc/t-sparclite.
	(mips*-*-*): Changed from mips-*-*.
	* optabs.c (expand_unop): Try subtraction from zero if there isn't a
	negate library function.
	* config/gofast.h: New file.
	* a29k/a29k-udi.h, a29k/t-a29kbare: New files.
	* i386/i386-aout.h, i386/i386-coff.h, i386/t-i386bare: New files.
	* i386/vsta.h, i386/t-vsta, i386/x-vsta, i386/xm-vsta.h: New files.
	* m68k/coff.h: New file (renamed from m68k-coff.h).
	* m68k/lynx-ng.h, m68k/lynx.h: Include it.
	* m68k/fpgnulib.c, m68k/lb1sf68.asm, m68k/m68kemb.h: New files.
	* m68k/m68k-aout.h, m68k/m68k-coff.h, m68k/m68k-none.h: New files.
	* m68k/t-m68kbare: New file.
	* m88k/m88k-aout.h, m88k/m88k-coff.h, m88k/t-bug: New files.
	* mips/ecoff-gdb.h, mips/ecoff.h, mips/ecoffl-gdb.h: New files.
	* mips/ecoffl.h, mips/elf.h, mips/elf64.h, mips/elfl.h: New files.
	* mips/elfl64.h, mips/elflorion.h, mips/elforion.h: New files.
	* mips/t-ecoff: New files.
	* sparc/lb1spc.asm, sparc/lb1spl.asm, sparc/litecoff.h: New files.
	* sparc/sparc-aout.h, sparc/t-sparcbare, sparc/t-sparclite: New files.

Thu Nov 17 18:32:24 1994  Torbjorn Granlund  (tege@tiny.cygnus.com)

	* cse.c (simplify_binary_operation): Do (x - (x & y)) -> (x & ~y).

Thu Nov 17 17:26:02 1994  Mark P. Gooderum  (mark@good.com)

	* stddef.h: Include <machine/ansi.h> on NetBSD.
	Check for _BSD_XXX_T_ as well as _XXX_T_.
	Add _BSD_XXX_T_ to list of defines to check and define for a given
	type for SIZE_T, PTRDIFF_T, and WCHAR_T.

Thu Nov 17 11:11:50 1994  Mike Collison  (collison@sw.stratus.com)

	* dsp16xx.c (notice_update_cc): Removed reference to obsolete LSHIFT.
	* dsp16xx.h (RTX_COSTS): Likewise.

Thu Nov 17 11:06:43 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* alpha.c (some_operand): New function.
	* alpha.h (PREDICATE_CODES): Add `some_operand'.
	* alpha.md (addsi3, adddi3): For patterns valid only
	during reload, allow operand 1 to be `some_operand'.

	* flow.c (find_auto_inc): Insert missing "return" statement.

	* c-common.c (print_char_table): Allow `L' for `u'.

Thu Nov 17 10:15:50 1994  Richard Stallman  <rms@mole.gnu.ai.mit.edu>

	* config.sub: Accept -domain as OS, and make it default for Apollo.

Wed Nov 16 19:28:46 1994  Jim Wilson  (wilson@chestnut.cygnus.com)

	* loop.c (move_movables): For move_insn case, skip notes when deleting
	instructions.

Wed Nov 16 16:13:48 1994  Ian Lance Taylor  (ian@cygnus.com)

	* bi-run.h: Always check BITS_BIG_ENDIAN, BYTES_BIG_ENDIAN, and
	WORDS_BIG_ENDIAN at run time, never at compile time.
	* bytecode.h, combine.c, cse.c, dbxout.c, dwarfout.c: Likewise.
	* expmed.c, expr.h, final.c, fold-const.c, function.c: Likewise.
	* jump.c, objc-act.c, real.c, real.h, recog.c, reload.c: Likewise.
	* reload1.c, sdbout.c, tree.c, varasm.c: Likewise.
	* real.c: Replace uses of MIEEE and IBMPC with a compile time
	check of IEEE and a runtime check of FLOAT_WORDS_BIG_ENDIAN.
	* libgcc.2 (LIBGCC2_WORDS_BIG_ENDIAN): If not defined, define to
	WORDS_BIG_ENDIAN.  Use it instead of WORDS_BIG_ENDIAN.
	* mips-tfile.c (init_file): Initialize fBigendian field based on
	HOST_WORDS_BIG_ENDIAN, not BYTES_BIG_ENDIAN.
	* config/mips/mips.h (MASK_BIG_ENDIAN): Define, replacing
	MASK_UNUSED4.
	(TARGET_BIG_ENDIAN): Define.
	(TARGET_SWITCHES): Add eb and el.  Include TARGET_ENDIAN_DEFAULT
	in default value.
	(TARGET_ENDIAN_DEFAULT): Define if not defined, based on
	DECSTATION.
	(CC1_SPEC): Convert -EB to -meb, convert -EL to -mel, and warn if
	-EB and -EL are both used.
	(CPP_SPEC): If -EB is seen, undefine MIPSEL, _MIPSEL, __MIPSEL and
	__MIPSEL__, and define _MIPSEB, __MIPSEB, __MIPSEB__ and MIPSEB
	(the last only if -ansi was not seen).  Similarly if -EL is seen.
	(REAL_ARITHMETIC): Define.
	(BYTES_BIG_ENDIAN, WORDS_BIG_ENDIAN): Base on TARGET_BIG_ENDIAN.
	(LIBGCC2_WORDS_BIG_ENDIAN): Define.
	(CONST_COSTS): Use split_double in CONST_DOUBLE case.
	* config/mips/mips.c (mips_move_2words): Use split_double rather
	than CONST_DOUBLE_LOW and CONST_DOUBLE_HIGH.
	(output_block_move): Check BYTES_BIG_ENDIAN at run time, not
	compile time.
	(print_operand): Check WORDS_BIG_ENDIAN, rather than using
	MOST_SIGNIFICANT_WORD and LEAST_SIGNIFICANT_WORD.
	* config/mips/t-mips (MULTILIB_OPTIONS, MULTILIB_DIRNAMES,
	MULTILIB_MATCHES, LIBGCC, INSTALL_LIBGCC): Define to build both
	big and little endian versions of libgcc.a.
	* config/mips/t-mips-gas: LIkewise.
	* config/mips/dec-bsd.h (CPP_SPEC): Same change as in mips.h.
	* config/mips/dec-osf1.h (CPP_SPEC): Likewise.
	* config/mips/iris3.h (CPP_SPEC): Likewise.
	* config/mips/iris5.h (CPP_SPEC): Likewise.
	* config/mips/osfrose.h (CPP_SPEC): Likewise.
	(CC1_SPEC): Same change as in mips.h.

Wed Nov 16 16:04:21 1994  Paul Eggert  <eggert@twinsun.com>

	* cccp.c (rescan): Remove unnecessary comparisons of ibp to limit.

Wed Nov 16 07:48:17 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* regclass.c (record_reg_classes): Handle case of single SET
	between a hard register alone in a class and a pseudo.

	* tree.c (integer_{zero,one,all_ones,pow2}p): Handle COMPLEX_CST.
	(real_{zero,one,two}p): Likewise.

	* gcc.c (main): For -V output, give both driver and compiler
	versions, if they differ.

	* toplev.c (rest_of_compilation): Always rerun jump_optimize
	after CSE if -O2.

	* fold-const.c (fold): If moved conversion into COND_EXPR,
	leave it there if it is an integral conversion to word or narrower.
	(fold, case NOP_EXPR): Ignore conversion to same type as operand.
	(fold, case COND_EXPR): Make third operand the simplest.

	* expr.c (convert_move): Don't put FROM in a register if it
	is a SUBREG.
	(store_expr): If don't want a value and storing into promoted
	variable, do conversion at tree level; don't copy volatile MEM
	unless want value, as comment says.

Tue Nov 15 20:02:34 1994  Doug Evans  (dje@cygnus.com)

	* varasm.c (named_section): New argument decl, all callers changed.
	* h8300/h8300.h, sh/sh.h, sparc/sysv4.h (ASM_OUTPUT_SECTION_NAME):
	New arg DECL.

Mon Nov 14 15:07:19 1994  Jason Merrill  <jason@phydeaux.cygnus.com>

        * tree.h (POINTER_TYPE_P): New macro.
        * m68k/m68kv4.h, m68k/mot3300.h (FUNCTION_VALUE): Use
        POINTER_TYPE_P rather than checking the type against
        POINTER_TYPE (to include references).
        * function.c (init_function_start): Ditto.

        * alpha/alpha.h (FUNCTION_VALUE): Use INTEGRAL_MODE_P rather than
        checking the type against various integral and pointer types.

        * m68k/{3b1,3b1g,crds,mot3300}.h: Don't define __PTR_TO_INT and
        __INT_TO_PTR.
        * m68k/xm-{3b1,crds,mot3300}.h: Define __PTR_TO_INT and __INT_TO_PTR.

Tue Nov 15 19:29:04 1994  Per Bothner  <bothner@kalessin.cygnus.com>

	* tree.c (staticp):  A non-nested function is always static.

Tue Nov 15 19:12:03 1994  Jim Meyering  (meyering@comco.com)

	* Makefile.in (specs, float.h-cross, xlimits.h): Use temporary instead
	of redirecting output directly to make target.
	($(MD_FILE), xsys-protos.h): Likewise.
	(mostlyclean): Remove any of these temporaries.
	(libgcc2.a): Add missing semicolon in commented code that could cause
	a /bin/sh syntax error if uncommented.

Tue Nov 15 19:07:00 1994  Warner Losh  (imp@village.org)
  
        * i386/freebsd.h (NO_IMPLICIT_EXTERN_C): Define.

Tue Nov 15 19:00:55 1994  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* reorg.c (redundant_insn): Renamed from redundant_insn_p; all
        callers changed.

Tue Nov 15 18:57:46 1994  Jim Wilson  (wilson@chestnut.cygnus.com)

	* reorg.c (relax_delay_slots): When invert a conditional jump over a
	single unconditional jump, invert the INSN_FROM_TARGET_P bit of insns
	in the delay slots.

	* reorg.c (redundant_insn_p): Change return type to rtx.  Return the
	redundant insn instead of true.
	(update_reg_unused_notes): New function.
	(fill_slots_from_thread): Call update_reg_unused_notes after one of
	the redundant_insn_p calls.

Tue Nov 15 18:39:33 1994  Torbjorn Granlund  (tege@tiny.cygnus.com)

	* expmed.c (expand_divmod, case ROUND_DIV_EXPR): Implement.
	* expr.c (do_jump_by_parts_greater_rtx): No longer static.
	(expand_expr): Delete code for plain `abs'.
	* optabs.c (expand_abs): New function, code moved from expand_expr.
	* expr.h: Declare expand_abs.

Tue Nov 15 12:11:26 1994  Jeffrey A. Law  (law@mole.gnu.ai.mit.edu)

	* pa.c (output_cbranch): Improve code for short backwards branch
	with an unfilled delay slot.
	(output_bb, output_dbra, output_movb): Likewise.

Tue Nov 15 09:55:31 1994  Doug Evans  (dje@cygnus.com)

	* jump.c (delete_insn): Delete labels in ADDR_VECs and
	ADDR_DIFF_VECs if their use count becomes zero.
	* flow.c (flow_delete_insn): New function.
	(find_basic_blocks): Call it to physically delete insns in
	unreachable blocks.  When scanning blocks after dead ones,
	start scanning after the dead one (not at the dead one).
	If there are lots of unreachable blocks, make another pass to squeeze
	them out (this reduces memory usage in some pathalogical cases by a
	significant amount without resorting to sparse matrices).
	(propagate_block): Make code a bit more efficient (for example,
	no need to test `loop_depth' for each insn, just notes).

Tue Nov 15 09:42:31 1994  Lynn Shumaker  (shumaker@saifr00.ateng.az.honeywell.com)

	* function.c (assign_stack_temp): Compute size of slot after
	assign_stack_local has accounted for alignment.

Mon Nov 14 23:47:20 1994  Torbjorn Granlund  (tege@tiny.cygnus.com)

	* pa.h (GO_IF_LEGITIMATE_ADDRESS): Allow
	(lo_sum (reg) (unspec (symref))).

	* pa.md (pic2_lo_sum): New pattern matching when -fPIC using UNSPEC.
	* pa.c (legitimize_pic_address): Generate an insn matching
	pic2_lo_sum when -fPIC.

	* pa.md (pic_highpart): Add missing mode for PLUS.
	(add_high_const): Likewise.

	* pa.md (matcher for plain lo_sum): Call abort if this happens
	when generating pic or PIC.

Mon Nov 14 23:47:20 1994  Jeffrey A. Law  (snake.cs.utah.edu)

	* Automatic generation of inline long call sequences when needed.
	* pa.h (TARGET_LONG_CALLS): Delete.  Replace all uses of with
	TARGET_PORTABLE_RUNTIME.
	(TARGET_MILLICODE_LONG_CALLS): New target flag.
	* pa.c (output_function_prologue): Keep track of the total number
	of code bytes emitted for each source file.
	(output_call): Handle TARGET_PORTABLE_RUNTIME and millicode calls
	for TARGET_MILLICODE_LONG_CALLS.  Emit an inline long-call if
	needed.  If emitting an inline long-call, perform argument relocations
	before the call if they are needed, unfill the delay slot of the
	call if necessary.
	* pa.md (define_delay for millicode): Disable the delay slot if
	TARGET_MILLICODE_LONG_CALLS.
	(millicode insns and indirect calls): Properly compute length for 
	both TARGET_PORTABLE_RUNTIME and TARGET_MILLICODE_LONG_CALLS.
	(call_internal_symref): Properly compute the length when more
	than 240000 bytes of code have already been output.  Take 
	TARGET_MILLICODE_LONG_CALLS into account in the length
	computation.

	* pa.h (DBX_OUTPUT_MAIN_SOURCE_FILE_END): Define.
	(ASM_FILE_END): Delete unneeded definition.

	* Fast indirect call support.
	* pa.h (TARGET_FAST_INDIRECT_CALLS): New target switch.
	(TARGET_SWITCHES): Add "fast-indirect-calls" and inverse.
	* pa.md (call_internal_reg, call_value_internal_reg): Generate
	appropriate code for TARGET_FAST_INDIRECT_CALLS.
			  
	* PA PIC support.
	* pa.c (secondary_reload_class): Refine.  Readonly data needs a
	secondary reload only during PIC generation.  Loading a floating
	point register with a constant requires a register from R1_REGS
	during -fPIC code generation.
	(read_only_operand): Constant pool entries are no longer read only
	during PIC code generation.
	(hppa_legitimize_address): If flag_pic is nonzero, then
	immediately call legitimize_pic_address.
	(emit_move_sequence): Call legitimize_pic_address to handle
	constant data.  Handle secondary reloads for PIC.  Use
	pic_label_operand rather than open coding the test.  Handle
	loading a LABEL_REF when generating PIC.
	(legitimzie_pic_address): Handle constant data addressing for PIC
	here.   Fix loading of symbolic addresses for -fPIC generation.
	(pic_label_operand): Renamed from pic_operand.  Handle any read
	only operand (such as constant data).  Reject function addresses,
	Accept SYMBOL_REF with the read-only bit set.  Generalize to
	handle (const (plus (reg) (int))).
	(finalize_pic): Delete unused function.
	(check_pic): Delete function.
	(pic_pc_rtx): Delete variable definition.
	(current_function_uses_pic_offset_table): Delete extern decl.
	(force_reg, validize_mem): Likewise.
        (output_global_address): Don't tack on "-$global$" when generating
        PIC code.
	(finalize_pic): Don't emit code for initialization of 
	hppa_save_pic_table_rtx here.  Don't claim we USE
	pic_offset_table_rtx at function end.
	* pa.h (SELECT_RTX_SECTION): Define.  During PIC generation
	everything (in the constant pool) goes into the data space.
	(PRINT_OPERAND_ADDRESS): Handle CONST_INTs during PIC
	generation.  Handle LO_SUM address during -fPIC generation.
	(LEGITIMATE_CONSTANT_P): Reject function labels when generating
	PIC code.
	(GO_IF_LEGITIMATE_ADDRESS): Only accept pic_reg + SYMBOL_REF for
	-fpic.
	(EXTRA_SECTION_FUNCTIONS): For -fpic, use the TEXT section for
	constants to avoid GAS lossage.
	(OVERRIDE_OPTIONS): Delete.
	(PIC_OFFSET_TABLE_REG_CALL_CLOBBERED): Define.
	(FINALIZE_PIC): Delete definition.
	(INIT_EXPANDERS): Define.  Clear hppa_save_pic_table_rtx here.
	* pa.md: Use !flag_pic rather than calling check_pic.
	(HImode high and lo_sum): Only accept const_int_operands.
	(pic_load_label): Force output to be in %r1. 
	(pic_highpart): New pattern.  Output must go into %r1.  More
	linker trickery.
	(symbolic high and lo_sum): Disallow during PIC	generation if
	source is a symbolic operand.  Handle CONST_INT LO_SUM during PIC
	generation.  Simplify.
	(define_split for symbolic_operand load): Do not accept a symbolic
	operand that is a pic_label_operand.
	(pic_load_label): Name this pattern.  Mask least significant bits
	and optimize when a simple label is within reach of an ldo.
	(call, call_value): Emit new-style USE information for
	pic_offset_table_rtx.  Emit code for initialization of
	hppa_save_pic_table_rtx and wrap it into push_topmost_sequence()
	and pop_topmost_sequence() calls. 

	* Various PA configuration cleanups.  
	* configure (hppa*-*-h[pi]ux): Use xm-pahpux.h and x-pa-hpux instead
	of the redundant hiux files.  Likewise for t-pa instead of t-pa-hpux.
	* config/pa/xm-pahiux.h: Delete.  It's identical to xm-pahpux.h.
	* config/pa/x-pa-hiux: Delete.  It's idential to x-pa-hpux.
	* config/pa/x-pa (TAROUTOPTS): Delete.  It was an HPUX host
	conditional, and x-pa is a BSD host target fragment.
	(INSTALL_HEADERS): Define.
	(STMP_FIXPROTO): Define.
	* config/pa/t-pa (INSTALLED_H): Delete.
	* config/pa/t-pa-hpux: Delete, it's identical to t-pa.
	* config/pa/pa-hiux.h: Include "pa/pa-hpux.h" and just override
	the CPP predefines.
	(CPP_PREDEFINES): Add -A assertions.
	* config/pa/{pa1-hiux.h, pa-ghiux.h, pa1-ghiux.h}: Likewise.
	* config/pa/pa-ghpux.h: Simplify by including pa-hpux.h.
	(DBX_DEBUGGING_INFO): Define.
	(DEFAULT_GDB_EXTENSIONS): Define.

Mon Nov 14 19:16:00 1994  Dennis Glatting  <war04!dennisg@kerby.ocsg.com>

	* fixincludes: Fixes for NextStep 3.2.  Remove ``__const__'' from
	sin and cos prototypes in ansi/math.h.  Remove keyword ``template''
	from bfd/libc.h.  Remove ``volatile'' from abort in bsd/libc.h
	and abort and exit in ansi/stdlib.h.

Mon Nov 14 18:54:28 1994  Douglas Rupp  (drupp@cs.washington.edu)

	* i386/x-winnt (EXTRA_PROGRAM): Match target name.

Mon Nov 14 18:48:21 1994  Torbjorn Granlund  (tege@tiny.cygnus.com)

	* freebsd.h (INCLUDE_DEFAULTS): Move definition beyond
	FREEBSD_NATIVE conditional.
	(FUNCTION_PROFILER): Move down to make file more similar to
	netbsd-i386.h.
	(DEFAULT_TARGET_MACHINE, etc): Comment our this braindamage!

Mon Nov 14 18:46:18 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* calls.c (expand_call): If IS_CONST and VALREG == 0, end our
	sequence and emit the insns.

Sat Nov 12 06:35:42 1994  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* Version 2.6.2 released.

Sat Nov 12 06:35:21 1994  Torbjorn Granlund  (tege@cygnus.com)

	* expmed.c (expand_divmod, case TRUNC_DIV_EXPR): Promote signed
	division by 0x80000000 to unsigned.

Fri Nov 11 17:07:35 1994  Michael Meissner  (meissner@osf.org)

	* c-common.c (decl_attributes): Add double-underscore version of
	printf and scanf for format type.

Fri Nov 11 16:38:04 1994  Jim Wilson  (wilson@chestnut.cygnus.com)

	* mips-tdump.c: Include <time.h>.  Delete ctime prototype.

Fri Nov 11 14:16:00 1994  Holger Teutsch  <holger@hotbso.rhein-main.de>

	* clipper.md (movsi+1): Allow r->m move during reloading.

Fri Nov 11 12:40:51 1994  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* c-decl.c (duplicate_decls): Properly merge decls with
	differing DECL_CONTEXT.

	* function.c (preserve_rtl_expr_result): find_temp_slot_from_address
	now used.
	Don't bring the temp slot to an inner level than it was.	
	(assign_stack_temp): Always initialize p->rtl_expr.

	* m68k/mot3300g.h (SPACE_AFTER_L_OPTION): Deleted.

Thu Nov 10 18:50:52 1994  Kresten Krab Thorup (krab@next.com)

	* objc/list.h: Add ifndef/define for repeated inclusion.

Thu Nov 10 18:02:58 1994  Michael Meissner  <meissner@pasta.osf.org>

	* c-common.c (decl_attributes): Check for attributes with leading
	and trailing double underscores.

Thu Nov 10 17:55:07 1994  Chris Metcalf  (metcalf@catfish.lcs.mit.edu)

	* fixincludes: Make argument type const for popen and tempnam in
	stdio.h and for strdup in string.h, for OSF/1 V3.0.

	* va-alpha.h (va_arg): Add cast to void * to suppress warning.

Thu Nov 10 17:48:21 1994  Walter Misar  (hrz.th-darmstadt.de)

	* m68k/hp320.h (FUNCTION_{PRO,EPI}LOGUE): Don't define.
	(IMMEDIATE_PREFIX, REGISTER_PREFIX): Define.

Thu Nov 10 15:04:57 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* m68k/crds.h (FUNCTION_{PRO,EPI}LOGUE): Add code to adjust stack
	when no frame pointer.
	* m68k.c (output_function_epilogue): Use a1 as scratch, not a0.
	* m68k/tower-as.h (FUNCTION_{PRO,EPI}LOGUE): No longer defined.
	(FUNCTION_EXTRA_EPILOGUE): Define.
	* m68k/tower.h (REGISTER_PREFIX, IMMEDIATE_PREFIX): Define.

	* i386/x-sco, i386/x-sco4 (CLIB): Add -lPW.
	(ALLOCA): Delete.

	* c-common.c ({print,scan}_char_table): Allow `L' modifier
	for integer output formats.
	(check_format_info): Treat `ll' like `q'.

	* rs6000.md (movsi): In TOC symbol case, use "la" for PowerPC.
	(movdi): Handle TOC symbol just like movsi.

	* objc-act.c (init_objc): Add missing casts to args of bcopy.
	(lang_init): Ensure line number is 0, not -1.

Tue Nov  8 07:51:53 1994  Paul Eggert  <eggert@twinsun.com>

	* cccp.c (dump_single_macro, dump_defn_1): If -traditional,
	dump macros in traditional style.  This also avoids a bogus error
	message if the macro uses traditional stringizing.

Mon Nov  7 21:28:13 1994  Michael I Bushnell  <mib@geech.gnu.ai.mit.edu>

	* protoize.c [!POSIX]: Only define O_RDONLY and O_WRONLY if not
	already defined.

Mon Nov  7 19:33:31 1994  Jim Wilson  (wilson@mole.gnu.ai.mit.edu)

	* combine.c (try_combine): Update split_code after converting MULT
	to ASHIFT.

Mon Nov  7 12:26:24 1994  Torbjorn Granlund  <tege@cygnus.com>

	* rs6000.md (DImode load-with-update matcher): Fix typo in MEM mode.
	(compare patterns): Fix several typos, SImode => CCmode.
	* sh.md (subdi3): Delete % from constraints.
	* 1750a.md (subqi3): Likewise.
	* clipper.md (subdi3): Likewise.
	* i370.md (subqi3): Likewise.
	(anonymous subqi3 matcher): Likewise.
	* i860.md (subdi3): Likewise.
	* dsp16xx.md (mulqi3): Fix typo in MULT mode.
	* elxsi.md (one_cmplsi2): Fix typo in NOT mode.

Mon Nov  7 12:47:37 1994  Ian Lance Taylor  <ian@cygnus.com>

	* m68kv4.h (ASM_IDENTIFY_GCC): Use proper definition for SGS assembler.

Mon Nov  7 11:02:25 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* gcc.c (process_command): Ignore LIBRARY_PATH and LPATH if
	cross-compiler.

Sun Nov  6 07:23:37 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* cross-test.c (foo): Return value for BU in range for shifts.

Sat Nov  5 14:25:36 1994  Jim Wilson  (wilson@chestnut.cygnus.com)

	* m68k.h (PREFERRED_RELOAD_CLASS): FP constants rejected by 'G'
	are OK for class FP_REGS.

Sat Nov  5 14:08:31 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* calls.c (store_one_arg): Preserve any temp slots whose address
	may have been taken.

	* real.c (GET_REAL, PUT_REAL): Cast args to bcopy to char *.
	* reload1.c (reload): Likewise.
	* i386.c ({save,restore}_386_machine_status): Likewise.
	* reg-stack.c (subst_asm_stack_regs): Likewise.
	(BLOCK_NUM): Rework to avoid cast of abort to int *.
	(find_blocks): Don't use BLOCK_NUM on lhs.
	(reg_to_stack, record_arg_reg_life): Cast arg to bzero to char *.

Sat Nov  5 08:29:45 1994  Paul Eggert  <eggert@twinsun.com>

	* cccp.c (rescan): Do not preserve newlines after macro name
	if rescanning a macro expansion.  Instead, preserve them if
	not outputting marks.

Fri Nov  4 17:25:29 1994  John David Anglin  (dave@hiauly1.hia.nrc.ca)

	* vax.c: Include tree.h and VMS-specific functions #ifdef VMS_TARGET.
	* vms.h (VMS_TARGET): Define.	

Fri Nov  4 17:19:30 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* bi-arity.c (main): Cast enum to char in output.
	* bc-emit.c (bc_emit_bytecode): Add missing cast.

Thu Nov  3 14:17:22 1994  Mike Stump  <mrs@cygnus.com>

	* libgcc2.c (__register_exceptions): Find max ending of a segment for
	end, not min.
	* libgcc2.c (__unwind_function): New function to support stack
	unwinding on i[34]86 for g++ exception handling.

Thu Nov  3 18:55:42 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* Makefile.in (c-parse.o, c-lex.o): c-parse.h is in $(srcdir).

Thu Nov  3 18:11:56 1994  John F Carr  (jfc@mit.edu)

	* rs6000.md (movsi): New alternative for SYMBOL_REF source operand.
	* rs6000.c (print_operand): New code '*' to print TOC register number.
	* rs6000.h (EXTRA_CONSTRAINT): 'R' matches a SYMBOL_REF for TOC entry.
	(PRINT_OPERAND_PUNCT_VALID_P): Recognize '*'.
	(PREDICATE_CODES): input_operand can now match SYMBOL_REF.

Thu Nov  3 18:03:24 1994  Jason Merrill  (jason@phydeaux.cygnus.com)

	* cccp.c: TOOL_INCLUDE_DIR is not C++-aware.

Thu Nov  3 17:23:30 1994  Jim Wilson  (wilson@chestnut.cygnus.com)

	* mips.c (mips_output_external): Exclude alloca from list of
	used external functions.

Tue Nov  1 19:19:41 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* Version 2.6.1 released.

Tue Nov  1 18:51:00 1994  Torbjorn Granlund  (tege@cygnus.com)

	* pa.md (add_high_const): Add missing mode for PLUS.

Tue Nov  1 18:39:53 1994  Stephen L Moshier  (moshier@world.std.com)

	* cse.c (simplify_unary_operation, case TRUNCATE): Set LV and HV.

Tue Nov  1 18:36:23 1994  Pat Rankin  (rankin@eql.caltech.edu)

	* vax.c (struct extern_list): Put code back outside of #ifdef VMS.
	(vms_check_external, vms_flush_pending_externals): Likewise.

Mon Oct 31 16:18:12 1994  Michael Meissner  <meissner@pasta.osf.org>

	* i386/i386.md (movsf, movdf, movxf): If we are moving floating
	point constants to a non-memory location that aren't 0 or 1,
	assume we need the pic register if -fpic.

Mon Oct 31 13:26:45 1994  Jim Wilson  (wilson@mole.gnu.ai.mit.edu)

	* sparc.h (GO_IF_LEGITIMATE_ADDRESS): Don't allow TFmode LO_SUM.
	* sparc.md (movtf+3): Disable pattern.

Mon Oct 31 08:11:47 1994  Doug Evans  <dje@canuck.cygnus.com>

	* expr.c (expand_expr, COND_EXPR case): Don't use original target as
	a temp if it's a volatile mem ref.  Finish previous patch (don't
	expand "X ? A & 1 : A" as "A & (X != 0)").

Mon Oct 31 08:07:09 1994  Pat Rankin  (rankin@eql.caltech.edu)

	* vax.c: Include tree.h #ifdef VMS.
	(struct extern_list): Move inside #ifdef VMS; add SIZE and IN_CONST
	fields; make `extern_head' static; add second list head.
	(vms_check_external): Move inside #ifdef VMS; give new args; maintain
	list of both pending external symbols and previously defined ones.
	(vms_flush_pending_externals): New function.
	* vax/vms.h (ASM_GLOBALIZE_LABEL): Pass new args to vms_check_external.
	(ASM_OUTPUT_EXTERNAL): Just call vms_check_external.
	(ASM_{,FINISH_}DECLARE_OBJECT_NAME, ASM_FILE_END): Define.

Mon Oct 31 08:00:59 1994  Michael Gschwind  (mike@vlsivie.tuwien.ac.at)

	* pdp11.h (TARGET_SWITCHES): Add -split and -no-split.
	(TARGET_SPLIT, TARGET_NOSPLIT): New macros.
	(TRAMPOLINE_TEMPLATE, INITIALIZE_TRAMPOLINE): Abort if -split.

Mon Oct 31 07:53:34 1994  Warner Losh  <imp@village.org>

	* i386/x-freebsd (CLIB): Add definition.

Mon Oct 31 07:49:17 1994  Jeffrey A Law  <law@snake.cs.utah.edu>

	* reorg.c (mark_set_resources): Properly handle SUBREGs.

Mon Oct 31 07:24:32 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* expr.c (expand_expr, case COMPONENT_REF): Don't extract
	field from a CONSTRUCTOR if it already has a TREE_CST_RTL.
	(expand_expr, case ADDR_EXPR): Call mark_temp_addr_taken
	on the temporary made when operand needs to be stored into memory.
	* function.c (preserve_temp_slots): Preserve anything whose
	address was taken when X is zero.

Sun Oct 30 15:11:51 1994  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* msdos/top.sed, i386/config-nt.sed: Update version to 2.6.1.
	* pa/t-pa-hpux: Add missing newline at end.

Sat Oct 29 21:16:29 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* emit-rtl.c (operand_subword): Fix typo: HOST_BITS_PER_INT
	should be HOST_BITS_PER_WIDE_INT.

Fri Oct 28 19:13:13 1994  Andrew McCallum  (mccallum@vein.cs.rochester.edu)

	* objc/misc.c (__objc_xcalloc):  Use calloc instead malloc/bzero.

Fri Oct 28 19:07:53 1994  Michael Gschwind  (mike@vlsivie.tuwien.ac.at)

	* pdp11.h (TRAMPOLINE_SIZE): Install real implementation.
	(INITIALIZE_TRAMPOLINE, TRAMPOLINE_TEMPLATE): Likewise.

Fri Oct 28 19:01:27 1994  Craig Burley  (burley@gnu.ai.mit.edu)

	* Makefile.in (stage?-start): Add semicolon between fi and done.
  
Fri Oct 28 17:12:26 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* cse.c (cse_insn): Don't record a DEST if paradoxical SUBREG
	and SRC is a SIGN_EXTEND or ZERO_EXTEND.

	* alpha.md (reload_outqi): Correctly handle scratch assignments
	for unaligned case when ADDR is a REG.

Fri Oct 28 07:55:40 1994  Michael Meissner  (meissner@osf.org)

	* i386/i386.md (adddi3): Fixup code in case operands[0] is equal
	to operands[2].

Thu Oct 27 18:58:39 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* reload1.c (count_possible_groups): Fix typo in setting
	counted_for_groups.

Thu Oct 27 15:30:41 1994  Per Bothner  <bothner@kalessin.cygnus.com>

	* c-typeck.c (process_init_element):  In the case of
	[LO .. HI] = VALUE, use save_expr to only evaluate VALUE once.

Thu Oct 27 15:15:25 1994  Torbjorn Granlund  (tege@rtl.cygnus.com)

	* gcc.c (process_command): Don't forget to split -Wl arguments at
	commas.

	* gcc.c (process_command): Handle -Wl, and -Xlinker similar to -l,
	i.e., preserve their order with respect to linker input files.

Thu Oct 27 13:11:16 1994  Douglas Rupp  (drupp@cs.washington.edu)

	* configure (i[345]86-*-winnt3*): Allow any version 3.x.
	Don't use a t-winnt file and move x-winnt to config/i386.
	* i386/x-winnt: Build ld-winnt.exe only on host.
	* winnt/t-winnt: Deleted.

Thu Oct 27 13:05:16 1994  Mike Collison  (collison@chianti.sw.stratus.com)

	* reload.c (debug_reload): New function to print reload info
	set up by find_reloads.

Wed Oct 26 18:27:03 1994  David Mosberger-Tang  <davidm@piston.cs.arizona.edu>

	* alpha.h (FUNCTION_PROFILER): Use $28 instead of $27.
	(LINK_SPEC): Pass -pg to linker.
	(LIB_SPEC): Link in -lprof1 with -pg, not -lprof2.
	(STARTFILE_SPEC): USe gcrt0.o if -pg, not mcrt0.o.

Wed Oct 26 18:22:34 1994  Doug Evans  (dje@cygnus.com)

	* expr.c (expand_expr, COND_EXPR case): Don't expand
	"X ? A & 1 : A" as "A & (X != 0)".

Wed Oct 26 18:06:52 1994  Douglas Rupp  (drupp@cs.washington.edu)

	* winnt/ld.c (expand_lib, main): Fix off-by-one bugs in several
	calls to malloc.

Wed Oct 26 22:00:09 1994  Richard Kenner  <kenner@vlsi1.ultra.nyu.edu>

	* winnt/t-winnt: Remove some spurious blank lines.

Wed Oct 26 14:14:39 1994  Michael Meissner  (meissner@osf.org)

	* i386/osfrose.h (REAL_NM_FILE_NAME): Use /usr/ccs/gcc/bfd-nm
	instead of /usr/ccs/bin/nm, since the GNU nm does not output stab
	symbols by default.

Wed Oct 26 13:47:06 1994  Michael Gschwind  (mike@vlsivie.tuwien.ac.at)

	* config.sub (pdp11): New machine name.
	* configure (pdp11-*-*): New configuration.
	* pdp11.c, pdp11.h, pdp11.md, xm-pdp11.h: New files.

Wed Oct 26 07:33:40 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* flow.c (find_basic_blocks): Ensure each live basic block is
	actually reachable.
	(life_analysis): Clean up handling of basic_block_drops_in.

Tue Oct 25 18:40:12 1994  Paul Eggert  <eggert@twinsun.com>

	* cccp.c (rescan): ".." no longer terminates a preprocessing
	number, since that's incompatible with the C standard.

Tue Oct 25 16:16:40 1994  Michael Dobson  (dobson@info.usuhs.mil)

	* we32k.h (CPP_PREDEFINES): Define u3b2, not u3b.

Tue Oct 25 16:15:27 1994  Jim Wilson  (wilson@cygnus.com)

	* reorg.c (fill_slots_from_thread): Update THREAD if it is split.

Mon Oct 24 00:12:46 1994  Jason Merrill  (jason@phydeaux.cygnus.com)

	* toplev.c (lang_options): Add -f{no-,}access-control.

Mon Oct 24 06:14:03 1994  Richard Earnshaw (rwe@pegasus.esprit.ec.org)

	* arm/arm.md (peepholes for call followed by branch): Disable.

Sun Oct 23 08:54:27 1994  Richard Earnshaw (rwe@pegasus.esprit.ec.org)

	* arm/x-riscix (INSTALL): Invoke install.sh with -c flag.

Fri Oct 21 00:42:08 1994  Jason Merrill  (jason@phydeaux.cygnus.com)

	* Makefile.in (LIB2FUNCS): Add _pure.

	* libgcc2.c (__pure_virtual): New function to go into vtable
	entries for pure virtual methods instead of abort.

Thu Oct 20 18:40:36 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* alpha.md (define_split comparison op with power of two minus 1):
	Fix typo.

Thu Oct 20 13:14:24 1994  Jason Merrill  (jason@phydeaux.cygnus.com)

	* collect2.c (add_to_list): Check for duplicates.

	* alpha/alpha.h (LINK_SPEC): Pass -shared through; don't
	pass -init __main if -shared.
	(STARTFILE_SPEC): Wrap startfiles in %{!shared:}.
	(INIT_NAME_FORMAT): Define.
	(FINI_NAME_FORMAT): Define.
	* alpha/osf12.h (LINK_SPEC): Ditto.
	* alpha/gdb-osf12.h: #include osf12.h instead of alpha.h

	* gcc.c (STARTFILE_SPEC): Wrap startfiles in %{!shared:}.

Thu Oct 20 16:07:46 1994  Jim Wilson  (wilson@cygnus.com)

	* unroll.c (loop_iterations): Move all failure exits after the
	computation of final_value.

	* mips.md (movdf_internal2+1): Disable when TARGET_64BIT.

	* i960.c (VARARGS_STDARG_FUNCTION): New macro.
	(i960_function_name_declare, output_function_profiler,
	i960_function_epilogue, i960_output_call_insn,  i960_output_ret_insn,
	i960_reg_parm_stack_space): Use it.
	(compute_frame_size): Don't use current_function_pretend_args_size.
	(i960_function_arg_advance, i960_function_arg): Don't use parameter
	named.
	(i960_setup_incoming_varargs): No need to adjust first_reg_offset
	after setting it.  Don't save last named argument to stack.
	Don't set pretend_size.
	* i960.h (SIGNED_CHAR_SPEC): Use #if instead of ?:.
	* va-i960.h (va_start): Use builtin_arts_info instead of
	builtin_next_arg.

 	* cse.c (merge_equiv_classes, cse_insn): Call rehash_using_reg
	after insert_regs.
	(canon_hash): Don't use qty_const to compute hash code for a
	register.

Thu Oct 20 09:41:51 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu)

	* stor-layout.c (variable_size): Return SIZE if it contains
	a PLACEHOLDER_EXPR.

Tue Oct 18 19:51:24 1994  Jason Merrill  (jason@phydeaux.cygnus.com)

	* collect2.c (main): Check REAL_*_FILE_NAME first.

Wed Oct 19 15:55:15 1994  David J. MacKenzie  <djm@duality.gnu.ai.mit.edu>

	* config.sub: Add licensing exception for Autoconf.

Wed Oct 19 06:43:46 1994  Michael Meissner  (meissner@osf.org)

	* i386/i386.h (FUNCTION_BLOCK_PROFILER): Don't bother preserving
	eax if -fpic, since it is a call clobbered register anyway.  Fix -fpic
	code so that it is correct.

Tue Oct 18 18:00:23 1994  Michael Meissner  (meissner@osf.org)

	* i386/i386.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER): Move
	macros here from osfrose, netbsd, and freebsd ports.  Remove
	assumptions that the assembler is gas.  Rewrite and fix the
	instructions produced with -fpic.

	* i386/osfrose.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER): Delete.
	* i386/freebsd.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER): Delete.
	* i386/netbsd-i386.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER):
	Delete.

Tue Oct 18 20:27:29 1994  Doug Evans  (dje@cygnus.com)

	* sparc.h (FRAME_POINTER_REQUIRED): Require frame pointer if
	non-leaf flat function.
	* sparc.c (sparc_frame_info): Combine members gp_sp_offset and
	fp_sp_offset into reg_offset.  All uses changed.
	(RETURN_ADDR_REGNUM): New macro.
	(RETURN_ADDR_MASK, FRAME_POINTER_MASK): New macros.
	(sparc_flat_compute_frame_info): Rename local mask to gmask.
	Only ensure reg save area is 8 byte aligned if necessary.
	(sparc_flat_save_restore): New arguments base_reg, offset, gmask,
	and fmask.  All callers changed.  No longer use %g2 to save regs
	in big stack frames.
	(sparc_flat_output_function_prologue): Delete local tsize.
	Reorder storing of previous frame pointer and return address reg to
	make it easier for gdb to identify flat functions.  Decrement %sp
	twice when saving call-saved regs in big frames.
	Count fp regs as 4 bytes in assembler comment.
	(sparc_flat_output_function_epilogue): Likewise when restoring
	call-saved regs.

Tue Oct 18 19:33:55 1994  Mike Collison  (collison@sw.stratus.com)

	* reload1.c (reload): Correctly compute group additional needs when
	the return register cannot be used as a spill register.

Tue Oct 18 16:17:26 1994  Jim Wilson  (wilson@mole.gnu.ai.mit.edu)

	* mips.h (ASM_SPEC): Pass -mcpu= option to GNU as.

Tue Oct 18 08:39:49 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* flow.c (propagate_block): Call mark_used_regs to show global regs
	used by call.
	* combine.c (can_combine_p): Don't combine into CALL_INSN where
	DEST is a global reg.

	* c-decl.c (start_function): Save immediate_size_expand
	and initialize it to zero in case nested function.

	* pa.c (non_hard_reg_operand): New function.
	* pa.md (reload_{in,out}*): Replace general_operand with
	non_hard_reg_operand.

Fri Oct 14 18:35:30 1994  Jason Merrill  (jason@phydeaux.cygnus.com)

	* gcc.c (default_compilers): Treat files with an extension of .c++
	as C++ code.

Mon Oct 17 19:21:57 1994  David Edelsohn  (edelsohn@npac.syr.edu)

	* configure (rs6000-ibm-aix4.1*): New configuration.
	* rs6000/aix41.h: New file.

Mon Oct 17 19:15:14 1994  Jim Wilson  (wilson@mole.gnu.ai.mit.edu)

	* va-mips.h (va_arg): Add little endian mips3 support.

	* sparc.h (RETURN_IN_MEMORY): Return true for TCmode values.

	* README.IRIX5: Delete.
	* install.texi: Update Irix 5 debugging info.

	* mips.c (function_prologue): Only emit line number when SDB_DEBUG.

	* configure: Delete new argument, --noguess.  Default build from
	host if host specified, otherwise guess build.  Fix typo in
	setting build from host.

Mon Oct 17 15:54:56 1994  Per Bothner  <bothner@kalessin.cygnus.com>

	* calls.c (expand_call, emit_library_call, emit_library_call_value):
	Allways adjust current_function_outgoing_args_size, even #ifndef
	ACCUMULATE_OUTGOING_ARGS.  (Useful for stack overflow checking.)
	* function.c (current_function_outgoing_args_size):  Update comment.

Mon Oct 17 18:49:01 1994  Paul Eggert  <eggert@twinsun.com>

	* cccp.c (rescan): Preserve newlines after macro names at the top level
	since this is more likely to do the right thing with line numbers.

Mon Oct 17 11:31:42 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* reload1.c (gen_reload): Renamed from gen_input_reload.
	(emit_reload_insns): Delete SECONDARY_MEM_NEEDED case for input
	reloads that can't happen and doesn't work.
	Fix errors in use of reload_outxx insns.
	Simplify output reload code by using gen_reload.
	* reload.h (gen_reload): Renamed from gen_input_reload.

Mon Oct 17 09:26:57 1994  Richard Earnshaw (rwe@pegasus.esprit.ec.org)

	* unroll.c (copy_loop_body, case JUMP_INSN): Don't abort if invert_exp
	fails.  Instead, redirect the jump around an unconditional branch.

Sun Oct 16 05:02:23 1994  Richard Earnshaw (rwe@pegasus.esprit.ec.org)

	* emit-rtl.c (add_insn_{before,after}): Don't abort because AFTER was
	deleted when not optimizing.

Fri Oct 14 19:26:28 1994  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* pa.c (emit_move_sequence): Handle secondary reload when loading
	a constant into SAR.

Fri Oct 14 10:29:31 1994  Richard Earnshaw (rwe@pegasus.esprit.ec.org)

	* fixincludes: Fix X11/Intrinsic.h for RISCiX to remove ___type from
	XtOffset.
	Add all files that receive special attention to REQUIRED, so that
	dependent copies are done if necessary.

	* getpwd.c: Always use getwd if HAVE_GETWD is defined.
	* arm/xm-arm.h: Define HAVE_GETWD.

	* arm/x-riscix, arm/t-riscix: New files
	* configure (arm-*-riscix*): Use them.
	
Thu Oct 13 17:12:27 1994  Jim Wilson  (wilson@mole.gnu.ai.mit.edu)

	* i960.md (call, call_internal, call_value, call_value_internal):
	Use memory_operand not general_operand.

	* optabs.c (expand_fix): Correct typo with FIX/UNSIGNED_FIX
	REG_NOTES.

Thu Oct 13 10:44:32 1994  Ian Lance Taylor  (ian@cygnus.com)

	* genattrtab.c (optimize_attrs): Don't do anything if
	num_insn_ents is zero.

Wed Oct 12 19:06:48 1994  Jim Wilson  (wilson@mole.gnu.ai.mit.edu)

	* mips/mips.c (mips_expand_prologue): Handle types that need
	constructing.  Rename TYPE to PASSED_TYPE and use consistently.

Wed Oct 12 11:32:05 1994  Ian Lance Taylor  (ian@cygnus.com)

	* genattrtab.c (num_insn_ents): New static variable.
	(remove_insn_ent): Decrement num_insn_ents.
	(insert_insn_ent): Increment num_insn_ents.
	(optimize_attrs): Use xmalloc to allocate all the attr_value_list
	structures at once, rather than using alloca for each one.

Wed Oct 12 09:17:34 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* optabs.c (??hf2_libfunc): Define like ??sf2_libfunc.
	(emit_float_lib_cmp): Call HFmode library functions.
	(init_optabs): Set names for HFmode comparison functions.
	* expr.h (??hf2_libfunc): Add declarations, like  ??sf2_libfunc.

Tue Oct 11 19:20:48 1994  Douglas Rupp  (drupp@cs.washington.edu)

	* winnt/ld.c (main): Pass -debug:full -debugtype:coff.
	* winnt/t-winnt: Rework rules for ld.
	* i386/config-nt.bat: Renamed from config/i386/config-winnt.bat.
	Make specific for x86, not all winnt; change filenames.
	* i386/config-nt.sed: Remove -g from CFLAGS.
	Reflect changes to t-winnt and other minor changes.
	* i386/x-winnt: Renamed from winnt/x-winnt.
	* i386/config-nt.sed: Renamed from config/winnt/top.sed.
	
Tue Oct 11 18:40:41 1994  Peter Schauer  (Peter.Schauer@regent.e-technik.tu-muenchen.de)

	* rs6000.h (ASM_DECLARE_FUNCTION_NAME): Always put out .lglobl
	for static functions.

Mon Oct 10 19:19:51 1994  Alex T. Ramos  (ramos@engr.latech.edu)

	* expr.c (convert_move): Add TImode conversions.

Mon Oct 10 18:46:44 1994  Alex Dreyzen  (alex@alex.jf.intel.com)

	* optabs.c (expand_float): Copy TEMP to TARGET when
	making recursive call and adjusting.

Mon Oct 10 07:10:25 1994  Michael Meissner  (meissner@osf.org)

	* i386/linux.h (DEFAULT_PCC_STRUCT_RETURN): Do not define as 0 if
	LINUX_ELF is defined.
	(perform.h): Include perform.h to define asm statements to use for
	libgcc1.a builds.

	* i386/linuxelf.h (DEFAULT_PCC_STRUCT_RETURN): Define as 1.
	(RETURN_IN_MEMORY): Don't define.

Sun Oct  9 11:49:20 1994  Michael Meissner  (meissner@osf.org)

	* i386/i386.md (movsf_mem): Add & constraint, so that the scratch
	register does not clobber the destination address.

Sun Oct  9 12:40:43 1994  Richard Earnshaw (rwe@pegasus.esprit.ec.org)

	* arm.md (reload_outdf): Don't call gen_addsi3 if the address is just
	a register.

Sat Oct  8 11:16:50 1994  Doug Evans  (dje@cygnus.com)

	* objc/archive.c (__objc_free): New function.
	(__objc_finish_read_root_object): Use it.

Fri Oct  7 19:23:03 1994  J.T. Conklin  (jtc@cygnus.com)

	* ginclude/stddef.h: Netware uses _SIZE_T_DEFINED_, _WCHAR_T_DEFINED_.

Fri Oct  7 12:45:43 1994  Michael Meissner  (meissner@osf.org)

	* i386/i386.c (legitimate_address_p): Disable SUBREGs as either
	the index or base register.

Fri Oct  7 08:24:44 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* i386/gnu.h (CPP_PREDEFINES): Define __HURD__.

	* collect2.c (my_strerror): If HAVE_STRERROR defined, call strerror.
	* xm-gnu.h (HAVE_STRERROR): Define.

	* function.c (preserve_temp_slots): If X cannot be a temp
	slot, preserve all things whose address was taken at the
	present level.

	* function.c (assign_stack_temp): Abort if SIZE == -1.

	* expr.c (safe_from_p): If EXP has a variable size, assume safe.
	(preexpand_calls): Don't preexpand a call that returns a variable-
	sized object.

	* emit-rtl.c (add_insn_{after,before}): Fix error in last change.

Thu Oct  6 09:18:28 1994  Kresten Krab Thorup  (krab@next.com)

	Adam Fedor (fedor@hopper.colorado.edu)
	* objc/archive.c (__objc_finish_read_root_object): Delay freeing
	of back-patch list.

	Andrew McCallum (mccallum@cs.rochester.edu)
	* objc/objc.h (BOOL): Changed from char to unsigned char.

Thu Oct  6 08:17:04 1994  Stan Cox  (coxs@dg-rtp.dg.com)

	* m88k/m88k.c (emit_move_sequence): If operand1 is an invalid PIC
	 address, then legitimize it before doing anything else.

Thu Oct  6 06:54:03 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* cse.c (cse_insn): Don't call force_const_mem on (const (truncate)).

	* expr.c (store_expr): Don't clobber TEMP with address.

	* reorg.c (try_merge_delay_insns): Update THREAD if it is split.

	* function.c (struct temp_slot): New field addr_taken.
	(assign_stack_temp): Initialize it.
	(mark_temp_addr_taken): New function.
	(preserve_temp_slots): Decrement level of things at same level
	but whose address has been taken.
	* expr.c (expand_expr, case ADDR_EXPR): Call mark_temp_addr_taken.

Wed Oct  5 14:17:39 1994  Jason Merrill  (jason@phydeaux.cygnus.com)

	* fold-const.c (fold, COMPONENT_REF): Don't die if the CONSTRUCTOR
	doesn't initialize the field we want.

Wed Oct  5 11:38:48 1994  Michael Meissner  (meissner@osf.org)

	* i386/i386.c (legitimize_pic_address): Changes to support
	LABEL_REF references when using -fpic.
	(output_pic_addr_const): Ditto.
	(print_operand_address): Ditto.

	* i386/i386.md (movsi insn): Changes to support LABEL_REF
	references when using -fpic.
	(movsi_lea): Name insn supporting lea instruction so it shows up
	more clearly when doing -dp.

Wed Oct  5 06:56:36 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* reorg.c (try_merge_delay_insns): Update THREAD if deleting first
	insn in it.

Wed Oct  5 01:19:14 1994  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* configure (i[345]86-*-gnu*): Set xm_file=i386/xm-gnu.h.
	* config/i386/xm-gnu.h: New file.
	* config/xm-gnu.h: New file.
	* config/i386/gnu.h: Move #include <fcntl.h> out of here, into
	config/xm-gnu.h.

Tue Oct  4 23:19:28 1994  Michael Meissner  <meissner@pasta.osf.org>

	* protoize.c (POSIX includes): If POSIX is defined, include
	sys/wait.h to get WIFSIGNALED, WTERMSIG, WIFEXITED, and
	WEXITSTATUS.

Tue Oct  4 21:48:02 1994  Michael I Bushnell  <mib@churchy.gnu.ai.mit.edu>

	* config/i386/gnu.h: Include <fcntl.h> to get O_RDONLY definition.
	* gcc.c (O_RDONLY): Define macro iff not already defined.
	(read_specs): Second arg to open should be O_RDONLY, not constant 0.

Tue Oct  4 19:06:38 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* expr.c (do_jump_for_compare): Properly scan insns when
	branch is at start of sequence.

Tue Oct  4 16:53:54 1994  Ian Lance Taylor  (ian@cygnus.com)

	* gcc.c, collect2.c, protoize.c (WIFSIGNALED): Define if not
	already defined.
	(WTERMSIG, WIFEXITED, WEXITSTATUS): Likewise.
	* gcc.c (execute): Use them.
	* collect2.c (do_wait): Likewise.
	* protoize.c (gen_aux_info_file): Likewise.

Tue Oct  4 16:38:06 1994  Michael Meissner  <meissner@pasta.osf.org>

	* i386/i386.h (RETURN_IN_MEMORY): Define so that large types such
	as complex double values get returned like structures do, and
	don't overwrite %ebx.

Tue Oct  4 15:58:21 1994  Jim Wilson  (wilson@mole.gnu.ai.mit.edu)

	* lynx-ng.h, lynx.h (PREFERRED_DEBUGGING_INFO): Add undef before
	define.

Tue Oct  4 05:12:02 1994  Richard Stallman  <rms@mole.gnu.ai.mit.edu>

	* config.sub: Translate -gnu/linux* to -linux*.

Mon Oct  3 11:43:45 1994  Ian Lance Taylor  (ian@cygnus.com)

	* config.sub: Add support for MIPS variants: mips64, mipsel,
	mips64el, mips64orion, mips64orionel, mips3*.

Sun Oct  2 18:26:34 1994  Jason Merrill  (jason@phydeaux.cygnus.com)

	* function.c (push_function_context_to): Renamed from
	push_function_context, adds argument to indicate that the new
	function is not a nested function.
	(push_function_context): Call it.
	(pop_function_context{,_from}): Similarly.

	* tree.c (save_tree_status): Add argument to indicate that the new
	function is not a nested function.
	(restore_tree_status): Ditto.

Sun Oct  2 18:05:37 1994  Doug Evans  (dje@cygnus.com)

	* configure (i[34]86-*): Change to i[345]86-*.
	(target_cpu_default): Treat i586 as an i486 (for now).

Sun Oct  2 10:25:51 1994  Richard Earnshaw (rwe@pegasus.esprit.ec.org)

	* arm.md (movsf): If reloading, create a scratch from the target for
	loading a constant into integer regs.
	(movdf): Likewise.

	Support for variants that fault on unaligned addrs:
	* arm.h (TARGET_SHORT_BY_BYTES): New macro.
	(TARGET_SWITCHES): Recognize switches -m[no-]short-load-bytes.
	(TARGET_DEFAULT): Only define if not already done so.
	(PROMOTE_MODE): Promote HImode unsigned if TARGET_SHORT_BY_BYTES.
	(SECONDARY_INPUT_RELOAD_CLASS): Need a scratch for reloading HImode if
	TARGET_SHORT_BY_BYTES.
	* arm.c (arm_reload_in_hi): New function.
	* arm.md (zero_extendhisi2, extendhisi2): Expand to suitable byte
	sequence when TARGET_SHORT_BYTES and loading a mem.
	(movhi_bytes, extendhisi2_mem): New expands.
	(movhi): Call movhi_bytes to load a short from memory if 
	TARGET_SHORT_BY_BYTES.
	(all matchers loading a short from memory): Don't match if 
	TARGET_SHORT_BY_BYTES.
	(matcher for movhi when TARGET_SHORT_BY_BYTES): New pattern to cover 
	remaining valid cases.

Sun Oct  2 08:54:30 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* reg-stack.c (subst_stack_regs): Check for NOTE to see if insn was
	deleted.

	* reorg.c (fill_slots_from_thread): Update THREAD if deleting
	its first insn.

	* reg-stack.c (delete_insn_for_stacker): Don't set INSN_DELETED_P
	on NOTE_INSN_DELETED.

Sat Oct  1 20:42:33 1994  Chip Salzenberg  <chip@fin.uucp>

	* sco4.h (CPP_PREDEFINES): Remove i386, unix.
	(CPP_SPEC): Add them here, so that they're undefined if -ansi.
	Also add _i386 and _unix, which are always defined.
	* x-sco (CLIB): Add "-lmalloc".
	(ALLOCA): Define as "-lPW".
	* x-sco4 (CC, OLDCC, RCCFLAGS, CCLIBFLAGS, CLIB, ALLOCA): From x-sco.
	(X_CFLAGS): Remove.

Sat Oct  1 14:27:45 1994  Michael Meissner  (meissner@osf.org)

	* i386/i386.md (movsf_push386): Rename to movsf_push_nomove.
	(movdf_normal): Prefer to use float registers rather than general
	purpose registers.

Sat Oct  1 07:01:10 1994  Richard Earnshaw (rwe@pegasus.esprit.ec.org)

	* c-decl.c (shadow_label): Emit an error if the label is already
	declared at this label scope. 

Sat Oct  1 06:44:58 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* emit-rtl.c (add_insn_{before,after}): Abort if insertion point is
	a deleted insn.
	* jump.c (jump_optimize): When deleting a jump, properly set NEXT.
	(duplicate_loop_exit_test): Don't insert NOTE_INSN_LOOP_VTOP
	before deleted insn; insert first, then delete.

	* gcc.c: Install omitted hunk from last diff.

Fri Sep 30 18:26:11 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* emit-rtl.c (add_insn_after): Abort if can't find AFTER and it
	has no NEXT_INSN.
	(add_insn_before): New function.
	(emit_{insn,insns,jump_insn,call_insn,barrier,note}_before): Call it.

Fri Sep 30 17:33:41 1994  Douglas Rupp  (drupp@cs.washington.edu)

	* config.sub (windowsnt): Alias for winnt.
	(winnt): New OS name.
	* configure (extra_programs): New, like extra_parts.
	(i[34]86-*-winnt3.1): New configuration.
	* genattr.c (atoi): Remove declaration.
	* getpwd.c: #ifdef WINNT, include direct.h.
	* sdbout.c: Don't include syms.h for winnt.
	* toplev.c: Don't include times.h for winnt.
	(get_run_time): Just return zero for winnt.
	(main): Don't print memory usage for OS/2 or winnt.
	* cccp.c (main): Use DIR_SEPARATOR if defined.
	Use "Include" environment variable instead of CPATH for winnt.
	* gcc.c: Don't include sys/file.h for winnt; use process.h instead.
	(concat): Now just concats two things; all callers changed.
	(concat[346]): New functions.
	(dir_separator_str): New variable.
	(exec_prefixes, startfile_prefixes, include_prefixes): Renamed
	from same names without plural; all users changed.
	(find_a_file, process_command, do_spec_1): Use DIR_SEPARATOR.
	(find_file, is_directory, main): Likewise.
	(lookup_compiler): If OS/2, do case-independent search.
	(fix_argv): New function on winnt.
	(FIX_ARGV): New macro for some systems; use instead of argv.
	* i386/unix.h: Treat ALMOST_STDC like __STDC__.
	(AS2C): New macro.
	* i386.c (output_387_binary_op): Use AS2C instead of AS2 with
	null first arg.
	* config/winnt/config-nt.bat, config/winnt/ld.c: New files.
	* config/winnt/{[tx]-winnt, config/winnt/top.sed: New files.
	* config/winnt/winnt.h, config/winnt/xm-winnt: New files.
	* i386/winnt.h, i386/xm-winnt.h: New files.

Thu Sep 29 19:53:14 1994  Jim Wilson  (wilson@cygnus.com)

	* sparc.md (movdf+3): Handle overlapping registers in define_split.

	* gcc.c (default_compilers): Add %Z to all cpp specs.
	(n_preprocessor_options, preprocessor_options): New variables.
	(process_command): Handle -Wp option.
	(do_spec_1): Handle %Z spec.

	* i960/i960-coff.h: New file.
	* t-960bare: New file.
	* config.sub (os): Accept coff as an OS.
	* configure (i960-*-coff): New configuration.

	* expr.c (result_vector): Use INCOMING_REGNO when !savep instead
	of when savep.
	* sparc.md (call): Use struct value pattern is struct size is not
	equal to zero instead of greater than zero.
	(call+7, call+8): New patterns for untyped calls.
	(untyped_call): Revise to emit explicit rtl for all operation.
	Delete four old patterns that matched the unexpanded untyped_call
	pattern.
	(blockage): New pattern.
	(flush_register_windows): Modify from 0 to 1.
	(goto_handler_and_restore): Modify from 1 to 2.
	(flush): Modify from 2 to 3.
	* sparc.c (sparc_initialize_trampoline): FLUSH is now 3 not 2.

	* calls.c (emit_library_call): For FUNCTION_ARG_PASS_BY_REFERENCE,
	pass address through force_operand before using it.

	* i960.c (i960_setup_incoming_varargs): Store parameter registers
	at proper offset in argument block.

Thu Sep 29 16:39:32 1994  Mike Stump  <mrs@cygnus.com>

	* stmt.c (expand_return): We have to be careful of cleanups that can
	be generated when expanding the return value, as they might otherwise
	wipe out the return value.

Thu Sep 29 13:35:24 1994  Mike Stump  <mrs@cygnus.com>

	* expr.c (do_jump): Handle cleanups in TRUTH_ANDIF_EXPR and
	TRUTH_ORIF_EXPR.

Thu Sep 29 13:23:56 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* gcc.c (struct option_map): Sort in alphabetical order.
	(translate_options): Ignore option once an error occurs.
	Fix error with reversed 'a' and 'o'.
	Give error if specified abbreviation is unambiguous.

	* c-typeck.c (convert_for_assignment): When converting object
	to union, allow converting the constant zero into a pointer
	member of the union.

Wed Sep 28 19:33:01 1994  Alex T Ramos  (ramos@engr.latech.edu)

	* machmode.def (PSImode): Widens to PDImode.
	* expr.c (convert_move): Added handling of PDImode conversions.

Wed Sep 28 19:24:17 1994  H.J. Lu  (hjl@nynexst.com)

	* configure: Don't make objc-runtime if cross-compiling gcc.
	* build-make (FIXINCLUDES): Set to Makefile.in.

Wed Sep 28 19:18:19 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* function.c (trampoline_address): Add missing call to 
	round_trampoline.

Wed Sep 28 18:34:13 1994  Michael Meissner  (meissner@osf.org)

	* config/svr4.h (ESCAPES): Print \v in octal rather than as '\v',
	since some older versions of gas didn't accept it.

Wed Sep 28 14:29:20 1994  Ian Lance Taylor  (ian@cygnus.com)

	* fixincludes: Comment out loop which handles symbolic links to
	files.  It appears to not work, and to be unnecessary.

Tue Sep 27 19:27:56 1994  Matthias Pfaller  (leo@marco.de)

	* ns32k.h (ENCODE_SECTION_INFO): Only calls may go through the
	PLT. All address loads, even function address loads, have to 
	go through the GOT or function addresses will not be unique.

Tue Sep 27 19:20:12 1994  Paul Eggert  (eggert@twinsun.com)

	* cccp.c (newline_fix, name_newline_fix): Don't treat \r
	specially here; it only causes bugs.  This undoes the
	May 14 16:01:13 1990 change to newline_fix and name_newline_fix.

Tue Sep 27 19:02:55 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* m88k.h (ASM_OUTPUT_SOURCE_LINE): Add missing #undef.

Tue Sep 27 18:32:17 1994  William J. Eaton  (wje@hoffman.rstnu.bcm.tmc.edu)

	* function.c (optimize_bit_field): Put any insns made by
	change_address in front of INSN.
	(expand_function_end): Don't pass DECL_INITIAL to setjmp_protect
	if it is error_mark_node.

	* genoutput.c, reload.c (n_occurrences): Make arg int, not char.
	* objc-act.c (warn_with_method): Likewise.

	* optabs.c (expand_fix): Call emit_library_call_value.

Tue Sep 27 12:39:10 1994  Mike Stump  (mrs@cygnus.com)

	* Makefile.in, libgcc2.c (L_eh): some support routines for C++.

Mon Sep 26 06:45:20 1994  Michael Meissner  (meissner@osf.org)

	* 386/i386.md (adddi3, subdi3): Rewrite to add a clobber of a
	scratch variable, so that memory/memoroy adds and subtracts can be
	done using just one scratch register.  Also, don't require op1 to
	be the same as op0.

Fri Sep 23 19:03:09 1994  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* config/i386/gnu.h (LIB_SPEC): Remove macro.

Fri Sep 23 16:11:26 1994  Michael Meissner  (meissner@osf.org)

	* i386/lynx-ng.h (CALL_USED_REGISTERS): Copy definition from
	i386/lynx.h that makes ebx be a call clobbered register, since
	some system calls evidently trash it.

Fri Sep 23 15:54:53 1994  Jim Wilson  (wilson@cygnus.com)

	* configure (mips-*riscos*): Changed to mips-*-riscos*.
	(mips-*-riscos*-*): Deleted.

	* cse.c (invalidate): New parameter FULL_MODE.  All callers
	changed.
	(set_nonvarying_address_components): Modify initial comment.
	(cse_insn): When call invalidate for dest, use the actual dest not
	inner_dest.

Thu Sep 22 18:56:19 1994  Torbjorn Granlund  (tege@cygnus.com)

	* expmed.c (expand_divmod): Special case for signed CEIL_DIV_EXPR
	when divisor is power of 2.

Thu Sep 22 12:28:53 1994  Jason Merrill  (jason@deneb.cygnus.com)

	* fixinc.svr4: Fix size_t, ptrdiff_t and wchar_t like fixincludes
	does.  Use extern inline rather than static inline in byteorder.h.

Thu Sep 22 12:22:03 1994  Steve Dum  (steve_dum@mentorg.com)

	* collect2.c (main): Discard the first executable once we've
	exploited it.

Thu Sep 22 11:38:34 1994  Ian Lance Taylor  (ian@cygnus.com)

	* fixincludes: Tweaks for LynxOS 2.2.2: accept spaces after # when
	removing #define void int in curses.h; change prototype of fnctl
	in fcntl.h to match POSIX.1.

Thu Sep 22 07:18:37 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* configure: Consistently put specified manufacturer names ahead
	of entries with wildcard manufacturers.

	* calls.c (emit_call_1): Fix typo in last change.

Wed Sep 21 21:32:56 1994  Chris Smith  (csmith@convex.com)

	* config.guess: Add convex c3* and c4* guesses.
	* configure: Don't run fixincludes on convex.

Wed Sep 21 15:59:12 1994  Ashley Saulsbury  (ans@sics.se)

	* alpha.h (ASM_FILE_START): Write .set volatile.

Wed Sep 21 14:45:45 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* calls.c (emit_call_1): Properly add a CLOBBER for sp 
	to CALL_INSN_FUNCTION_USAGE.

	* c-typeck.c (mark_addressable): Give different error if trying
	to put object with volatile fields into register; don't use DECL_NAME.

Wed Sep 21 14:02:10 1994  Jim Wilson  (wilson@cygnus.com)

	* reload1.c (eliminate_regs): Make test in LOAD_EXTEND_OP case
	more precise.

Wed Sep 21 11:34:12 1994  Ian Lance Taylor  (ian@cygnus.com)

	* fixincludes: Don't try to remove empty directories until after
	removing DONE files.

Wed Sep 21 05:52:49 1994  Uwe Seimet  (seimet@chemie.uni-kl.de)

	* m68k/atari.h (NO_{DOLLAR,DOT}_IN_LABEL): Define.

Tue Sep 20 20:06:08 1994  Doug Evans  (dje@cygnus.com)

	* final.c (asm_insn_count): Handle ASM_INPUTs too.

Tue Sep 20 19:32:10 1994  Oliver Kellogg  (okellogg@salyko.cube.net)

	* 1750a.h, 1750a.c, 1750a.md: New files, to use as1750.
	* 1750a/m1750.inc: File deleted.
	* 1750a/ms1750.inc: New file.

Tue Sep 20 17:55:50 1994  Hallvard B Furuseth  (hbf@durin.uio.no)
 
	* cccp.c (make_definition): Enable `-D' with macro arguments.

Tue Sep 20 17:49:47 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* cexp.y (HOST_WIDE_INT, HOST_BITS_PER_WIDE_INT): New macros.
	(expression_value): Now HOST_WIDE_INT.
	(parse_c_expression): Now returns HOST_WIDE_INT.
	* cccp.c (eval_if_expression): Likewise.
	(do_if, do_elif): Reflect new return value of functions.

	* alpha.c (mode_mask_operand): Always return a value.

	* function.c (pop_function_context): Clear reg_renumber.

	* gcc.c (process_command): Add new switch, -dumpmachine.

Tue Sep 20 15:57:40 1994  Jim Wilson  (wilson@cygnus.com)

	* sched.c (sched_analyze_insn): Parameter loop_note type changed
	to rtx, and name changed to loop_notes.  Code adding it to
	REG_NOTES modified to account for type change.
	(sched_analyze): Variable loop_note type changed to rtx, and name
	changed to loop_notes.  Store LOOP_* REG_DEAD notes in it instead
	of LOOP_* NOTE_LINE_NUMBER.
	(schedule_block): Pass last not insn to emit_note_before call.

	* iris5.h (ASM_OUTPUT_UNDEF_FUNCTION): Define.
	(ASM_OUTPUT_EXTERNAL_LIBCALL): Define.
	(ASM_DECLARE_FUNCTION_SIZE): Define.
	* mips.c (mips_output_external): Use ASM_OUTPUT_UNDEF_FUNCTION.
	(mips_output_external_libcall): New function.
	(mips_asm_file_end): Handle ASM_OUTPUT_UNDEF_FUNCTION.
	* README.IRIX5: Update.

Tue Sep 20 14:39:37 1994  Michael Meissner  (meissner@osf.org)

	* i386/i386.h (output_move_memory): Add declaration.
	(output_move_pushmem): Ditto.

	* i386/i386.c (output_move_pushmem): New function to handle
	pushing bytes from memory onto the stack, possibily using
	temporary registers.
	(output_move_memory): New function to handle moving bytes from
	memory to memory via temporary registers.

	* i386/i386.md (movsi insn): If -fpic and the value we are moving
	is a constant pool address, emit a leal instruction instead of
	movl.
	(movsf_push): Allow pushes from memory.
	(SF, DF, XF, DI pushes): Move most of the code to the common
	function output_move_pushmem.
	(SF, DF, XF, DI memory->memory moves): Move most of the code to
	the common function output_move_memory.
	(DI move patterns): Combine DI patterns into two, one for pushes,
	and one for everything else, so that the combiner will combine a
	load with a store into a memory->memory move.
	(untyped_call): Replace non-working code with m68k version that
	emits a regular call, then breaks the parallel moves into separate
	moves, and then issue a blockage instruction.
	(blockage): New unspec_volatile insn to block insns from being
	moved across this point.
	(untyped_return): Delete.
	(update_return): Delete.

	* objc/sendmsg.c (get_imp): Allow __inline__ on x86 platforms.

Tue Sep 20 12:21:12 1994  Ian Lance Taylor  (ian@cygnus.com)

	* fixincludes: Handle the case of a symlink to root/* from a
	subdirectory of another symlink to root/*.

Mon Sep 19 20:30:21 1994  Jason Merrill  (jason@deneb.cygnus.com)

	* fold-const.c (fold): Handle COMPONENT_REFs involving CONSTRUCTORs.

Mon Sep 19 20:25:38 1994  Will Athanasiou  (will@westford.ccur.com)

	* rs6000.md (load sf with update): Fix RTL typo.

Mon Sep 19 08:46:46 1994  Charles M. Hannum  (mycroft@duality.gnu.ai.mit.edu)

	* c-common.c (check_format_info): Enable checking of format
	specifiers using the `q' (quad) length modifier.
	(format_char_info): Add `qlen'.
	(print_char_table, scan_char_table): Add appropriate entries for
	qlen.

Sat Sep 17 12:48:57 1994  Per Bothner  (bothner@kalessin.cygnus.com)

	* stmt.c (mark_seen_cases):  Don't call fatal (or do anything
	else) if case index out of range.  Warning is given later.

Fri Sep 16 19:22:46 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* global.c (global_alloc): Mark regs assigned to SCRATCH as used by
	more than just local alloc.

Thu Sep 15 14:36:59 1994  Michael Meissner  <meissner@pasta.osf.org>

	* i386/i386.c (order_regs_for_local_alloc): Instead of using
	flag_cse_follow_jumps and not leaf_function_p to determine whether
	to allocate EDX, and ECX before EAX, use whether or not a DImode
	variable was used in the compilation.  DImode variables seem to
	cause spill failures if EAX is allocated first, while smaller code
	is generated if EAX is allocated first, assuming no spill failure.

	* i386/i386.md (SF, DF, XF, and DI moves and pushes): Eliminate
	special patterns for TARGET_386 that allow direct pushes from
	memory, and instead allow direct pushes from memory as the last
	alternative in case no scratch registers could be allocated.
	(movxf_mem): Remove inadvertent !TARGET_386 condition.
	(addsi3): Allow generation of lea on 486, since the single
	instruction lea is at least as fast as the mov and add it
	replaces.
	(zero extend patterns): Replace !TARGET_486 with TARGET_386.
	(bit extracts): Ditto.

	* i386/osfrose.h (LONG_DOUBLE_TYPE_SIZE): Don't redefine to be 64
	unless NO_LONG_DOUBLE is defined.

Thu Sep 15 13:46:05 1994  Jim Wilson  (wilson@cygnus.com)

 	* expmed.c (store_split_bit_field): Use number of bits in arg not
	BITS_PER_WORD to adjust arg in BYTES_BIG_ENDIAN case.

Thu Sep 15 09:19:12 1994  Richard Earnshaw (rwe@pegasus.esprit.ec.org)

	* optabs.c (expand_binop, multi-word shifts): Generate rtl
	free of conflicts for shifts less than one word.

Thu Sep 15 05:29:58 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* gcc.c: Rework last change so it's done like collect2.c.

	* cse.c (cse_around_loop): Don't invalidate SUBREG unless 
	it's a SUBREG of a REG.

	* sched.c (sched_analyze_insn): Don't set SCHED_GROUP_P for previous
	INSN a USE unless it's a USE of a REG.

Wed Sep 14 10:08:58 1994  Michael I Bushnell  <mib@churchy.gnu.ai.mit.edu>

	* gcc.c: Include <sys/errno.h> in case `errno' is really a macro
	as permitted by ANSI C.  

	* getpwd.c (GUESSPATHLEN): If there is no definition of
	MAXPATHLEN, then set GUESSPATHLEN to be 100.  (It's used
	as a starting point, not a limit, so this is harmless.)

Tue Sep 13 15:02:19 1994  Michael Meissner  <meissner@pasta.osf.org>

	* i386/i386.md (movxf_mem): Fix typo with memory/memory moves
	of XFmode variables, where the store actually did a load, ie, the
	source and destination operands were fixed.
	(fixuns_trunc patterns): Revert to the old code.
	(movdf_push486, movxf_push486, movdi_push486): If an address is
	based on the stack pointer, account for the stack pointer changing
	due to the intermediate pushes generated.

Tue Sep 13 14:11:16 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* collect2.c (fatal_perror, fatal, error): Declare all args as char *.

Tue Sep 13 12:40:39 1994  Jeffrey A. Law  (snake.cs.utah.edu)

	* pa.c (emit_move_sequence): Handle secondary FP load/store
	reloads of the form (subreg (mem (plus (reg) (disp)))).
	(secondary_reload_class): A secondary register is needed to handle
	out-of-range FP loads and stores.
	* pa.md (reload_indf, reload_outdf): New expanders.
	(reload_insf, reload_outsf): Likewise.

Mon Sep 12 18:15:48 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* t-pa (ADA_CFLAGS): New override.
	* pa/t-pa-hpux: New file.
	* configure (hppa*-*-hpux*): Use t-pa-hpux instead of t-libc-ok.

Mon Sep 12 14:52:17 1994  Jim Wilson  (wilson@cygnus.com)

	* function.c (assign_parms): Set RTX_UNCHANGING_P on stack_parm
	for const parameter before calling move_block_from_reg.

Mon Sep 12 14:27:58 1994  Doug Evans  (dje@cygnus.com)

	* config/fp-bit.c (FLO_union_type): Add packed attribute to `bits'.

Sat Sep 10 09:50:41 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* cse.c (invalidate_for_call): Properly set IN_TABLE.

Sat Sep 10 06:46:24 1994  Bill Burton  (billb@progress.com)

	* Added improved support for Sequent DYNIX/ptx 1.x and 2.x:
	* fixinc.ptx: New file.
	* i386/seq-sysv3.h (HAVE_ATEXIT): No longer defined.
	* i386/seq2-sysv3.h: New file.
	* configure (i[34]86-sequent-ptx[12]*): New configurations.
	(i[34]86-sequent-sysv*, i[34]84-sequent-ptx): Deleted configurations.
	* config.sub (ptx): New OS; use for Sequent.

Fri Sep  9 21:48:48 1994  Paul Eggert  (eggert@twinsun.com)

	* cccp.c (rescan, handle_directive): Backslash no longer suppresses the
	specialness of the following char unless -traditional.
	(rescan): Remove backslash-newline only if at top level, since
	backslash-newline-space can be encountered during macro processing.
	(collect_expansion): Remove special hack for \# inside a #define;
	it's not compatible with the C Standard.

Thu Sep  9 17:36:03 1994  Jason Merrill  (jason@deneb.cygnus.com)
 
	* Utilize OSF/1's limited .init support.
	* alpha/alpha.h (HAS_INIT_SECTION): Define.
	(LINK_SPEC): Add '-init __main'.
	* alpha/osf12.h (LINK_SPEC): Ditto.
 
	* function.c (expand_main_function): Don't call __main if
	HAS_INIT_SECTION is defined.

Fri Sep  9 16:36:46 1994  Mike Stump  (mrs@cygnus.com)

	* tree.c (decl_function_context): Don't treat C++ member
	functions of classes declared in a function, as nested functions.

Fri Sep  9 16:10:25 1994  Steve Chamberlain  (sac@jonny.cygnus.com)

	* sh/sh.c (prepare_move_operands): Generate better DI constant 
	code.
	(fake_shift): New function.
	* sh/sh.md (ashlsi3_n, lshrsi3_n): Only recognise if fake_shift
	enabled.
	* sh/{lib1funcs.asm, ashlsi3.c, lshrsi3.c, ashrsi3.c} : New files.
	* sh/t-sh : Build new files.

Fri Sep  9 15:52:54 1994  Hallvard B Furuseth  (h.b.furuseth@usit.uio.no)

	* cccp.c: Correct unprototyped pointer args from `0' to `NULL_PTR'

Fri Sep  9 15:17:52 1994  Matthew Green  (mrg@splode.mame.mu.oz.au)

	* configure (sparc-*-netbsd): New configuration.
	* sparc/netbsd.h: New file.

Fri Sep  9 15:15:48 1994  Jim Wilson  (wilson@cygnus.com)

	* mips.md (truncdisi2): Change from define_expand to define_insn.
	(truncdihi2, truncdiqi2): Likewise.

	* sparc.h (SQRTTF2_LIBCALL): Delete.
	(INIT_TARGET_OPTABS): Define.
	(INIT_SUBTARGET_OPTABS): Define.

	* stmt.c (check_for_full_enumeration_handling): Cast malloc result
	to `unsigned char *' not `char *'.

	* dbxout.c (dbxout_symbol_location): Handle error_mark_node in
	DECL_INITIAL for C++.

	* mips.md (memory): Add missing !r4600 to first define_function_unit.

	* sparc.md (negsi2): Use register_operand not general_operand for
	output.

Fri Sep  9 14:52:58 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* config/netbsd.h: Add #undef for everything we define; a few were
	missing.

	* reload.c (find_reloads, case 'p'): Operand is BASE_REG_CLASS.

Fri Sep  9 14:00:28 1994  Mike Collison  (collison@world.std.com)

	* configure (dsp16xx-*): New configuration.
	* config.sub (dsp16xx): New basic machine.
	* dsp16xx.c, dsp16xx.md, dsp16xx.h, xm-dsp16xx.h: New files.

Fri Sep  9 12:47:00 1994  Michael Meissner  (meissner@osf.org)

	* i386/i386.md (All SF, DF, XF, DI 486 push patterns): Merge the
	memory and nonmemory push patterns together.

Fri Sep  9 00:53:36 1994  Richard Stallman  <rms@mole.gnu.ai.mit.edu>

	* config.sub: Accept i586 like i386.
	Do not use SCO as a default for i386-*.

Thu Sep  8 18:49:35 1994  Steve Chamberlain  (sac@cygnus.com)

	* config/fp-bit.c (_fpmul_parts):  Perform optimized
	64bit*64bit multiply correctly.
	* sh/sh.c (synth_constant): Ensure DI mode constants get their
	high part zeroed.
	(add_constant):  Entabled constants are only identical if their
	sizes are the same.

Thu Sep  8 14:40:31 1994  Jim Wilson  (wilson@cygnus.com)

	* flow.c (mark_used_regs, case REG): Correct typo, use GET_MODE
	not GET_CODE.
	* sched.c (attach_deaths): Likewise.

Tue Sep  6 23:33:41 1994  Per Bothner  (bothner@kalessin.cygnus.com)

	* tree.c (get_set_constructor_bits, get_set_constructor_words):
	New functions.  Extract bits or words from SET_TYPE CONSTRUCTOR.
	* tree.h:  Declare above new functions.

Thu Sep  8 14:02:05 1994  Michael Meissner  (meissner@osf.org)

	* 386/i386.h (TARGET_OPTIONS): New macro to define -mreg-alloc=
	switch to allow users to override the register allocation order.
	(OVERRIDE_OPTIONS): Call the function override_options.
	(REG_ALLOC_ORDER): Define to allocate in the natural order, this
	is needed for ORDER_REGS_FOR_LOCAL_ALLOC to work.
	(ORDER_REGS_FOR_LOCAL_ALLOC): Define to call the function
	order_regs_for_local_alloc.
	(regclass_map): Move declaration to end of file.
	(i386_compare_op0, i386_compare_op1): Ditto.
	(CLASS_LIKELY_SPILLED_P): Define, return 1 for AD_REGS in addition
	to all of the single register classes, since AD_REGS is only used
	to allocate EAX:EDX.
	(override_options, order_regs_for_local_alloc): Add declarations.
	(hi_reg_name): Add declaration.
	(qi_reg_name): Ditto.
	(qi_high_reg_name): Ditto.
	(i386_reg_alloc_order): Add declaration for TARGET_OPTIONS to use.

	* i386/i386.c (i386_compare_op0, i386_compare_op1): Initialize
	with NULL_RTX.
	(i386_reg_alloc_order):  Provide global variable definition.
	(regs_allocated): Static array to note whether a register is noted
	via -mreg-alloc=<xxx>.
	(override_options): Provide checking for registers declared with
	-mreg-alloc=<xxx>.
	(order_regs_for_local_alloc): If -mreg-alloc=<xxx> was used,
	allocate registers mentioned in order, and then allocate all other
	registers in the normal register order.  If -mreg-alloc=<xxx> was
	not used, allocate registers in natural order except for non-leaf
	functions with CSE following jumps, allocate EAX after EDX and
	ECX, to allow the function return to be CSE'd, and perl 4.036's
	perly.y to be compiled without aborting due to not being able to
	find a spill register.
	(movsf, movdf, movdi): Rewrite all patterns to provide effecient
	memory to memory moves, including pushes for i386 and i486.  Fixes
	problems in compiling motif+ without optimization.
	(swapsf): Add, like swapdf and swapxf.
	(fixuns_truncsfsi2, fixuns_truncdfsi2): Use general_operand
	instead of register_operand for define_expand, since the operand
	is copied to a new pseudo register as part of the expansion.
	(fix_truncxfdi2, fix_truncdfdi2, fix_truncsfdi2): Rewrite to call
	the more primitive generator functions instead of knowing how many
	clobbers of match_scratchs they do.

	* Makefile.in (aux_output.o): Define TARGET_CPU_DEFAULT if
	specified when compiling aux_output.o to allow the machine C file
	access to this if it wants it.

Thu Sep  8 07:15:29 1994  David Edelsohn  (edelsohn@npac.syr.edu)

	* rs6000.md (movsi matcher): Merge TARGET_POWER and !TARGET_POWER
	cases.  Rationalize mnemonics.
	(movhi and movqi matchers): Likewise.
	(movsf matcher): Correct length attribute for stfs which no longer
	includes frsp.

Thu Sep  8 07:06:31 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* rs6000.h (REGISTER_MOVE_COST): Fix typo in last change.

Wed Sep  7 19:31:52 1994  Paul Eggert  (eggert@twinsun.com)

	* cccp.c (handle_directive): In `#include <xxx>' directives,
	remove backslash-newline properly.  Don't allow any other newlines.

Wed Sep  7 18:11:29 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* rs6000.h (REGISTER_MOVE_COST): Moving between special registers
	is expensive.

	* combine.c (simplify_comparison): Convert comparison to unsigned
	when stripping off a ZERO_EXTEND.

	* combine.c (simplify_set): Only convert IF_THEN_ELSE to logical
	expression if mode of object being compared is result mode.

Wed Sep  7 18:09:17 1994  David J. MacKenzie  (djm@geech.gnu.ai.mit.edu)

	* configure: Ignore --help, --version, --program-prefix,
	--program-suffix, --cache-file, --quiet, --silent.

Wed Sep  7 13:29:50 1994  Doug Evans  (dje@cygnus.com)

	* stmt.c (expand_asm_operands): Move test for misspelled registers
	higher so all cases caught.

Wed Sep  7 09:54:14 1994  Per Bothner  (bothner@kalessin.cygnus.com)

	* configure:  Touch Makefile.ll before appending subdir stuff.
	(Needed if there are no subdirs.)

Wed Sep  7 11:19:18 1994  Kresten Krab Thorup  (krab@akvavit.next.com)

	* objc/init.c (__objc_init_protocols): Remove assertion.
	* objc/Object.m (conformsTo:): Make lookup allways happen in
	the class object.

Tue Sep  6 17:47:39 1994  Per Bothner  (bothner@kalessin.cygnus.com)

	* configure:  Rename *-next-ns[23] to *-next-nextstep[23].
	* config.sub:  Cleanup NeXT support to emit nextstep*.

Tue Sep  6 18:38:02 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* reload.c (find_reloads_address): Don't reorder the operands of a
	PLUS when fixing up index.

Tue Sep  6 18:24:50 1994  Matthias Pfaller  (leo@marco.de)

	* ns32k.md (stackadjust/push peepholes): For the adjust/push/push
	pattern one offset was wrong.
	Don't use addr for register and and MEM refs.

Tue Sep  6 11:24:06 1994  Steve Chamberlain  (sac@jonny.cygnus.com)

	* sh/sh.c (push, pop): Generate REG_NOTES.
	(synth_constant): Correct one of the patterns.
	(output_file_start): Bump version number.
	* sh/sh.h (EXIT_IGNORE_STACK): Now 1.
	* sh/sh.md (adddi3, subdi3): Simplify.
	(casesi_worker): Use TARGET_BIGTABLE.

Mon Sep  5 12:29:15 1994  Ian Lance Taylor  (ian@cygnus.com)

	* ginclude/math-68881.h: Change inline functions from static to
	extern.

	* configure (i[34]86-*-sysv4*): If --with-stabs, set tm_file to
	i386/sysv4gdb.h.
	* config/i386/sysv4gdb.h: New file; sets PREFERRED_DEBUGGING_TYPE.

Sun Sep  4 08:40:02 1994  Chris Smith  (csmith@convex.com)

	* convex.h (VTABLE_USES_MASK, VINDEX_MAX, SET_DECL_VINDEX):
	delete, no longer used.
	(target_flags): delete cexp.c hack, no longer needed.
	* convex.md (decr-and-set-cc0): fix HImode to use halfword
	insns.
	(cmpqi patterns): fix constraints not to use A regs

Sat Sep  3 14:12:11 1994  Michael Meissner  (meissner@osf.org)

	* i386/i386.md (DImode move and push insns): Eliminate movdi
	wrapper that made a DI temp register to do a memory to memory
	move because it creates too much register pressure, especially
	when not optimizing.  On the 486, allocate and use 1-2 scratch
	registers to push a DImode value.

Fri Sep  2 15:11:59 1994  Jason Merrill  (jason@deneb.cygnus.com)
 
        * c-decl.c (min_precision): Move from here.
        * c-common.c: To here.

Fri Sep  2 13:16:38 1994  Per Bothner  (bothner@kalessin.cygnus.com)

	* tree.h (maximum_field_alignment, set_alignment):  New declarations.

Fri Sep  2 14:25:36 1994  Ian Lance Taylor  (ian@cygnus.com)

	* config/svr4.h (DBX_DEBUGGING_INFO, PREFERRED_DEBUGGING_TYPE,
	DBX_BLOCKS_FUNCTION_RELATIVE, ASM_IDENTIFY_GCC,
	ASM_IDENTIFY_GCC_AFTER_SOURCE, ASM_OUTPUT_SOURCE_LINE,
	DBX_FUNCTION_FIRST): Define.  This adds support for -gstabs for
	SVR4 configurations.  -gstabs requires gas and gdb.
	* config/sparc/sol2.h (DBX_DEBUGGING_INFO,
	DBX_BLOCKS_FUNCTION_RELATIVE, ASM_IDENTIFY_GCC,
	ASM_IDENTIFY_GCC_AFTER_SOURCE, ASM_OUTPUT_SOURCE_LINE,
	DBX_FUNCTION_FIRST): Don't define.  Now defined by config/svr4.h.
	(PREFERRED_DEBUGGING_TYPE): Undefine before defining.
	* config/sparc/sysv4.h (DBX_DEBUGGING_INFO): Don't bother to
	undefine before including svr4.h.
	(ASM_OUTPUT_SOURCE_LINE): Undefine before including svr4.h.

Thu Sep  1 22:02:02 1994  Michael Meissner  (meissner@osf.org)

	* toplev.c (fatal_insn): Move most of the code from
	fatal_insns_not_found here, and add an argument to give the error
	message.
	(fatal_insn_not_found): Call fatal_insn.
	* rtl.h (fatal_insn, fatal_insn_not_found): Add prototypes.
	* genextra.c (main): Don't declare fatal_insn_not_found in
	insn-extract.c.
	* reload1.c (reload): Call fatal_insn where appropriate to print
	an error message instead of calling abort.
	(spill_failure): Ditto.
	(reload_as_needed): Ditto.
	(allocate_reload_reg): Ditto.
	(emit_reload_insns): Ditto.

Thu Sep  1 19:34:26 1994  Jason Merrill  (jason@deneb.cygnus.com)
 
        * tree.c (type_list_equal): If the types of the default arguments
        differ, the lists do not match.
 
Thu Sep  1 19:29:58 1994  Matthias Pfaller  (leo@marco.de)

	* ns32k.md (stack-adjust/push peepholes): Addresses are
	moved with "addr", not with "movd".

Thu Sep  1 19:17:55 1994  Paul Eggert  (eggert@twinsun.com)

	* cccp.c (make_definition): Don't dump core when given an
	unterminated string in a -D option.

Thu Sep  1 19:13:35 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* c-typeck.c (convert_arguments): Give proper warnings when
	converting COMPLEX_TYPE; widen check to include all integral types.

Wed Aug 31 20:38:53 1994  Per Bothner  (bothner@spiff.gnu.ai.mit.edu)

	* fixproto:  Define FIX_HEADER (needed by Aug 19 change).
	Use FIX_HEADER instead of $original_dir/fix-header (twice).

Wed Aug 31 16:56:15 1994  Jason Merrill  (jason@deneb.cygnus.com)
 
        * stmt.c (warn_if_unused_value): Extend special case for casted
        MODIFY_EXPRs to apply to INIT_EXPRs as well.
 
Wed Aug 31 16:30:09 1994  Per Bothner  (bothner@kalessin.cygnus.com)

	* stor-layout.c (set_alignment):  New global.
	(layout-type):  Add support for SET_TYPE.

	* expmed.c (store_bit_field):  Semi-revert Aug 25 change:
	Make it apply only for BLKmode, not integral modes.

	* stmt.c (all_cases_count, mark_seen_cases):  New functions.
	(BITARRAY_TEST, BITARRAY_SET):  New macros.  Used (mainly by
	Chill) to check all cases are covered (for enums and ranges).
	(check_for_full_enumeration_handling):  Re-write to use the
	new functions, now that we have them.

Wed Aug 31 19:19:29 1994  Richard Earnshaw  (rwe@pegasus.esprit.ec.org)

	* combine.c (nonzero_bits, cases DIV, MOD, UDIV, UMOD): Declare
	op0_maybe_minusp and op1_maybe_minusp as HOST_WIDE_INT.

Wed Aug 31 18:54:54 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* expmed.c (store_split_bit_field): Always adjust arg to 
	extract_fixed_bit_field in BYTES_BIG_ENDIAN case.

Wed Aug 31 02:49:34 1994  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* config/i386/gnu.h (LIB_SPEC): New macro.

Tue Aug 30 16:35:23 1994  Jason Merrill  (jason@deneb.cygnus.com)
 
        * toplev.c (lang_options): Add -W{no-,}reorder.
 
Tue Aug 30 13:55:58 1994  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* combine.c (simplify_comparison, case GEU): Add missing break.

Mon Aug 29 17:50:55 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* vax.md (extv, extzv): Don't use ROTL when field is outside
	boundaries of a word.

Mon Aug 29 11:43:18 1994  Kresten Krab Thorup  (krab@akvavit.next.com)

	* objc/sendmsg.c (get_imp): Don't inline on 386.

Sun Aug 28 18:56:03 1994  Andrew McCallum (mccallum@cs.rochester.edu)

	* objc/class.c (objc_get_meta_class):  New function.

Sat Aug 27 23:13:53 1994  Michael Meissner  (meissner@osf.org)

	* i386/i386.c (legitimate_address_p): If index register is either
	the arg pointer or the stack pointer, and there is no scale
	factor, swap with the base register.

	* i386/i386.h (REG_CLASS_CONTENTS): Don't allow the arg pointer
	register as an index register, since the frame could be omitted,
	and the stack pointer is not valid as an index.

	* i386/i386.md (mov*, movstrict*): Don't create pushes of memory
	values when creating insns, let the combiner create a push of a
	memory value if -m386.  In particular, pushes of byte values was
	broken because there is no pattern to recognize such a push.

Fri Aug 26 16:03:09 1994  Michael Meissner  (meissner@osf.org)

	* i386/i386.h (MASK_*): Add masks for all of the switches.
	(TARGET_*): Use appropriate MASK_* instead of a number.  Add
	-mdebug-addr switch to debug GO_IF_LEGITIMATE_ADDRESS,
	-mno-wide-multiply to turn off widening multiplies, and -mno-move
	to allow integer move insns to generate direct memory to memory
	copies, which reload will fix up.  Add TARGET_386 which is not of
	TARGET_486.
	(REG_ALLOC_ORDER): Go to the order used in 2.5.8, eax, edx, ecx, ...
	Add a comment describing the tradeoffs.
	(REG_OK*): Add strict and non-strict versions of the macros that
	are always present, and REG_OK_STRICT chooses between the two
	inner macros.
	(GO_IF_LEGIMATE_ADDRESS): Move processing to legitimate_address_p
	function.
	(LEGITIMIZE_ADDRESS): Move processing to legitimize_address
	function.
	(function declarations): Add function declarations for all extern
	functions in i386.c.

	* i386/i386.c (asm_add): Add support in case adding by 1 or -1 to
	use inc/dec.
	(various): Change TARGET_486 -> !TARGET_386.
	(legitimate_address_p): Move GO_IF_LEGITIMATE_ADDRESS processing
	here from i386.h.  Combine OSF/rose support from osfrose.h through
	the use of conditional macros.  Only recognize addresses in
	canonical formats, code adapted from the i960 port.  Add tracing
	if -mdebug-addr.
	(legitimize_address): Move LEGITIMIZE_ADDRESS here from i386.h,
	and add adaptations from the i960 port.
	(convert_387_op): Remove unused function.

	* i386/i386.md (various): Remove cast to char * of output
	functions, since i386.h now declares them all properly.  Change
	TARGET_486 tests to !TARGET_386 and !TARGET_486 to TARGET_386.
	(movsi, movstricthi, movhi, movstrictqi, movqi, movdi): Add
	define_expand wrappers to prevent memory<->memory moves from being
	generated unless -mno-move is used.  On 486's do not allow push of
	memory insns to be generated unless -mno-move.
	(movdi): For movdi patterns, add 2 (clobber (match_scratch...))
	declarations to allow memory<->memory moves with non-contigous
	registers, so that reload don't abort if it can't make a DI
	register.
	(umulsidi3, mulsidi3): Don't allow pattern if -mno-wide-multiply.
	(smultsi3_highpart, umultsi3_highpart): Add patterns to make
	division by constants generate better code.

	* i386/osfrose.h (MASK_*): Use octal to define bitmasks, not hex,
	for compatibility with i386.h.
	(NO_IMPLICIT_EXTERN_C): Define.
	(LONG_DOUBLE_TYPE_SIZE): Explicitly define to be 64 instead of
	just #undef'ing it.
	(GO_IF_LEGITIMATE_ADDRESS): Delete, merged with common i386 code.
	(ASM_FILE_END): Print -fschedule-insns and -fschedule-insns2 in
	ident string if those options are used.
	(REAL_LD_FILE_NAME): Delete.
	(ASM_OUTPUT_DOUBLE): Delete, use the common macros.
	(ASM_OUTPUT_FLOAT): Ditto.
	(ASM_OUTPUT_LONG_DOUBLE): Ditto.

Thu Aug 25 17:15:18 1994  Per Bothner  (bothner@kalessin.cygnus.com)

	* expmed.c (store_bit_field):  Always store into multi-word
	bitfields starting with low addresses.  (Old code was
	incompatible with operand_subword_force on big-endian targets.)

Thu Aug 25 18:31:20 1994  Antti Miettinen  (amiettin@ntc.nokia.com)

	* m68k/lynx.h (CALL_USED_REGS): Add d2 and d3 as call-used.

Thu Aug 25 11:30:44 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* cse.c (record_jump_cond): Don't do anything if OP0 and OP1
	are already equivalent.

	* rtlanal.c (may_trap_p, case EXPR_LIST): New case.

	* c-common.c (shorten_compare): Don't issue warning if both
	operands constants and the signedness doesn't affect the 
	comparison results.

	* configure: Refine handling and error-checking of positional args.

	* print-tree.c (print_node): Print more flags for types and decls.

	* c-typeck.c (type_lists_compatible_p): Treat transparent unions
	just like unnamed ones.

Wed Aug 24 19:34:52 1994  Charles Hannum  (mycroft@duality.gnu.ai.mit.edu)

	* configure: Rearrange handling of NetBSD ports to use the standard
	`cpu-vendor-os' format.
	* config.sub: Recognize names of NetBSD ports that do not correspond
	to a CPU name.

Wed Aug 24 18:43:30 1994  Philippe De Muyter (phdm@info.ucl.ac.be)

	* print-tree.c (print_node_brief, print_node): Use assignment instead
	of initialization for aggregate local variable REAL_VALUE_TYPE d.

Wed Aug 24 18:28:52 1994  Ian Lance Taylor  (ian@cygnus.com)

	* config/svr4.h (ASM_OUTPUT_SECTION_NAME): Define.
	* config/sparc/sysv4.h (ASM_OUTPUT_SECTION_NAME): Output #alloc to
	set SHF_ALLOC in section flags.

Wed Aug 24 17:45:19 1994  Jim Wilson  (wilson@sphagnum.cygnus.com)

	* c-parse.in (parmlist_2): Give error for function with only
	ELLIPSIS as an argument.

Wed Aug 24 17:36:22 1994  H.J. Lu (hjl@nynexst.com)

	* i386/linux.h (STARTFILE_SPEC): Add %{static:-static}.

Wed Aug 24 14:34:37 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* calls.c (expand_call): Check for variable-sized return value
	in proper place.

	* c-typeck.c (default_conversion): Don't substitute constant
	value if array since will return address.

	* configure (LANG_MAKEFILE): Include lang/Makefile.in in list.

	* alpha.h (EXTRA_CONSTRAINT): Add new letter, `R'.
	(ENCODE_SECTION_INFO): Don't check TREE_ASM_WRITTEN.
	(PREDICATE_COSTS): Add call_operand.
	* alpha.c (call_operand): New function.
	(output_epilog): Don't set SYMBOL_REF_FLAG of current function.
	* alpha.md (call): Rework to use macro version of jsr.
	* osf2.h (LINK_SPEC): Don't define; should never have been.

	* c-typeck.c (push_init_level): Don't blow up if construct_type
	is null (can happen with missing brace).

Wed Aug 24 10:49:35 1994  Michael Meissner  (meissner@osf.org)

	* i386/i386.h (REG_ALLOC_ORDER): Restore previous version which
	allocates edx first, then ecx, eax, ...  This is because perl
	doesn't build when the order is eax, ecx, edx...

Tue Aug 23 09:20:16 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* configure: Restore old behavior of positional arguments.
	Add new argument, --noguess.
	config.guess now guesses BUILD, not HOST; HOST defaults from BUILD.
	Always compare canonical names, not user-specified names.
	Numerous minor changes in the messages output to make the
	configuration chosen clearer.

Tue Aug 23 02:01:42 1994  Richard Stallman  <rms@mole.gnu.ai.mit.edu>

	* config.sub: Move m68k-ccur handling to proper part of file.
	Canonicalize cpu type pentium into i486.  (Change it to i586 later.)

Mon Aug 22 18:41:59 1994  Steve Chamberlain  (sac@jonny.cygnus.com)

	* sh/sh.c (find_barrier):  Calculate the size of larger than
	SI moves correctly.
	(general_movsrc_operand): Allow label_refs plus const.
	(sh_function_arg_partial_nregs, sh_function_arg): Pass BLKmode
	objects in partial regs.
	* sh.h (TARGET_DEFAULT): Turn off BIGTABLE_BIT.
	(EXTRA_CONSTRAINT_Q): Allow label_refs plus const.
	(READONLY_DATA_SECTION_ASM_OP, EXTRA_SECTIONS, rdata_section):
	Delete rdata section and refs.
	* sh.md (dimode split): Don't allow a Q constraint source.

Sun Aug 21 23:15:35 1994  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* pa.h (FUNCTION_ARG): Use indirect calling conventions when
	TARGET_LONG_CALLS is in effect.

Sat Aug 20 13:31:34 1994  Jim Wilson  (wilson@cygnus.com)

	* sched.c (sched_analyze_insn): Add new parameter loop_note.
	If loop_note set, then serialize on this insn.
	(sched_analyze): New variable loop_note.  Pass to
	sched_analyze_insn.  Set it if we pass a NOTE_INSN_LOOP_BEG or
	NOTE_INSN_LOOP_END.
	(unlink_notes): Don't save away NOTE_INSN_LOOP_BEG or
	NOTE_INSN_LOOP_END notes.
	(schedule_block): Generalize code that looks for magic REG_DEAD
	notes and converts them to notes.

Sat Aug 20 12:47:21 1994  Michael Meissner  (meissner@osf.org)

	* i386.h (REG_ALLOC_ORDER): Allocate eax first, then ecx, edx, and
	then do the nromal allocation order for the remaining registers.

Fri Aug 19 20:14:35 1994  Jim Wilson  (wilson@cygnus.com)

	* tree.c (build_type_variant): Only return existing type if it
	also has the same TYPE_NAME.

	* irix5.h (NO_IMPLICIT_EXTERN_C): Comment out.

Fri Aug 19 16:41:43 1994  Per Bothner  (bothner@kalessin.cygnus.com)

	* fixproto:  Use $FIX_HEADER macro instead of calling
	fix-header directly in 2nd location.

Fri Aug 19 17:34:19 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* expr.c (emit_move_insn_1): Never make a no-conflict block.

	* tree.h (struct tree_type): New field transparent_union_flag.
	(struct tree_decl): New field transparent_union.
	({DECL,TYPE}_TRANSPARENT_UNION): New macros.
	* c-common.c (decl_attribute): Handle "transparent_union" attribute.
	* function.c (assign_parms): If parm is transparent union, use
	type of first field.
	* calls.c (expand_call): Likewise.
	* integrate.c (function_cannot_inline): Don't inline if any
	parm is a transparent union.

Fri Aug 19 12:01:11 1994  Ian Lance Taylor  (ian@cygnus.com)

	* fixincludes: Canonicalize ${INPUT} to avoid automounter
	problems.

Fri Aug 19 11:31:24 1994  Kresten Krab Thorup  (krab@akvavit.next.com)

	* objc-act.c (build_selector_translation_table): Reset
	current_function_decl after hack_function_prototype build it.
	(build_module_descriptor): Return constructor name from functions
	decl_rtl. 

Thu Aug 18 17:23:18 1994  Per Bothner  (bothner@spiff.gnu.ai.mit.edu)

	* README.FRESCO:  New file.  Notes about compiling the Fresco
	toolkit with g++.

Thu Aug 18 14:10:22 1994  Jim Wilson  (wilson@cygnus.com)

	* combine.c (distribute_notes, case REG_UNUSED): Ignore notes when
	from_insn != i3 only if the notes would remain as REG_UNUSED notes.

Wed Aug 17 18:31:43 1994  Holger Teutsch  (holger@hotbso.rhein-main.de)

	* clipper.h (CLIPPER_ARG_SIZE): Return size in bytes.
	(FUNCTION_ARG_ADVANCE): Fix argument alignment processing.

Wed Aug 17 18:03:54 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* fx80.md (casesi_2): Operand 0 is HImode; add SIGN_EXTEND
	when adding to pc.
	(casesi): Operand 0 is HImode.
	(unnamed PC addition pattern): Add SIGN_EXTEND to add HImode
	offset to SImode PC.
	* m68k.md (tablejump): Add SIGN_EXTEND to HImode offset
	so can add to SImode PC.
	Likewise for matching pattern.
	* cse.c (fold_rtx): When folding tablejump, allow LABEL_REF
	to be in arg0; also allow other arg to be MINUS, not just be
	equivalent to it.

Mon Aug 15 19:19:11 1994  Paul Eggert  (eggert@twinsun.com)

	* cccp.c (index0): New function.
	(trigraph_pcp): Use index0 instead of index, so that a null
	byte doesn't suppress further trigraph preprocessing.

	* cccp.c (rescan, do_ident): Pass more accurate size request
	to check_expand.

	* cccp.c (main): Don't dump core if given -pcp, -MD, or -MMD
	without following arg.

Mon Aug 15 17:56:38 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* stmt.c (expand_elseif): New function.

Mon Aug 15 14:16:18 1994  Ian Lance Taylor  (ian@cygnus.com)

	* configure: If the host is guessed, and the target name is a
	prefix of the host name, then use the target name as the host
	name.

Mon Aug 15 13:35:24 1994  Stan Shebs  (shebs@andros.cygnus.com)

	* m68k/m68k-coff.h: New file.

Sun Aug 14 00:28:15 1994  Andrew McCallum  (mccallum@vein.cs.rochester.edu)

	* objc/encoding.c (objc_sizeof_type): Assign from ROUND,
	don't increment.  Remove ; after while to fix infinite loop.
	Add float and double cases.
	(objc_alignof_type):  Add float and double cases.
	* objc/selector.c (): Use __objc_selector_names, not
	__objc_selector_array.
	(sel_types_match): New function.
	(sel_get_typed_uid): Use sel_types_match.  Change strcmp to !strcmp.

Sun Aug 14 21:54:29 1994  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* pa.h (ASM_OUTPUT_ALIGNED_COMMON, ASM_OUTPUT_ALIGNED_LOCAL):
	Define.
	(ASM_OUTPUT_COMMON, ASM_OUTPUT_LOCAL): Delete.

	* pa.c (hppa_expand_prologue): Avoid writing outside the current
	stack boundary in code to handle large stack frames.

Sun Aug 14 18:55:51 1994  Jim Wilson  (wilson@cygnus.com)

	* unroll.c (loop_iterations): Use PREV_INSN not prev_nonnote_insn.

	* bsd-5.h (ASM_OUTPUT_NEWLINE): Delete.
	(ASM_OUTPUT_ASCII): Define.
	* mips-5.h, svr3-5.h, svr4-5.h: Likewise.
	* mips.h (ASM_OUTPUT_NEWLINE): Delete.
	(ASM_OUTPUT_ASCII): Don't use ASM_OUTPUT_NEWLINE.

	* va-mips.h (va_start): Add cast to __gnuc_va_list type.

	* flow.c (mark_used_regs): When adding REG_DEAD notes, check for
	the case where a multiple register hard reg overlaps a register
	set by the insn.
	* sched.c (attach_deaths): Likewise.
	* combine.c (distribute_notes, case REG_DEAD): Add another
	find_reg_fusage call.

	* unroll.c (calculate_giv_inc): Handle constants loaded with IOR.

Sun Aug 14 16:40:04 1994  Richard Stallman  <rms@mole.gnu.ai.mit.edu>

	* cccp.c (skip_if_group): New arg op.  All callers changed.
	If output_conditionals is true, output text of failed conditionals.
	(conditional_skip): New arg op.  All callers changed.
	(main): Handle -ifoutput option.

Sun Aug 14 05:49:29 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* print-tree.c (print_node{,_brief}): Use REAL_VALUE_TO_DECIMAL
	to print REAL_CST ifdef REAL_ARITHMETIC.

	* reload1.c (count_possible_groups) Pass CLASS as arg and only
	try to find groups of that class.

	* configure: If config.guess fails and target specified, use as host. 
	Print a message when making a cross-compiler.

Sat Aug 13 17:12:30 1994  Jim Wilson  (wilson@cygnus.com)

	* configure (sparc-*-sunos4.0*): New configuration.
	* t-sunos4: Rename file to t-sunos41.
	* t-sunos40: New file.

Sat Aug 13 13:50:22 1994  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* reload1.c (emit_reload_insns): Handle a secondary input reload
	which needs to use secondary memory too.

Fri Aug 12 18:53:24 1994  Ian Lance Taylor  (ian@cygnus.com)

	* mips/mips.c (override_options): If neither -mcpu= nor -mipsN was
	used, and MIPS_CPU_DEFAULT is defined, set mips_cpu to
	MIPS_CPU_DEFAULT and set mips_cpu_string to
	MIPS_CPU_STRING_DEFAULT.

Fri Aug 12 10:54:35 1994  Stan Cox  (coxs@dg-rtp.dg.com)

	* m88k/dgux.h, m88k/dguxbcs.h (ASM_SPEC,CPP_SPEC): 
	Made -pipe work for -msvr4. Added -D*_TARGET definitions.

	* m88k.c (emit_bcnd): Improved code generated by changing cmp/bbx
	instruction pair to single bcnd instruction

Fri Aug 12 07:52:20 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* cse.c (set_nonvarying_address_components): If BASE is CONST_INT,
	add value to start and set BASE to const0_rtx.
	(refers_to_mem_p): Don't do it here.

	* function.c (expand_function_start): Add redundant copy to
	static_chain_incoming_rtx if SMALL_REGISTER_CLASS so inlining
	works properly.
	* integrate.c (expand_inline_function): Use single_set when
	appropriate.
	Delete insn that sets static_chain_incoming_rtx before its use.
	(subst_constants): Treat virtual reg as constant.

	* flow.c (mark_used_regs): Only show changes size if one mode is
	integral.
	* stupid.c (stupid_mark_refs): Likewise.
	* combine.c (simplify_rtx, case FLOAT_TRUNCATE): Remove
	redundant float_truncate.
	* rs6000.md (movsf): Don't truncate if not register; clean up.

	* c-decl.c (duplicate_decls): Suppress -Wredundant-decls warning
	if we have already given an error.

Thu Aug 11 18:44:25 1994  Jason Merrill  (jason@deneb.cygnus.com)

        * stmt.c (expand_anon_union_decl): Fix up the alignment and mode
        of the member VAR_DECLs.

Thu Aug 11 13:36:14 1994  Per Bothner  (bothner@kalessin.cygnus.com)

	* tree.c (stabilize_reference):  Handle COMPOUND_EXPR.

	* fix-header.c (write_rbrac):  If NO_IMPLICIT_EXTERN_C is defined,
	add extern "C" { ... } to added prototypes.  (Needed for hpux.)

Thu Aug 11 14:23:59 1994  Paul Eggert  (eggert@twinsun.com)

	* cccp.c (rescan): Fix botches with `-lint': the output buffer
	pointer was not recached properly, leading to lost output.
	Also, buffer overrun was possible.

	* cccp.c (dump_defn_1): Skip newlines and strings correctly.

Thu Aug 11 14:13:17 1994  Niklas Hallqvist  (niklas@appli.se)

	* configure (m68k-*-netbsd*): New target, like others.

Thu Aug 11 14:09:23 1994  David Mosberger-Tang  (davidm@piston.cs.arizona.edu)

      * alpha.h (FUNCTION_PROFILER):  Load global pointer from $27, not $26. e
 
Thu Aug 11 13:52:15 1994  Walter Misar  (misar@rbg.informatik.th-darmstadt.de)

	* m68k/hp320.h (NO_DOT_IN_LABEL): Define if HPUX_ASM.

Thu Aug 11 13:12:12 1994  David Mosberger-Tang  (davidm@cs.arizona.edu)

	* alpha.h (BLOCK_PROFILER): Use $26 and $27 instead of $0 and $1.

Thu Aug 11 13:09:36 1994  Antti Miettinen  (amiettin@trshp.trs.ntc.nokia.com)

	* config/lynx.h (ASM_OUTPUT_SOURCE_LINE): Call assemble_name.

Thu Aug 11 12:57:22 1994  Stephen L Moshier  (moshier@world.std.com)

	* expr.c (expand_builtin): Relegate sin and cos to ffast-math.

Thu Aug 11 12:45:20 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* flow.c (find_auto_inc): Ensure that all proposed changes to
	insns are valid before commiting to the auto-inc.

	* calls.c (expand_call): Ensure we call force_operand on
	structure_value_addr.

	* configure: Use config.guess to get default value for host,
	not target.

Thu Aug 11 12:43:24 1994  Robert Wilhelm  (Robert.Wilhelm@physik.tu-muenchen.de)

	* Makefile.in (mostlyclean): Add missing -f.

Tue Aug  9 02:02:07 1994  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* pa.md (default set high): Do not accept function label arithmetic
	as a valid operand.
	(default lo_sum): Likewise.
	* pa.c (hppa_legitimize_address): Do nothing with function label
	arithmetic.
	(emit_move_sequence): Split up function label arithmetic so that
	function's address is loaded first, then constant part is added to
	the function's address.
	(is_function_label_plus_const): New function.

Mon Aug  8 19:57:05 1994  Matthias Pfaller  (leo@marco.de)

	* ns32k.md (all patterns that use ins/inss and ext/exts):
	Disallow use of these instructions when -mnobitfield is
	specified.
	* ns32k.h (TARGET_BITFIELD): New macro.
	(TARGET_SWITCHES): Support for TARGET_BITFIELD.
	* ns32k/netbsd.h (TARGET_DEFAULT): Added -mnobitfield.
	(CPP_PREDEFINES): Added -Dpc532.
	(WCHAR_{TYPE, UNSIGNED, TYPE_SIZE}): Changed to match new definition
	in NetBSD 1.0.
	* ns32k.c (print_operand_address): A patch for 2.5.8 ended up at the
	wrong place.  Moved.

Mon Aug  8 19:42:09 1994  Paul Eggert  (eggert@twinsun.com)

	* cccp.c (create_definition): Warn about `#define a@', since a
	diagnostic is now required (see ISO TC1's addition to
	subclause 6.8).  Also warn about `#define is-empty(x) (!x)'.

Mon Aug  8 16:32:37 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* fix-header.c (write_rbrac): Set up to use fixed headers
	if __USE_FIXED_HEADERS__ is defined.

	* reload1.c (emit_reload_insns): Always clear new_spill_reg_store.

	* reload.c (find_reloads): Force reload for paradoxical SUBREG
	of MEM if BYTES_BIG_ENDIAN.

	* m68k/hp320.h (READONLY_DATA_SECTION): Remove definition.

	* function.c (expand_function_start): Only use
	static_chain_incoming_rtx once if it is a REG and we 
	have SMALL_REGISTER_CLASSES.

	* local-alloc.c (find_free_reg): Fix typo in last change.
	* rs6000.h (CLASS_CANNOT_CHANGE_SIZE): New macro.

Sun Aug  7 08:54:42 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* regs.h (reg_changes_size): Add declaration.
	* flow.c (reg_changes_size): New variable.
	(allocate_for_life_analysis): Allocate and initialize it.
	(mark_used_regs, case SUBREG): Set it.
	* local-alloc.c (qty_changes_size): New variable.
	(alloc_qty{,_for_scratch}, update_qty_class): Set it.
	(local_alloc): Allocate it.
	(find_free_reg): If CLASS_CANNOT_CHANGE_SIZE, avoid its registers
	if qty_changes_size.
	* global.c (find_reg) If CLASS_CANNOT_CHANGE_SIZE, avoid its
	registers if reg_changes_size.
	* stupid.c (regs_change_size): New variable.
	(stupid_life_analysis): Alloc, init and pass it to stupid_free_reg.
	(stupid_mark_regs): Set it.
	(stupid_find_reg): New arg, CHANGES_SIZE; avoid regs
	in CLASS_CANNOT_CHANGE_SIZE if defined and CHANGES_SIZE nonzero.
	* reload.c (push_reload): Make test in LOAD_EXTEND_OP case more
	precise; handle CLASS_CANNOT_CHANGE_SIZE.
	(find_relods): When setting force_reloads, make LOAD_EXTEND_OP
	case more precise.
	* alpha.h (CLASS_CANNOT_CHANGE_SIZE): New macro.

	* reload1.c (eliminate_regs, case SUBREG): Add USE of pseudo
	so we don't improperly delete an output reload.

Fri Aug  5 15:08:39 1994  Jason Merrill  (jason@deneb.cygnus.com)

        * expr.c (expand_expr, COND_EXPR case): Use truthvalue_conversion
        to make the condition for running cleanups acceptable to
        invert_truthvalue.

Fri Aug  5 12:29:42 1994  Jim Wilson  (wilson@cygnus.com)

	* expmed.c (expand_mult): Accept DImode for synth_mult only if
	CONST_DOUBLE_HIGH is zero.  Reject negative values for synth_mult
	if the mode is larger than HOST_BITS_PER_INT.  Don't do the
	negate_variant if the mode is larger than HOST_BITS_PER_INT.

Fri Aug  5 12:23:17 1994  Stephen L Moshier  (moshier@world.std.com)

	* gbl-ctors.h (DO_GLOBAL_CTORS_BODY): Use long instead of
	HOST_WIDE_INT.

Fri Aug  5 12:18:18 1994  Kaveh R. Ghazi  (ghazi@caip.rutgers.edu)

	* configure: In subdirectories, make link to include directory.
	* Makefile.in (distclean): Delete it.

Thu Aug  4 17:21:02 1994  Jason Merrill  (jason@deneb.cygnus.com)

        * expr.c (defer_cleanups_to): Put back line which was mistakenly
        removed.

Wed Aug  3 21:37:31 1994  Doug Evans  (dje@cygnus.com)

	* sparc.c (v9 sparc_builtin_saveregs): Save quadword fp regs on
	16 byte boundaries.  Handle non-zero number of named fp args.
	* va-sparc.h (v9 va_start): Pass an arg to __builtin_next_arg.
	(v9 va_arg): Advance over float's.

Wed Aug  3 11:10:32 1994  Ian Lance Taylor  (ian@mole.gnu.ai.mit.edu)

	* fixincludes: Changes for glibc.  In the main loop, don't fix
	files which contain the string ``This file is part of the GNU C
	Library''.  Don't include <stdarg.h> in <stdio.h> if <stdio.h>
	contains the string ``__need___va_list''.  In <stdio.h>, don't
	change GNUC_VA_LIST to GNUC_DUMMY_VA_LIST.  Don't add extern "C"
	to <assert.h> if it contains the string ``__BEGIN_DECLS''.  Don't
	add multiple inclusion protection to <time.h> or <sys/time.h> if
	they contain the string ``#ifndef''.

Tue Aug  2 18:38:46 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* cse.c (simplify_unary_operation): Clean up some mode and
	size checks with CONST_DOUBLEs; TRUNCATE should do nothing.

	* combine.c (subst_prev_insn): Remove variable and all uses.

Tue Aug  2 14:42:29 1994  Doug Evans  (dje@canuck.cygnus.com)

	* sparc.h (V9_SWITCHES): Add -mmedlow, -mmedany.
	(TARGET_OPTIONS): Delete.
	(CONDITIONAL_REGISTER_USAGE): Don't unfix %g4 if -mmedany.
	* sparc.c (sparc_code_model): Delete.
	(sparc_override_options): Code model flags only useable with v9.

	* sparc.h (enum reg_class): New values EXTRA_FP_REGS,
	GENERAL_OR_EXTRA_FP_REGS for the v9 case.
	(REG_CLASS_NAMES): Likewise.
	(REG_CLASS_CONTENTS): Likewise.
	(REGNO_REG_CLASS): Handle EXTRA_FP_REGS.
	(REG_CLASS_FROM_LETTER): Likewise, as `e'.
	Treat `e' like `f' in v8 case.
	(FP_REG_CLASS_P): New macro.
	(PREFERRED_RELOAD_CLASS): Use it.
	(SECONDARY_INPUT_RELOAD_CLASS, SECONDARY_OUTPUT_RELOAD_CLASS,
	SECONDARY_MEMORY_NEEDED, CLASS_MAX_NREGS, REGISTER_MOVE_COST):
	Likewise.
	* sparc.md (all DF/TFmode patterns): Use `e' in contraint field
	instead of `f'.

Mon Aug  1 20:05:51 1994  Roland McGrath  <roland@churchy.gnu.ai.mit.edu>

	* config/i386/gnu.h: New file.
	* configure (i[34]86-*-gnu*): Deal with this on its own, not like
	i[34]86-*-mach*.  Use i386/gnu.h and t-libc-ok; set gnu_ld and
	gas, and disable fixincludes.

Mon Aug  1 19:27:44 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* tree.c (permanent_allocation): When freeing to
	momentary_function_firstobj, set momentary_firstobj to be
	the next available location (i.e., momentary_function_firstobj).

Mon Aug  1 18:52:40 1994  Chris Arthur  (csa@gnu.ai.mit.edu)

	* stddef.h: Handle _BSD_WCHAR_T_ like _WCHAR_T_, since
	at least BSD/386 1.1 uses the former instead of the latter.
	If _BSD_RUNE_T_ is defined, then define rune_t when we define
	wchar_t.  Test definedness of _GCC_SIZE_T as well as
	_GCC_SIZE_T_; likewise for _GCC_PTRDIFF_T and _GCC_WCHAR_T.

Mon Aug  1 05:20:44 1994  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* pa-ghpux.h, pa-hpux.h (LINK_SPEC): Any -g argument implies
	static linking.

Sun Jul 31 17:19:37 1994  Jason Merrill  (jason@deneb.cygnus.com)

        * integrate.c (expand_inline_function): Don't fall down trying to
        pass things by invisible reference.

Sun Jul 31 06:56:46 1994  Pat Rankin  (rankin@eql.caltech.edu)

	* cccp.c (my_strerror): New function.
	(error_from_errno, perror_with_name): Use it.

Sat Jul 30 12:59:01 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* fold-const.c (fold_truthop): Apply masks to constants.

	* print-tree.c (print_node{,_brief}): Use correct printf code to
	print INTEGER_CST if HOST_WIDE_INT is wider than int.

	* expmed.c ({store,extract}_bit_field): Don't use bitfield insn
	if OP0 is register and bitfield spans it.

	* m88k.c (arith64_operand): Integer CONST_DOUBLE is not DImode.
	* sparc.c (reg_or_0_operand): Likewise.
	* ns32k.c, pa.c (print_operand): Likewise.
	* fx80.h, gmicro.h, ns32/{genix,merlin}.h (PRINT_OPERAND): Likewise.
	* m68k/crds.h, m68k/news.h, pyr.h (PRINT_OPERAND): Likewise.

	* alpha.h (CASE_VECTOR_PC_RELATIVE): Define.
	(ASM_OUTPUT_ADDR_VEC_ELT): Abort.
	(ASM_OUTPUT_ADDR_DIFF_ELT): Now what used to be previous definition.
	* alpha.md (tablejump): Rework to look like normal add but verify
	that label is for next insn and is tablejump; look for ADDR_DIFF_ELT.
	* cse.c (fold_rtx, case MEM): Surround TRUNCATE for jump table
	entry with a CONST.
	(fold_rtx, case '1'): Handle operand 0 of a CONST.
	(fold_rtx, case PLUS): Handle (const (minus (label_ref) (label_ref))).

Fri Jul 29 19:27:17 1994  Lee Iverson  (leei@ai.sri.com)

	* c-decl.c (finish_decl): Preserve initialializer if iterator.

Fri Jul 29 19:07:23 1994  Hallvard B Furuseth  (h.b.furuseth@usit.uio.no)

	* libgcc2.c: Add declaration of ctime.
	* bc-emit.c (bc_sym_write): Change %d to %lu in printf calls.
	* fix-header.c (write_{l,r}brac): Specify return type of int.
	* tree.c (change_main_variant): Return type now void.
	* varasm.c (bc_output_constructor): Return type now rtx.

Fri Jul 29 18:33:48 1994  Ken Duda  (kjd@cache.crc.ricoh.com)

	* c-typeck.c (build_unary_op, case *INCREMENT_EXPR):
	Add size in bytes, not value of sizeof.

Fri Jul 29 17:36:38 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* function.c (expand_function_start): Initialize VALUE_ADDRESS.

	* romp.md (tst?f): Use CONST0_RTX instead of incorrect call
	to immed_real_const_1.

	* expr.c (move_block_to_reg): Do nothing if NREGS == 0.

Fri Jul 29 17:17:18 1994  Tom Tromey  (tromey@busco.lanl.gov)

	* cccp.c (special_symbol, do_xifdef): Don't access value.defn
	of a T_CONST.

Thu Jul 28 17:19:32 1994  Jason Merrill  (jason@deneb.cygnus.com)

        * gbl-ctors.h (DO_GLOBAL_CTORS_BODY): Reverse order of execution
        of constuctor lists.
        * config/svr3.h (DO_GLOBAL_CTORS_BODY): Ditto.

        * libgcc2.c (__do_global_dtors): Reverse order of execution of
        destructor lists.

Thu Jul 28 19:56:30 1994  Jim Pendergraft  (jimp@dg-rtp.dg.com)

	* dwarfout.c (output_decl, case FUNCTION_DECL): Corrected
	and simplified code that determined when to generate
	varargs or ANSI stdargs variable length parameter list
	DWARF information.

Thu Jul 28 19:38:57 1994  Andreas Schwab  (schwab@issan.informatik.uni-dortmund.de)

	* m68k.md (extv, extzv): In patterns that will use movb and
	movw, ensure size is 8 or 16.

Thu Jul 28 19:28:31 1994  David Robinson  (drtr@mail.ast.cam.ac.uk)

	* expr.c (expand_expr, case CONJ_EXPR): Use correct mode for
	parts of a complex expression.

	* optabs.c (expand_binop, case MULT [complex]) Fix typo.

Thu Jul 28 19:21:38 1994  Uwe Seimet  (seimet@chemie.uni-kl.de)

	* am68k/atari.h (FUNCTION_VALUE): New override.

Thu Jul 28 17:27:38 1994  Paul Eggert  (eggert@twinsun.com)

	* Makefile.in (c-lex.o, distdir-start):
	Depend on $(srcdir)/c-gperf.h, not c-gperf.h.

Thu Jul 28 15:14:33 1994  Oliver Kellogg  (okellogg@salyko.cube.net)

	* m1750.inc (DNR.M): Add missing macro.

Thu Jul 28 13:02:56 1994  Kresten Krab Thorup  (krab@akvavit)

	* objc/misc.c (__objc_xcalloc): Remove declaration of bzero.

Thu Jul 28 07:29:52 1994  Markus Wild  (mw@eunet.ch)

	* c-common.c (decl_attributes): Correct string check for "format"
	to include unsigned and signed char.

Thu Jul 28 07:11:36 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* reload1.c (compare_spill_regs): Simplify and return zero if
	registers are the same.

	* c-decl.c (finish_struct): Don't look at alignment of error_mark_node.

	* combine.c (try_combine): Don't make a MULT if none of the insns
	in our input had one.

Wed Jul 27 19:06:53 1994  R Bowler  (rbowler@cix.compulink.co.uk)

	* i370/mvs.h (ASM_OUTPUT_ASCII): Fix bug when first character
	of string constant is single quote.

Wed Jul 27 22:44:32 1994  Jason Merrill  (jason@deneb.cygnus.com)
  
        * m68k/next.h: #undef PCC_STATIC_STRUCT_RETURN.

        * alpha/alpha.h: #define NO_IMPLICIT_EXTERN_C.

Wed Jul 27 14:06:37 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* expmed.c (expand_mult): Properly set ADD_TARGET for add_variant.

	* alpha.h (INITIAL_ELIMINATION_OFFSET): Properly compute offset
	between	AP and SP when get_frame_size and
	current_function_pretend_args_size are not a multiple of 16 bytes.

	* expmed.c (expand_divmod): Don't make REG_NOTE if last insn's
	destination isn't QUOTIENT.

Tue Jul 26 19:45:54 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* expr.c (expand_expr, case ARRAY_REF): Don't fold L"foo"[2].

Tue Jul 26 14:10:52 1994  Per Bothner  (bothner@kalessin.cygnus.com)

	* config.sub:  Refer to NeXT's operating system as nextstep.

Tue Jul 26 13:50:37 1994  Jim Wilson  (wilson@cygnus.com)

	* c-typeck.c (process_init_element): Do not call push_init_level
	if the value is error_mark_node.

	* iris5.h (NO_IMPLICIT_EXTERN_C): Define.

Mon Jul 25 00:20:36 1994  Chris Arthur  (csa@gnu.ai.mit.edu)

	* configure (canon_target): add cases to recognize BSD/386
	specifically, so we can use a tm_file that will cause __bsdi__
	to get defined (since emacs, among other things, needs it).

	* config/i386/bsd386.h: New.  Use 386bsd.h, and just override
	CPP_PREDEFINES (add -Dbsdi) and WCHAR stuff.

Sat Jul 23 16:30:12 1994  Kaveh R. Ghazi  (ghazi@caip.rutgers.edu)

	* fixinc.svr4: Change i860 in #if to __i860__, as with other CPUs.

Fri Jul 22 14:33:59 1994  Doug Evans  (dje@cygnus.com)

	* h8300.md (andhi3, iorhi3, xorhi3): Change constraint on
	operand 2 from `i' to `n'.

Fri Jul 22 09:30:39 1994  DJ Delorie  (dj@ctron.com)

	* configure.bat: move code to config/msdos/* (simplification)

	* config/msdos/configure.bat [new file]: moved most processing
	here so that as things get more complicated with the language
	breakouts, the top directory won't get too messy.  Sed script
	broken out to simplify processing and avoid quoting errors.
	* config/msdos/top.sed [new file]: sed script to change Makefile.in
	to Makefile in top directory (currently used for cp directory also)
	sed commands changed to handle language breakout

	* gcc.c (pexecute): use spawn*() for djgpp to ensure that quotes
	are properly preserved.  Response file code left for 16-bit
	compilers, which can't handle the long command lines that gcc
	may generate.

	* config/i386/go32.h: define NO_IMPLICIT_EXTERN_C.

Thu Jul 21 23:19:03 1994  Steve Chamberlain  (sac@wombat.gnu.ai.mit.edu)

        * sh/sh.h (TARGET_SWITCHES, PACKSTRUCT_BIT, STRUCTURE_SIZE_BOUNDARY):
        parse and handle new option.
        (LEGITIMATE_CONSTANT_P): LABEL_REFs are no longer illegal.
        (WCHAR_TYPE, WCHAR_TYPE_SIZE): New definitions.
        (HANDLE_PRAGMA): Has return.

        * sh/sh.c (add_function, seen_function): Experimental code to
        generate bsrs.
        (handle_pragma): Return final char.
        (expand_acall): Handle TARGET_BSR.
        (general_movdst_operand, general_movsrc_operand): Allow ok
        autoinc/dec.
        (bsr_operand): New function.
        (fixit): Need to fix LABEL_REFs.

        * sh/sh.md (addc): Simplify.
        (adddi3, subdi3, negdi3): Use operand_subword.
        (subc, negc): New pattern.
        (shifts): Fix constraints.

Thu Jul 21 17:59:43 1994  Jim Wilson  (wilson@cygnus.com)

	* objc-act.c (build_module_descriptor): Don't set DECL_EXTERNAL on
	current_function_decl.

	* combine.c (simplify_rtx): For (not (xor X C)) generate new rtx
	instead of modifying old rtx.

	* c-decl.c (start_function): If old_decl is NULL, then set it to
	the implicit decl if any.  Delete superfluous test from warn missing
	prototypes code.  For warn missing declarations code, only warn if
	previous decl is implicit.

Thu Jul 21 17:47:05 1994  Paul Eggert  (eggert@twinsun.com)

	* fold-const.c (fold): Don't fold X-X to 0 if X is floating point
	and !flag_fast_math.

Thu Jul 21 02:07:45 1994  Charles Levert  (charles@comm.polymtl.ca)

	* Makefile.in (stmp-multilib): Rework to handle make -n.
	(stmp-multilib-sub): New target.

Tue Jul 19 23:14:42 1994  Larry Jones  (larry.jones@sdrc.com)

	* configure (i[34]86-*-isc*): Treat isc4 like isc3.
	Remove references to nonexistant files and add extra_parts
	when needed.
	(i[34]86-*-solaris2*): Remove reference to nonexistant
	t-sco and use extra_parts instead.
	(i[34]86-*-sysv*, i860-*-sysv3*, m68k-*-sysv3*, m68k-ncr-sysv*):
	Replace t-svr3 with extra_parts.

Tue Jul 19 20:31:34 1994  Doug Evans  (dje@cygnus.com)

	* configure (find lang subdirs loop): Try to work around an
	apparent bug in bash 1.12 on linux.

	* Makefile.in (clean): Remove multilib build dirs.

	* h8300.c (print_operand, default case): Handle SFmode regs.

Mon Jul 18 22:02:53 1994  Jim Wilson  (wilson@cygnus.com)

	* sparc.c (call_operand): Use symbolic_operand not CONSTANT_P.
	(call_operand_address): Likewise.
	* sparc.md (call*): Use symbolic_operand not immediate_operand.
	Use 's' constraint not 'i' constraint.

	* toplev.c (rest_of_compilation): Clear DECL_ABSTRACT_ORIGIN if
	clear DECL_INLINE.

	* global.c (find_reg): Store divide results in temporary variables.

	* gcc.c (process_command): When have -BstageN option, pass include
	not stageN/../include to preprocessor.

Mon Jul 18 21:58:27 1994  Torbjorn Granlund  (tege@tiny.cygnus.com)

	* loop.c (move_movables): Aviod lossage when CALL_INSN_FUNCTION_USAGE
	is NULL.

Mon Jul 18 20:53:54 1994  Ian Lance Taylor  (ian@cygnus.com)

	* fixincludes: Rework required loop to avoid crash on decstation.

Thu Jul 14 09:42:23 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* Version 2.6.0 released.

	* explow.c (force_reg): Don't make a REG_EQUAL note for an insn
	that doesn't set TEMP.

Wed Jul 13 17:00:35 1994  Torbjorn Granlund  (tege@rtl.cygnus.com)

	* expmed.c (expand_divmod, case CEIL_DIV_EXPR):
	Handle emit_store_flag returning 0.

Wed Jul 13 16:35:57 1994  Jim Wilson  (wilson@cygnus.com)

	* expr.c (store_field): Set MEM_IN_STRUCT_P on object and
	blk_object.

Wed Jul 13 08:40:11 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* Makefile.in (distdir-start): Make tmp/ginclude and copy its files.
	(distdir-finish): Don't use -f Makefile.in.
	(gcc.xtar.gz): Add --best.

	* fold-const.c (decode_field_reference): Merge operand of
	a BIT_AND_EXPR with the mask made from the description of the field.

	* fold-const.c (fold, case MULT_EXPR): Remove last change.

Wed Jul 13 07:12:32 1994  Torbjorn Granlund  (tege@adder.cygnus.com)

	* xm-pa.h, xm-pahpux.h, xm-pahiux.h (USE_C_ALLOCA): Define.

Wed Jul 13 03:30:36 1994  Jason Merrill  (jason@deneb.cygnus.com)

        * tree.h (TYPE_NEEDS_CONSTRUCTING): New macro.
        (tree_type): Add needs_constructing_flag.
        * function.c (assign_parms): If TYPE_NEEDS_CONSTRUCTING, pass by
        invisible reference.
        * calls.c (expand_call): Ditto.

Wed Jul 13 06:49:05 1994  Simon Cooper  (scooper@hardees.rutgers.edu)

	* objc/Object.m: Include stdarg.h before stdio.h.

Tue Jul 12 21:31:59 1994  Jim Wilson  (wilson@cygnus.com)

	* c-decl.c (pushdecl): Don't call lookup_name_current_level_global
	when traditional.  When doing checks against
	IDENTIFIER_LIMBO_VALUE, also do check against
	INDENTIFIER_GLOBAL_VALUE when traditional.

	* final.c (getpwd): Declare.

Tue Jul 12 16:24:10 1994  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* pa.h (GO_IF_LEGITIMATE_ADDRESS): Only allow immediate addressing
	using 5 bits to avoid losing with FP loads and stores on page zero.

Tue Jul 12 16:20:09 1994  David Edelsohn  (edelsohn@npac.syr.edu)

	* rs6000.md (ashlsi3, lshrsi3, ashrsi3): Only output low-order five
	bits for !TARGET_POWER case.

Tue Jul 12 13:06:14 1994  Jim Wilson  (wilson@cygnus.com)

	* combine.c (record_dead_and_set_regs_1): Can only handle SUBREG
	if the register is smaller or equal to BITS_PER_WORD.

	* sparc/sysv4.h (FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER): Define.

	* final.c (end_final): Store full path name in .d file not just
	the filename.

	* README.IRIX5: New file.

Tue Jul 12 10:55:14 1994  Michael Meissner  (meissner@osf.org)

	* i386/osfrose.h (CC1_SPEC): If both -pic-extern/-pic-lib and
	-pic-none, use -pic-extern win, instead of -pic-none.

	* i386/osfelf.h (CC1_SPEC): Ditto.

Tue Jul 12 09:08:06 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* reload.c (find_reloads): Don't try to call force_const_mem on
	a HIGH.

	* fold-const.c (fold, case MULT_EXPR): If arg is an unsigned
	CEIL_DIV_EXPR, convert to TRUNC_DIV_EXPR of a PLUS_EXPR in some cases.

	* alpha.md (ashldi3): Update pattern for (sign_extend (ashift ..))
	to match the current canonicalization.

	* explow.c (round_push, allocate_dynamic_stack_space): Avoid
	using CEIL_DIV_EXPR; add adjustment and use TRUNC_DIV_EXPR instead.

Tue Jul 12 08:12:04 1994  Richard Earnshaw (rwe11@cl.cam.ac.uk)

	* dbxout.c (dbxout_source_file): Increment source_label_number outside
	of macro expansion.

	* arm.c (reversible_cc_register): New function.
	(final_prescan_insn): Don't try to conditionalize jumps with JUMP_CLOB
	attribute.
	* arm.h (PREDICATE_CODES): Add reversible_cc_register.
	* arm.md (matcher for SFmode inequality comparison): Use cmfe, not cfm.
	(matchers for {store-flag, not-store-flag, neg-store-flag}): Output
	if-false instruction first before if-true instruction.
	(matcher for (AND store-flag x)): Only match if reversible_cc_register.
	(matcher for (IF-THEN-ELSE reg (NOT reg))): Likewise.

	* arm.h (FRAME_POINTER_REQUIRED): Always true if the function has
	nonlocal labels.
	* arm.md ({save,restore}_stack_nonlocal): Delete.

Mon Jul 11 19:29:15 1994  Oliver Kellogg  (okellogg@salyko.cube.net)

	* machmode.def (TQFmode): New mode.
	* expr.c (convert_move): Add some conversions for TQFmode.
	* varasm.c (assemble_real): Handle TQFmode output.
	* config.sub (basic_machine): Add 1750a.
	* configure (1750a-*-*): New configuration.
	* 1750a.c, 1750a.h, 1750a.md, m1750a.inc: New files.

Mon Jul 11 18:38:42 1994  Doug Evans  (dje@cygnus.com)

	Add support for the h8/300h cpu.
	* config/h8300/lib1funcs.asm: New file.
	* h8300/t-h8300 (CROSS_LIBGCC1): Use libgcc1-asm.a.
	(LIB1ASMSRC, LIB1ASMFUNCS, LIB2FUNCS_EXTRA, MULTILIB_OPTIONS,
	MULTILIB_DIRNAMES, LIBGCC, INSTALL_LIBGCC): Define.
	(fp-bit.c): Build it.
	* h8300/h8300.h (CPP_PREDEFINES, CPP_SPEC, LIB_SPEC, TARGET_SWITCHES,
	BITS_PER_WORD, MAX_BITS_PER_WORD, UNITS_PER_WORD, MAX_UNITS_PER_WORD,
	POINTER_SIZE, PARM_BOUNDARY, BIGGEST_ALIGNMENT,
	BIGGEST_FIELD_ALIGNMENT, STACK_BOUNDARY, HARD_REGNO_NREGS,
	HARD_REGNO_MODE_OK, REG_CLASS_NAMES, REG_CLASS_CONTENTS,
	REGNO_REG_CLASS, PUSH_ROUNDING, FUNCTION_ARG_ADVANCE,
	TRAMPOLINE_TEMPLATE, TRAMPOLINE_SIZE, INITIALIZE_TRAMPOLINE,
	CONSTANT_ADDRESS, MOVE_MAX, Pmode, SIZE_TYPE, PTRDIFF_TYPE):
	Add h8/300h support.
	(LINK_SPEC, TARGET_RTL_DUMP, TARGET_H8300, TARGET_H8300H,
	REAL_ARITHMETIC, SETUP_INCOMING_VARARGS, HAVE_POST_INCREMENT,
	HAVE_PRE_DECREMENT, MAX_MOVE_MAX, NO_BUILTIN_SIZE_TYPE,
	NO_BUILTIN_PTRDIFF_TYPE, WCHAR_TYPE, WCHAR_TYPE_SIZE,
	MAX_WCHAR_TYPE_SIZE, ASM_WORD_OP, INIT_SECTION_ASM_OP,
	CTORS_SECTION_ASM_OP, DTORS_SECTION_ASM_OP, EXTRA_SECTIONS,
	EXTRA_SECTION_FUNCTIONS, ASM_OUTPUT_CONSTRUCTOR, ASM_OUTPUT_DESTRUCTOR,
	DO_GLOBAL_CTORS_BODY, DO_GLOBAL_DTORS_BODY, INIT_TARGET_OPTABS):
	Define.
	(CAN_DEBUG_WITHOUT_FP, PCC_STATIC_STRUCT_RETURN, STRUCT_VALUE_REGNUM,
	STRUCT_VALUE_INCOMING, STRUCTURE_SIZE_BOUNDARY): Undefine.
	(enum reg_class): Add h8/300h support.
	(emit_a_shift): Declare.
	(TARGET_DEFAULT): Set default to -mquickcall.
	(DOUBLE_TYPE_SIZE): Fix at 32.  DFmode support doesn't exist.
	(CALL_USED_REGISTERS, REG_ALLOC_ORDER): Swap registers 2,3 with 4,5.
	Registers 0,1 contain function result, allocate after 2,3.
	(STATIC_CHAIN_REGNUM): Use reg 4.
	(CONST_OK_FOR_LETTER_P): 'O' is ok_for_bclr, 'P' is small_power_of_two.
	(FUNCTION_PROFILER, FUNCTION_BLOCK_PROFILER, BLOCK_PROFILER): First
	attempt at an implementation.
	(CONST_COSTS): Move code into function const_costs.
	(BRANCH_COST): Set to 0.
	(NOTICE_UPDATE_CC): Move code into function notice_update_cc.
	(ASM_FILE_START): Move code into function asm_file_start.
	(ASM_FILE_END): Move code into function asm_file_end.
	(ASM_OUTPUT_DOUBLE, ASM_OUTPUT_FLOAT): Use REAL_VALUE_TO_DECIMAL.
	* h8300/h8300.c (cpu_type, names_extended, names_upper_extended,
	h8_reg_names, h8_push_ops, h8_pop_ops, h8_mov_ops, h8_push_op,
	h8_pop_op, h8_mov_op, current_function_anonymous_args, extra_pop,
	hand_list): New variables.
	(h8300_init_once, asm_file_start, asm_file_end, ok_for_bclr, o_operand,
	p_operand, call_insn_operand, jump_address_operand, bit_operand,
	eq_operator, const_costs, notice_update_cc, bit_operator,
	nshift_operator, expand_a_shift, get_shift_alg, emit_a_shift,
	fix_bit_operand): New functions.
	(shift_alg, shift_type, shift_mode): New enums.
	(shift_insn): New struct.
	(shift_n_bits, can_shift): Deleted.
	(shift_one, rotate_one): New variables.
	(WORD_REG_USED): New macro (was function word_reg_used).
	(dosize, function_prologue, function_epilogue, print_operand_address):
	Add h8/300h support.
	(small_power_of_two): Renamed from potl8.
	(potg8): Deleted.
	(general_operand_src): Fix POST_INC case.
	(general_operand_dst): Fix PRE_DEC case.
	(function_arg): 3 regs of args are passed if -mquickcall.
	4 regs of args are passed to handwritten assembler routines.
	(print_operand): New cases 'A', 'P', 'S', 'U', 'W', 'b', 'c', 'd', 'g'.
	Delete case 'O'.  Sort cases.  Add h8/300h support.
	(do_movsi): Renamed from domovsi.
	Handle reload_in_progress and reload_completed.
	(initial_offset): Renamed from io.  Add h8/300h support.
	* h8300/h8300.md (cpu): New attribute.
	(attribute length): Add h8/300h support.
	(attribute cc): New value `cbit'.
	(all anonymous insns): Give them names.
	(move insns): Add h8/300h support.
	(tstqi, tsthi): Use btst insn if able.
	(arithmetic insns): Add h8/300h support.
	(boolean insns): Likewise.
	(negate insns): Likewise.
	(branch insns): Likewise.
	(call_value): Use call_insn_operand for operand 1.
	(shift insns): Completely rewritten.  Add h8/300h support.
	(zero/sign extension insns): Add h8/300h support.
	(extv): Deleted.
	(insv, extzv): Only use for h8/300.
	(bitfield insns): Completely rewritten.
	(fancyb*): New insns for speeding up bit accesses.

	* optabs.c (init_optabs): Allow target specific libcalls
	with INIT_TARGET_OPTABS.

Mon Jul 11 18:32:42 1994  Steve Chamberlain  (sac@cygnus.com)

	* config/fp-bit.c: New file.  Provides simple fp emulation library.

Mon Jul 11 18:27:42 1994  Ian Lance Taylor  (ian@cygnus.com)

	* Makefile.in (libgcc1-asm.a): New target for building libgcc1.a
	in cross compilers.

Mon Jul 11 17:00:45 1994  David Edelsohn  (edelsohn@npac.syr.edu)

	* rs6000.md (movsi matcher): Add nop for moving special register
	to itself for !TARGET_POWER.
	(movhi and movqi matcher): Likewise and add mtjmpr attribute.
	Separate MQ from CTR and LR target registers for TARGET_POWER.

	* powerpc.h (CPP_SPEC): Fix typo.

Mon Jul 11 16:50:29 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* c-parse.in (stmt): Don't give more than one error message if a
	nested `if' has an empty body.

	* a29k.md (movqi): Call loadhi, not loadqi.

Mon Jul 11 16:46:09 1994  Jeffrey A. Law  (law@mole.gnu.ai.mit.edu)

	* pa.h (DEBUGGER_ARG_OFFSET): Define.  If no frame pointer
	is available, then adjust the offset by the size of the
	current frame.

Mon Jul 11 16:34:14 1994  Stan Shebs  (shebs@andros.cygnus.com)

 	* configure (*-*-lynxos*): Always run fixincludes, and if not using
	gas, set tm_file to lynx-ng.h.
	* config/x-lynx: Always run fixproto.
	* config/lynx.h, i386/lynx.h, m68k/lynx.h, sparc/lynx.h: Rewrite
	to work with gas producing coff files.
	* config/lynx-ng.h, i386/lynx-ng.h, m68k/lynx-ng.h,
	sparc/lynx-ng.h: New files.

Mon Jul 11 15:16:28 1994  Pat Rankin  (rankin@eql.caltech.edu)

	* make-cc1.com: Compile most of cc1plus in the `cp' subdirectory.
	* vmsconfig.com: When setting up tm.h, convert "vax/vax.h" into
	"config-vax.h" rather than "[.config.vax]vax.h" for #include so
	it will work from [.cp] subdirectory; copy vax.h to config-vax.h
	as part of configuration setup.  Also, manually include cc1plus
	in the list of buildable compilers (a temporary measure; it
	should process cp/Makefile.in like it does for primary makefile).

	* make-cc1.com: Use `=' rather than `:=' when setting up CC,
	so that `gcc' can be defined as a foreign command if necessary;
	eliminate `set symbol/scope=noGlobal' for same reason; use `='
	with all other symbols, for consistency; add explicit .obj
	extension to some lists of object files passed to the linker;
	general cleanup of the command text echoed during execution.
	* make-cccp.com: Revise to be more consistent with make-cc1.com
	for symbol setup & usage and for echoing command execution.

Mon Jul 11 15:03:23 1994  Charles Hannum  (mycroft@duality.gnu.ai.mit.edu)

	* configure: Recognize m68k-*-netbsd* and i[345]86-*-netbsd*.
	* cccp.c, collect2.c, gcc.c, protoize.c, cp/g++.c (sys_errlist)
	[bsd4_4]: Do this for __NetBSD__ also.

Mon Jul 11 14:16:28 1994  Kresten Krab Thorup  (krab@spiff.gnu.ai.mit.edu)

	* mips/mips.h (STRUCT_VALUE): Change definition from `(rtx)0' to
	just `0' so it is a valid expression for the pre-processor. 

Mon Jul 11 10:54:35 1994  Stan Cox  (coxs@dg-rtp.dg.com)

	* configure (m88k-dg-dguxbcs): New configuration.  m88k-dg-dgux
	Now builds an elf compiler.  Both targets will create bcs or elf.

	* m88k/dgux.h (ASM_SPEC,STARTFILE_SPEC,LIB_SPEC): svr4 default.

	* m88k/dguxbcs.h (ASM_SPEC,STARTFILE_SPEC,LIB_SPEC): 
	New target for svr3.

	* m88k/x-dgux, m88k/t-dgux, m88k/x-dguxbcs: 
	Changed for svr4/svr4/svr3 respectively.

	* m88k/m88k.h (TARGET_SVR3): New target switch.

Wed Jun 29 19:23:27 1994  David Mosberger-Tang  (davidm@piston.cs.arizona.edu)
  
  	* alpha.h (LIB_SPEC): If -pg, add -lprof2.

Mon Jul 11 13:17:38 1994  Ian Lance Taylor  (ian@cygnus.com)

	* combine.c (simplify_set): Only turn IF_THEN_ELSE into AND if
	MODE_INT.

Sun Jul 10 06:03:12 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* reload1.c (eliminate_regs_in_insn): Handle special case of
	assignment from hard frame pointer to frame pointer (for
	nonlocal goto).
	* function.c (instantiate_virtual_regs_1): Remove last change.
	* stmt.c (expand_end_bindings): When adjusting FP, set it
	from hard_frame_pointer_rtx.

	* expr.c (expand_builtin, case BUILT_IN_FSQRT): Don't use
	asterisk in name of `errno'.

Fri Jul  8 22:07:32 1994  Jim Wilson  (wilson@cygnus.com)

	* stdarg.h: Delete include of <stdarg.h> when not gcc.
	* varargs.h: Delete include of <varargs.h> when not gcc.

Fri Jul  8 18:45:56 1994  Philippe De Muyter (phdm@info.ucl.ac.be)

	* m68k/mot3300.h (FUNCTION_EXTRA_EPILOGUE): Copy a0 to d0, not
	the other way.

Fri Jul  8 17:41:39 1994  Jim Wilson  (wilson@cygnus.com)

	* expr.c (get_inner_unaligned_p): New function.
	(expand_assignment, expand_expr): Use it.

Fri Jul  8 17:16:25 1994  Doug Evans  (dje@cygnus.com)

	* expmed.c (extract_split_bit_field): Set UNIT to BITS_PER_WORD for
	register values.
	(store_split_bit_field): Likewise.  Call operand_subword_force.

Fri Jul  8 13:48:23 1994  Mike Stump  (mrs@cygnus.com)

	* expr.c (target_temp_slot_level): New variable to keep track of
	the current stack level for temporaries created by TARGET_EXPRs.
	* expr.h (target_temp_slot_level): Declare it.
	* expr.c (expand_expr): Add code to maintain the new temporary
	stack for TARGET_EXPRs to the CLEANUP_POINT_EXPR code and change
	the allocation of temporaries for TARGET_EXPRs to be from the new
	stack, so that they may live longer, and only be reused after they
	are no longer in use.
	* function.c (assign_stack_temp): KEEP can now also be 2, to
	indicate allocation from the longer term frontend controlled
	temporary stack.
	* function.c (init_function_start): Initialize
	target_temp_slot_level to zero.

Fri Jul  8 16:52:38 1994  Jim Wilson  (wilson@cygnus.com)

	* combine.c (distribute_notes, REG_DEAD case): When check to see
	if insn uses register, also call find_regno_fusage.

	* sparc.h (SECONDARY_MEMORY_NEEDED_RTX): Call assign_stack_local
	if the frame has zero size.

Fri Jul  8 11:46:50 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* varasm.c (record_constant_rtx, force_const_mem): Ensure everything
	is in saveable_obstack, not current_obstack.

	* combine.c (force_to_mode): OP_MODE must be MODE if MODE and
	mode of X are of different classes.
	(nonzero_bits, num_sign_bit_copies): Say nothing known for
	floating-point modes.

	* function.c (instantiate_virtual_regs_1, case SET):
	If DEST is virtual_stack_vars_rtx, replace with hardware
	frame pointer.

	* expr.c (expand_expr, case CONVERT_EXPR): If changing signedness
	and we have a promoted SUBREG, clear the promotion flag.

	* c-decl.c (finish_decl): Put RTL and other stuff in 
	permanent_obstack if DECL is.

	* combine.c (gen_unary): Add new arg, OP0_MODE.
	All callers changed.

Thu Jul  7 19:58:35 1994  Jason Merrill  (jason@deneb.cygnus.com)

        * varasm.c (assemble_variable): Do set TREE_ASM_WRITTEN on
        erroneous incomplete decls.

Thu Jul  7 17:59:46 1994  Joseph Arceneaux  (jla@gnu.ai.mit.edu)

	* configure (m68k-motorola-sysv*): Use mot3300g.h for gas.
	* m68k/mot3300g.h: New file.

Thu Jul  7 17:42:21 1994  Philippe De Muyter  (phdm@info.ucl.ac.be)

	* m68k/mot3300.h (FUNCTION_EXTRA_EPILOGUE): Fix typo in last change.

Thu Jul  7 17:36:26 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* expmed.c (expand_mult_highpart): Build constant forms of CNST1
	in MODE or WIDE_MODE, as appropriate.

	* optabs.c (expand_binop, case DIV [complex]): Fix typo in last change.

	* alpha.md (reload_inqi): Make operand[2] be TImode and
	pass register number that differs to unaligned_loadqi.
	(reload_outqi): Change overlap in temps to unaligned_storeqi.
	* alpha.c ({un,}aligned_memory_operand): Check against
	hard_frame_pointer_rtx, not frame_pointer_rtx.

Thu Jul  7 01:39:33 1994  Doug Evans  (dje@cygnus.com)

	* combine.c (make_compound_operation, AND case): Do extraction in
	desired result mode.

	* flow.c (mark_set_1): Record explicit hard registers in their
	raw mode.
	(mark_used_regs): Likewise.
	* combine.c (distribute_notes): Likewise.

Wed Jul  6 14:45:08 1994  Pat Rankin  (rankin@eql.caltech.edu)

	* longlong.h (vax sdiv_qrnnd): Fix typo.

Wed Jul  6 19:59:12 1994  Mike Stump  (mrs@cygnus.com)

	* expr.c (expand_expr, defer_cleanups_to, expand_cleanups_to): All
	cleanups have to be protected by interim exception handling code.
	* stmt.c (expand_decl_cleanup, expand_cleanups): Ditto.
	* toplev.c (interim_eh_hook): Hook for interim exception handling.
	* toplev.c (interim_eh): Default implementation for exception
	handling that does nothing.
	* toplev.c (main): Set default for interim_eh_hook.

Wed Jul  6 17:56:37 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* alpha.c (output_prolog): Start memory probing with $2.

Wed Jul  6 14:21:14 1994  Jim Wilson  (wilson@cygnus.com)

	* stmt.c (struct nesting): Add new field alt_end_label.
	(expand_start_loop): Initialize it to zero.
	(expand_end_loop): Reorder loop if find either a jump to end_label
	or a jump to alt_end_label.
	(expand_exit_loop_if_false): Set alt_end_label.

Wed Jul  6 05:07:31 1994  Richard Earnshaw  (rwe11@cl.cam.ac.uk)

	* c-common.c (decl_attributes): If TREE_TYPE for the DECL is updated,
	then update TYPE as well.

	* longlong.h (arm umul_ppmm): Fix use of uninitialized register. 
	Eliminate clobbers of hard registers.

Wed Jul  6 03:22:04 1994  Torbjorn Granlund  (tege@rtl.cygnus.com)

	* expmed.c (expand_divmod): Clear out TARGET also if OP1 is a
	constant, when TARGET == OP0.

Tue Jul  5 18:58:28 1994  Torbjorn Granlund  (tege@rtl.cygnus.com)

	* Makefile.in (c-parse.y): Redirect through tmp file.
	(objc-parse.y): Likewise.
	(c-gperf.h): Likewise.
	(mostlyclean): Delete the new tmp files.

	* expmed.c (expand_divmod): Fix typo setting op1_is_pow2.
	(expand_divmod): Handle powers-of-two specifically for unsigned
	CEIL_*_EXPR.

	* longlong.h: Really fix the test for _IBMR2.  Change test of
	__powerpc__ to _ARCH_PPC.

Tue Jul  5 17:00:19 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* combine.c (try_combine): Don't check for replacing
	arg of function here.
	(can_combine_p): Do it here.

	* expr.c (expand_increment): If pre-incrementing a promoted
	variable, don't adjust OP0 since the result won't be used.

	* jump.c (duplicate_loop_exit_test): Handle SUBREG in SET_DEST
	of loop exit test statements.

	* combine.c (try_combine): If I2DEST was used in I2SRC, it isn't
	unused just because there is no SET for I2 anymore.

Mon Jul  4 11:15:13 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* rs6000.h (RS6000_OUTPUT_BASENAME): Always call assembler_name
	and pass the actual symbol name.

	* varasm.c (assemble_name): Call STRIP_NAME_ENCODING.

	* cse.c (canon_hash, exp_equiv_p): Refer to string in SYMBOL_REF
	with XSTR, not XEXP.

Sat Jul  2 18:53:19 1994  Jim Wilson  (wilson@cygnus.com)

	* mips.md (smuldi3_highpart, smuldi3_highpart_internal,
	umuldi3_highpart, umuldi3_highpart_internal): New patterns.

	* unroll.c (loop_iterations): Only use REG_EQUAL note value if it
	is constant.

	* dbxout.c (dbxout_type_methods): Enable debugging info for
	template classes.

	* c-lex.c (yylex): Reject imaginary numbers when pedantic.

	* c-decl.c (duplicate_decls): When make void* match char*, set
	DECL_IN_SYSTEM_HEADER.

	* Makefile.in (clean): Delete LIB2FUNCS_EXTRA.

	* alpha.h (FUNCTION_PROFILER, FUNCTION_BLOCK_PROFILER,
	BLOCK_PROFILER): Use multiple fputs/fprintf calls instead of ANSI
	C concatenated strings.
	(PREDICATE_CODES): Add cint8_operand.

	* gcc.c (DEFAULT_WORD_SWITCH_TAKES_ARG): Add -isystem.

Sat Jul  2 09:34:20 1994  Torbjorn Granlund  (tege@rtl.cygnus.com)

	* expmed.c (expand_divmod): Always return gen_lowpart (mode, ...).

Fri Jul  1 19:28:39 1994  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* reorg.c (make_return_insns): Make sure redirecting a jump to
	a RETURN insn does not invalidate the delay slots of the jump.

Fri Jul  1 16:32:58 1994  Richard Earnshaw (rwe11@cl.cam.ac.uk)

	* longlong.h: (arm umul_ppmm): Fix typos in last change.  Mark
	hard-coded registers with "%|".

Fri Jul  1 10:08:47 1994  Jason Merrill  (jason@deneb.cygnus.com)

	* toplev.c (compile_file): Pass through static consts and inlines
	multiple times in case they reference each other.

Fri Jul  1 07:41:19 1994  Torbjorn Granlund  (tege@tiny.cygnus.com)

	* longlong.h: Test for _AM29K and _IBMR2, not ___AM29K__
	and ___IBMR2__.
	(arm umul_ppmm): New definition.
	(clipper umul_ppmm, smul_ppmm, __umulsidi3): New definitions.
	(hppa count_leading_zeros): New definition.
	(i960 umul_ppmm, __umulsidi3): New definitions.
	(mc68000 umul_ppmm): Use %. before size suffixes.
	(mc88110 umul_ppmm, udiv_qrnnd): Rewrite,
	(mc88000): Get UMUL_TIME and UDIV_TIME right.
	(mips): Get UMUL_TIME right.
	(ns32000 umul_ppmm): New definition.
	(ns32000 udiv_qrnnd): Rename from bogus div_qrnnd, rewrite.
	(powerpc umul_ppmm, smul_ppmm): New definitions.
	(_IBMR2/powerpc add_ssaaaa, sub_ddmmss): Improve.
	(pyr umul_ppmm): Fix typo.
	(sparc add_ssaaaa, sub_ddmmss): Match constant 0 for all inputs.
	(vax sdiv_qrnnd): New definition.

	* expmed.c (expand_divmod): Put OP0 in a register when computing
	remainder, or when OP1 is constant.

Fri Jul  1 06:46:09 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* jump.c (jump_optimize): Don't convert if (foo) x++ into an
	add of an scc unless X has no side effects and can't trap.

	* c-parse.in (initelt): The equal sign is optional when
	positioning to a single element of an array.

	* c-typeck.c (push_init_level): If not at "unfilled" position,
	set constructor_incremental to 0; likewise for range.

	* xm-alpha.h: If GNUC, include alloca.h, else declare alloca.

	* m68k/mot3300.h (FUNCTION_EXTRA_EPILOGUE): New macro.

	* expmed.c (expand_divmod): Don't set REG_NOTES unless we generated
	a quotient.

Thu Jun 30 18:25:52 1994  David Edelsohn (edelsohn@npac.syr.edu)

	* gcc.c (do_spec_1, case 'P'): Don't add underscores to macros
	starting with '_[A-Z]'.

Thu Jun 30 18:16:36 1994  Will Athanasiou  (will@guardian.westford.ccur.com)

	* m68k.md (umulsi3_highpart, smulsi3_highpart): Fix constraint
	for operand 0 in define_insn.

Thu Jun 30 16:07:33 1994  Kaveh R. Ghazi  (ghazi@noc.rutgers.edu)

	* fixincludes: Put wrappers around <time.h> and <sys/time.h> to
	avoid multiple inclusion errors on m88k-tektronix-sysv3.

Thu Jun 30 12:08:48 1994  Kresten Krab Thorup  (krab@spiff.gnu.ai.mit.edu)

	* objc-act.c, objc/init.c (OBJC_VERSION): Incremented to 6.

	* objc/sendmsg.c (INVISIBLE_STRUCT_RETURN): New macro.
	(__objc_block_forward): Declare depending on the above.

	* objc/class.c (objc_next_class):  New function.
	* objc/objc-api.h (objc_next_class):  New function.

	* objc-act.c (get_proto_encoding, build_typed_selector_reference):
	New fucnctions. (UTAG_PROTOCOL): New define.
	(objc_selector_template, flag_typed_selectors): New variables.
	(objc_init): set flag_typed_selectors if -fgnu-runtime.
	(synth_module_prologue): Change declaration of
	_OBJC_SELECTOR_TABLE when flag_typed_selectors is non-null.
	(build_module_descriptor): Make sure the generated constructor
	function is declared public.
	(build_selector): Only cast to SEL when not doing typed selectors.
	(build_selector_translation_table): Rewrite initialization.
	(build_tmp_function_decl): Make up new name when called, since it
	may now be called multiple times.
	(hack_method_prototype): Use init_function_start to reinit args
	machinery.  Also set current_function_decl before calling
	assign_parms.
	(generate_protocols):  Don't generate encoding twice.
	(build_selector_template): New function.
	(build_method_list_template): Generate (void*)0 as first element,
	not (int)0.
	(build_message_expr): move the call to build_selector_reference 
	towards the end, where we have determined the function prototype.

	* objc/Object.h, objc/Object.m (read:, write:, streamVersion:):
	Un-disable for alpha.  (forward::, performv::): Declare and fix to
	return retval_t. 
	* objc/archive.c: Completely rewritten to handle 64 bit longs and
	pointers. 
	* objc/class.c (class_pose_as): Rewritten.
	* objc/encoding.c: use new ROUND macro for alignment rounding.
	* objc/init.c, objc/selector.c, objc/sendmsg.c: Rewritten to
	handle new selectors.

Thu Jun 30 07:49:50 1994  Richard Earnshaw (rwe11@cl.cam.ac.uk)

	* arm.h (INITIAL_ELIMINATION_OFFSET): Check frame_pointer_needed when
	eliminating the arg pointer into the stack pointer.

Thu Jun 30 06:25:50 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* c-common.c (c_build_type_variant): Remove last change; instead,
	copy TYPE if not in old obstack.

Wed Jun 29 21:51:52 1994  Jason Merrill  (jason@deneb.cygnus.com)

	* toplev.c (lang_options): Add -W{no-,}non-virtual-dtor.

Wed Jun 29 19:23:27 1994  David Mosberger-Tang  (davidm@piston.cs.arizona.edu)

	* final.c (end_final,profile_function): Profiling variables are
	size of pointer, not int.
	* alpha.h (LIB_SPEC): If -pg, add -lprof2.
	(STARTFILE_SPEC, {FUNCTION,BLOCK,FUNCTION_BLOCK}_PROFILER): New macros.

Wed Jun 29 15:52:45 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* loop.c (basic_induction_var, case REG): Allow previous
	insn to set a SUBREG of X.

	* alpha.c (alpha_sa_size): Round size to 16-byte boundary.
	(add_long_const): Add new arg, TEMP_REG.
	(output_{pro,epi}log): Rework to put save area between outgoing
	args and local variables.
	* alpha.h (FRAME_POINTER_REGNUM): Now register 63.
	(HARD_FRAME_POINTER_REGNUM): New macro.
	(CONDITIONAL_REGISTER_USAGE, REG_CLASS_CONTENTS, REGNO_REG_CLASS):
	Show register 63 is not an FP register.
	(REGHNO_OK_FOR_BASE_P, REG_OK_FOR_BASE_P, REGISTER_NAMES): Likewise.
	(ALPHA_ROUND): New macro.
	(STARTING_FRAME_OFFSET, ELIMINABLE_REGS, INITIAL_ELIMINATION_OFFSET):
	Modify to reflect save area between outgoing args and local vars.
	* alpha.md: Add new pattern for double-add when have
	reg + frame pointer.
	Slight changes to all such patterns and add define_splits for them.

	* global.c (global_alloc): Make a more accurate attempt to see
	if the frame pointer will be used.
	If it is, show HARD_FRAME_POINTER_REGNUM used if its not
	the same as FRAME_POINTER_REGNUM.
	* reload1.c (reload): Can't eliminate if frame pointer needed
	and TO is stack pointer.
	Spill HARD_FRAME_POINTER_REGNUM if not FRAME_POINTER_REGNUM
	and frame pointer is needed.
	(spill_hard_reg): If CANT_ELIMINATE, set regs_ever_live;
	no longer done by callers.	

	* a29k.md (movqi): Add missing `DONE'.

Wed Jun 29 15:44:18 1994  Doug Evans  (dje@canuck.cygnus.com)

	* sparc/sparc.h	(CPP_SPEC): Split up v9/non-v9 stuff.
	Move -Acpu and -Amachine from here.
	(CPP_PREDEFINES): To here.
	(NO_BUILTIN_PTRDIFF_TYPE): Undefine.
	(NO_BUILTIN_SIZE_TYPE): Likewise.
	(PTRDIFF_TYPE): Split up v9/non-v9 definitions.
	(SIZE_TYPE): Likewise.
	* sparc/sp64-elf: (PTRDIFF_TYPE): Remove dependence on POINTER_SIZE.
	(SIZE_TYPE): Likewise.

Wed Jun 29 15:28:17 1994  Michael Meissner  (meissner@osf.org)

	* cccp.c (collect_expansion): Always put 1 space after the macro
	expansion in ANSI mode to fix regression from June 24th.

Tue Jun 28 22:41:52 1994  Doug Evans  (dje@cygnus.com)

	* combine.c (simplify_set): Evaluate HAVE_conditional_move at runtime.

Tue Jun 28 20:27:08 1994  Torbjorn Granlund  (tege@adder.cygnus.com)

	* optab.c (expand_binop): Convert OP0 to mode for library calls.

	Changes to optimize division-by-constants, and make ceil and floor
	rounding work correctly:
	* expmed.c (expand_mult): Generalize to call synth_mult also
	for OP1 - 1.
	(ceil_log2): New function.
	(choose_multiplier): New function.
	(invert_mod2n): New function.
	(expand_mult_highpart_adjust): New function.
	(expand_mult_highpart): New function.
	(EXACT_POWER_OF_2_OR_ZERO_P): New macro.
	(expand_divmod): Almost completely rewritten.
	(expand_shift): Don't truncate immediate shift count, it doesn't work
	for types smaller than int.
	* expr.h (smul_highpart_optab, umul_highpart_optab): New variables.
	* genopinit.c (optabs): Add [us]mul_highpart_optab.
	* optabs.c (smul_highpart_optab, umul_highpart_optab): New variables.
	(expand_binop): Handle [us]mul_highpart_optab as commutative.
	(init_optabs): Initialize [us]mul_highpart_optab.
	* fold-const.c (div_and_round_double): Make it globally accessible.
	* a29k.md (smulsi3_highpart, umulsi3_highpart): New patterns.
	* alpha.md (umuldi3_highpart): New expander and matcher.
	* alpha.c (cint8_operand): New predicate.
	* m68k.md (umulsi3_highpart, const_umulsi3_highpart):
	New expander and matcher.
	(smulsi3_highpart, const_smulsi3_highpart): Likewise.

Tue Jun 28 13:42:10 1994  Jim Wilson  (wilson@cygnus.com)

	* sol2.h (CPP_SPEC): Handle -msupersparc.
	* sparc.c (cpu_type, sparc_cpu_type): Rename to arch_type and
	sparc_arch_type.  Fix all users.
	(supersparc_adjust_cost): New function.
	* sparc.h (cpu_type, sparc_cpu_type): Rename to arch_type and
	sparc_arch_type.
	(CPP_SPEC): Handle -msupersparc.
	(MASK_SUPERSPARC, TARGET_SUPERSPARC): New macros.
	(TARGET_SWITCHES): Add -msupersparc and -mcypress.
	(ADJUST_COST): New macro.
	* sparc.md (cpu attribute): Rename to arch attribute.  Add a new
	cpu attribute.  Fix all users.
	(type attribute): Add ialu, shift, imul, fpdivs, and fpdivd.
	Delete fpdiv.
	(function units): Add Cypress and Supersparc versions of each.
	(addsi3, subsi3, andsi3, iorsi3, xorsi3): Add ialu type attribute.
	(mulsi3): Add imul type attribute.
	(divtf3, divdf3): Use fpdivd not fpdiv type attribute.
	(divsf3); Use fpdivs not fpdiv type attribute.
	(ashlsi3, ashrsi3, lshrsi3): Add shift type attribute.

	* i960.md (andsi3+6): Replace bad clrbit pattern with two working
	ones.

Tue Jun 28 13:31:31 1994  Uwe Seimet  (seimet@iris1.chemie.uni-kl.de)

	* configure (m68k-atari-sysv4*): New configuration.
	* m68k/atari.h, m68k/xm-atari.h: New files.

Tue Jun 28 12:41:32 1994  Jeffrey A. Law  (law@snake.cs.utah.edu)

	* pa.md (define_split for (plus (reg) (large_constant))): Treat
	large_constant as signed.

Tue Jun 28 05:46:55 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* reload1.c (eliminate_regs_in_insn): When checking for moves
	and adds, use single_set.

	* reload1.c (reloads_conflict): Handle R1_TYPE of RELOAD_OTHER.

	* expr.c (do_jump, case BIT_AND_EXPR): Only narrow to a type
	that corresponds to a mode.

Tue Jun 28 05:41:29 1994  Will R. Athanasiou (will@westford.ccur.com)

	* rs6000.h (MEMORY_MOVE_COST): Make processor-dependent.
	* rs6000.md (movsf): Emit frsp if storing to memory and not PowerPC.
	(movsf matcher): Remove explicit frsp.
	(store sf with update): Likewise.
	* rs6000.c: Include ctype.h.

Tue Jun 28 05:40:44 1994  Mike Collison  (collison@chianti.sw.stratus.com)

	* real.c: Treat HFmode like SFmode, for now.

Mon Jun 27 19:16:49 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* optabs.c (expand_binop, multi-words shifts and rotates):
	Fix errors in last change.

Mon Jun 27 11:29:18 1994  Richard Earnshaw (rwe11@cl.cam.ac.uk)

	* arm.c: Include "expr.h".
	(arm_fpu): New variable.
	(arm_gen_movstrqi): Fix typo.
	* arm.h: (enum floating_point_type): New enumeration type.
	(arm_fpu): New declaration.
	* arm.md: (function_unit fpa): Add more accurate scheduling
	information.
	(all floating point patterns): Add more detailed instruction type
	information to attributes.
	* riscix.h: (STARTFILE_SPEC,SIZE_TYPE,PTRDIFF_TYPE): Fix typos.
	(ASM_FINAL_SPEC): Only reject -mbsd and -mxopen when -pedantic.

Sun Jun 26 05:37:26 1994  Pat Rankin  (rankin@eql.caltech.edu)

	* toplev.c (v_message_with_decl): Avoid fwrite for stderr; mixing
	it with fprintf and fputs can cause strange results under VMS.

Sat Jun 25 06:07:56 1994  Richard Earnshaw (rwe11@cl.cam.ac.uk)

	* combine.c (distribute_notes, case REG_DEAD): If a call uses a
	hard reg, then this is where it dies.

Fri Jun 24 19:09:33 1994  Chip Salzenberg  (chip@fin.uucp)

	* cccp.c (create_definition): Eliminate whitespace before and
	after macro definitions.

Fri Jun 24 16:19:27 1994  Philippe De Muyter  (phdm@info.ucl.ac.be)

	* c-decl.c (lang_decode_option): Set warn_bad_function_cast
	for -Wbad-function-cast.
	* c-typeck.c (build_c_cast): Issue a warning for non-matching cast
	from a function call (like malloc without proto).
	* c-tree.h: Declare warn_bad_function_cast.
	* toplev.c (lang_options): Add -W[no]-bad-function-cast.

Fri Jun 24 16:09:12 1994  Pat Rankin  (rankin@eql.caltech.edu)

	* vax.h (ASM_IDENTIFY_LANGUAGE): New macro.

Fri Jun 24 15:36:37 1994  Richard Earnshaw  (rwe11@cl.cam.ac.uk)

	* jump.c (jump_optimize): If we reverse "if (foo) bar else break;"
	and there follows a NOTE_INSN_LOOP_END, move the note before "bar".

	* arm.md (movstrsi): Delete.
	(movstrqi): New expand.
	* arm.h (arm_gen_movstrqi): New function.

Fri Jun 24 14:43:46 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* alpha.c (alpha_builtin_saveregs): Fix typo in computing value
	for __base.

	* vax.md (zero_extract patterns): Don't allow constants in
	the first operand of ZERO_EXTRACT since the recognizer
	function forces them to match the mode of the match_operand.

	* c-typeck.c (decl_constant_value): Test for const and
	not iterator.
	(default_conversion, digest_init): Remove redundant checks
	before calling decl_constant_value.
	(convert_for_assignment): See if RHS has a constant value.

	* m68k.md (ashrsi3, lshrsh3): Remove patterns using bfext[su].

	* reg-stack.c (goto_block_pat): Ignore undefined label.

Thu Jun 23 22:07:42 1994  Doug Evans  (dje@cygnus.com)

	* sparc/sp64-elf.h (LINK_SPEC): Fix typo.
	(PTRDIFF_TYPE): Likewise.

Thu Jun 23 19:15:36 1994  Jason Merrill  (jason@deneb.cygnus.com)

	* tree.h (TREE_SYMBOL_REFERENCED): New macro.
	* varasm.c (assemble_name): Set TREE_SYMBOL_REFERENCED on the
	identifier for `name'.
	* toplev.c (compile_file): Use TREE_SYMBOL_REFERENCED instead of
	TREE_USED and TREE_ADDRESSABLE where appropriate.

Thu Jun 23 19:06:05 1994  Randy Wright  (rwright@dhostwo.convex.com)

	* cse.c (simplify_unary_operation, case UNSIGNED_FLOAT): Add
	missing cast to unsigned.

Thu Jun 23 19:00:18 1994  David Edelsohn  (edelsohn@npac.syr.edu)

	* rs6000.md (fix_truncdfsi2, movsf, movdi): Use assign_stack_temp.
	(mulsidi3): Add earlyclobber constraint modifier to PowerPC
	version and !TARGET_POWERPC64 to final condition.

	* rs6000.h (CPP_PREDEFINES): Define _POWER (alias for _IBMR2).
	(CPP_SPEC): New macro.
	* powerpc.h (ASM_SPEC): Use PowerPC mode, not 601 mode.
	(CPP_SPEC): New macro.
	(TARGET_DEFAULT): Generate pure PowerPC code, not 601-specific.

Thu Jun 23 18:09:23 1994  Pat Rankin  (rankin@eql.caltech.edu)

	* vax.h (CPP_PREDEFINES): Add `__vax__'.
	* vax/vms.h (CPP_PREDEFINES): Add `__vax__', `__vms__', and `__VMS__';
	update __GNUC_MINOR__ to 6.

Thu Jun 23 17:59:41 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* toplev.c (compile_file): Don't try to write function if we
	didn't save insns for it.

	* reload.c (find_reloads): Don't rejecting non-const due to value
	of PREFERRED_RELOAD_CLASS if no regs were valid for alternative.

Thu Jun 23 17:45:55 1994  Matthias Pfaller  (leo@marco.de)

	* ns32k.c (output_move_double): If the dest is register pair and both
	regs are used in src address, use ADDR to compute src address, not
	ADDD, which throws away scaled index.

Thu Jun 23 17:40:06 1994  Craig Burley  (burley@gnu.ai.mit.edu)

	* c-decl.c (clear_binding_level): Add missing fields in initializer.
	(c_decode_option): Correct misspelling of -fno-dollars-in-identifiers.

Thu Jun 23 13:47:23 1994  Ian Lance Taylor  (ian@cygnus.com)

	* fixincludes: Fix return type of sbrk in <unistd.h> on Alpha
	OSF/1 V2.0.  Also, redirect grep errors to /dev/null in <assert.h>
	fix.

Thu Jun 23 12:08:23 1994  Richard Earnshaw (rwe11@cl.cam.ac.uk)

	* arm.c: Include tree.h.
	(const_ok_for_arm): Add fast return for 0 or just one non-zero bit.
	(const_ok_for_op, arm_split_constant): New functions.
	(arm_rtx_costs, reg_or_int_operand): New functions.
	(shift_operator): Accept ROTATERT.
	(multi_register_push): New function.
	(shift_op): Don't abort if a constant is outside the acceptable range,
	but convert the whole shift expression into something legal.  If the
	shift is zero, then return NULL.
	(output_return_instruction): Output a call to abort if the function is
	volatile.
	(arm_volatile_func): New function.
	(get_prologue_size): Remove all adjustments for insns that are now
	output as rtx.
	(output_func_prologue): Remove all code that outputs instructions,
	just print a few comments.
	(output_func_epilogue): Output a call to abort if a volatile function
	tries to return.
	(emit_multi_reg_push): New function.
	(arm_expand_prologue): New function.  Don't bother to push call-saved
	regs if we will never return.
	(arm_print_operand, case 'S'): If shift_op returns NULL, then no shift
	is required.
	* arm.h (TARGET_WHEN_DEBUGGING): Delete.
	(MODES_TIEABLE_P): All modes of the same class are tieable.
	(CONST_OK_FOR_LETTER_P): Add 'M' for constants valid in a shift.
	(FUNCTION_PROFILER): Don't call arm_increase_location.
	(INITIAL_ELIMINATION_OFFSET): Call saved regs are no-longer pushed for
	functions that don't return.
	(LEGITIMIZE_ADDRESS): Push constants that will never be legitimate -- 
	symbols and labels -- into registers.  Handle DImode better.
	(DEFAULT_SIGNED_CHAR): Use unsigned unless already defined.
	(RTX_COSTS): Call arm_rtx_costs.
	(ADDRESS_COST): Since most operations have the same rtx cost, make the
	more complex addresses cheaper.
	(PREDICATE_CODES): Add ROTATERT to shift_operator; and new predicates
	for reg_or_int_operand and multi_register_push.
	(DBX_CONTIN_LENGTH): Only define if not already done.
	(PRINT_OPERAND_ADDRESS): Let arm_print operand output the ", " for
	shifts.
	* arm.md (addsi3, subsi3, andsi3, iorsi3, ashlsi3, ashrsi3, lshrsi3,
	rotrsi3): Rewrite as expand patterns.
	(rotlsi3): New expand.
	(matchers, and split patterns for above): New.
	(all patterns with shifts): Let arm_print_operand output the ", "
	before a shift if it is needed.
	(zero_extendqihi2): Delete.
	(zero_extendqisi2): Expand to (and ...) if not memory.
	(movsi): Call arm_split_constant to generate a constant.
	(movqi): Only force a MEM into a register if not reloading.
	(movsf, movdf): If loading a non-immediate floating point value, or
	loading and floating point immediate into integer regs, push the
	constant straight into the pool.
	(movdf): Get rid of the scratch register.
	(reload_outdf): Rewrite to expand to the two required insns.
	(matcher for movdf): Remove alternative that used scratch register for
	storing.
	(movxf): rewrite as expand.
	(matcher for movxf): Recognize even when XFmode code is disabled, so
	that prologue insns can be generated.
	(Matcher for reversed conditional jump): Don't match if the mode of the
	CC register is not reversible.
	(prologue): New expand.
	(matcher for multi_register_push insn): New.
	* riscix.h: Delete some dead code.
	(STARTFILE_SPEC): Look in the correct places for start files.
	(LIB_SPEC): Define.
	(LINK_SPEC): Define.
	(TARGET_WHEN_DEBUGGING): Delete.
	(DEFAULT_SIGNED_CHAR): Set to unsigned.
	(SIZE_TYPE, PTRDIFF_TYPE, TARGET_EDOM): Define.
	* rix-gas.h (DBX_CONTIN_LENGTH): Set to 80.
	(DEFAULT_GDB_EXTENSIONS, DBX_NO_XREFS): Don't try to pander to dbx, it
	is just to broken to use.

Wed Jun 22 20:13:03 1994  Will Athanasiou  (will@westford.ccur.com)

	* configure (m68k-ccur-rtu): New configuration.
	* config.sub (m68k-ccur): New system.
	* protoize.c: Include <dirent.h>, not <sys/dir.h> on Concurrent.
	* ccur-GAS.h, x-ccur: New files.

Wed Jun 22 18:49:17 1994  Walter Misar  (misar@rbg.informatik.th-darmstadt.de)

	* m68k/hp320.h (LINK_SPEC): New macro.

Wed Jun 22 18:43:51 1994  Ian Lance Taylor  (ian@cygnus.com)

	* configure: For target alpha-*-*, if using gas, set
	target_cpu_default to 4.
	* config/alpha/alpha.h (TARGET_SWITCHES): Include
	TARGET_CPU_DEFAULT in default value.
	(TARGET_CPU_DEFAULT): Define as 0 if not already defined.
	(ASM_FINAL_SPEC): Include TARGET_CPU_DEFAULT in test for which
	version to define.

Wed Jun 22 18:15:41 1994  Richard Kenner  (kenner@vlsi1.ultra.nyu.edu)

	* loop.c (strength_reduce): When replacing DEST_ADDR givs, make
	sure resulting insn is valid.

	* optabs.c (expand_binop): New variable next_methods; pass to
	most recursive calls when trying to avoid libcalls.
	Always check for a return value of zero in recursive calls.
	(expand_float): Ensure TARGET has proper mode.
	Pass OPTAB_LIB_WIDEN to expand_binop calls.

Tue Jun 21 14:35:38 1994  Doug Evans  (dje@cygnus.com)

	* cccp.c (skip_to_end_of_comment): Catch unterminated comments.

Sat Jun 18 17:49:41 1994  Jason Merrill  (jason@deneb.cygnus.com)

	* fixproto: Move hacking of assert.h from here.
